-- CLASS ngSituacao
CREATE TABLE SITUACAO (
ID_SITUACAO                                       INT PRIMARY KEY,
CODIGO                                            VARCHAR(5) NOT NULL,
DESCRICAO                                         VARCHAR(250) NOT NULL
);

INSERT INTO SITUACAO
VALUES (1, '1', 'Disponvel');

INSERT INTO SITUACAO
VALUES (2, '2', 'Emprestado');

INSERT INTO SITUACAO
VALUES (3, '3', 'Reservado');

INSERT INTO SITUACAO
VALUES (4, '4', 'Perdido');

-- CLASS ngUsuario
CREATE TABLE USUARIO (
ID_USUARIO                                        INT PRIMARY KEY,
NOME                                              VARCHAR(200) NOT NULL,
CPF                                               VARCHAR(11) NOT NULL,
DATA_NASCIMENTO                                   DATETIME NOT NULL
);

-- CLASS ngLivro
CREATE TABLE LIVRO (
ID_LIVRO                                          INT PRIMARY KEY,
ISBN                                              VARCHAR(15) NOT NULL,
TITULO                                            VARCHAR(200) NOT NULL,
EDICAO                                            VARCHAR(15) NOT NULL
);

-- CLASS ngExemplar
CREATE TABLE EXEMPLAR (
ID_EXEMPLAR                                       INT PRIMARY KEY,
CODIGO                                            VARCHAR(20) NOT NULL,
ID_SITUACAO                                       INT NOT NULL,
ID_LIVRO                                          INT NOT NULL
);

-- CLASS ngExemplar
-- RELATION ngSituacao(0..*) <----> (1..1)ngExemplar
ALTER TABLE EXEMPLAR ADD CONSTRAINT F2998ID_SITUACAO FOREIGN KEY (ID_SITUACAO) REFERENCES SITUACAO(ID_SITUACAO);

CREATE INDEX I2998ID_SITUACAO ON EXEMPLAR (ID_SITUACAO);

-- RELATION ngLivro(0..*) <----> (1..1)ngExemplar
ALTER TABLE EXEMPLAR ADD CONSTRAINT F2998ID_LIVRO FOREIGN KEY (ID_LIVRO) REFERENCES LIVRO(ID_LIVRO);

CREATE INDEX I2998ID_LIVRO ON EXEMPLAR (ID_LIVRO);

-- CLASS ngEmprestimo
CREATE TABLE EMPRESTIMO (
ID_EMPRESTIMO                                     INT PRIMARY KEY,
DATA_INICIO                                       DATETIME NOT NULL,
DATA_DEVOLUCAO_PREVISTA                           DATETIME NOT NULL,
ID_USUARIO                                        INT NOT NULL,
ID_EXEMPLAR                                       INT NOT NULL
);

-- CLASS ngEmprestimo
-- RELATION ngUsuario(0..*) <----> (1..1)ngEmprestimo
ALTER TABLE EMPRESTIMO ADD CONSTRAINT F3002ID_USUARIO FOREIGN KEY (ID_USUARIO) REFERENCES USUARIO(ID_USUARIO);

CREATE INDEX I3002ID_USUARIO ON EMPRESTIMO (ID_USUARIO);

-- RELATION ngExemplar(0..*) <----> (1..1)ngEmprestimo
ALTER TABLE EMPRESTIMO ADD CONSTRAINT F3002ID_EXEMPLAR FOREIGN KEY (ID_EXEMPLAR) REFERENCES EXEMPLAR(ID_EXEMPLAR);

CREATE INDEX I3002ID_EXEMPLAR ON EMPRESTIMO (ID_EXEMPLAR);