unit nguEmprestimo;


interface

uses
  acuframework, utumessage;

type
  ngEmprestimo = class(acPersistentObject)
  public
    procedure toXML(piField: utField);
  private
    FDataInicio: acDateTime;
    FDataDevolucaoPrevista: acDateTime;
    FDataDevolucao: acDateTime;
    fExemplar: acRelationPartnerShip;
    fUsuario: acRelationPartnerShip;
  published
    property DataInicio: acDateTime read FDataInicio write FDataInicio;
    property DataDevolucaoPrevista: acDateTime read FDataDevolucaoPrevista write FDataDevolucaoPrevista;
    property DataDevolucao: acDateTime read FDataDevolucao write FDataDevolucao;
    property Exemplar: acRelationPartnerShip read fExemplar write fExemplar;
    property Usuario: acRelationPartnerShip read fUsuario write fUsuario;
  end;

implementation

procedure ngEmprestimo.toXML(piField: utField);
begin
  piField.AddAttribute('OID').AsString := Self.IDO.AsString;
  piField.AddAttribute('DataInicio').AsDate := Self.DataInicio.Value;
  piField.AddAttribute('DataDevolucaoPrevista').AsDate := Self.DataDevolucaoPrevista.Value;
  piField.AddAttribute('DataDevolucao').AsDate := Self.DataDevolucao.Value;
end;

initialization

PersistenceManager.RegisterClass(ngEmprestimo);

end.

