unit utuEmprestimoOQL;

interface

uses acuOQL, acuFramework;

type

  IContarEmprestimosExemplar = interface(IDataSetOQLQuery)
    function Param_oid: acOQLParamInt;
  end;

  IContarEmprestimosLivro = interface(IDataSetOQLQuery)
    function Param_oid: acOQLParamInt;
  end;

  IObterEmprestimos = interface(IOQLQuery)
    function Param_oid: acOQLParamInt;
    function Param_nome: acOQLParamString;
    function Param_cpf: acOQLParamString;
  end;

  IObterExemplares = interface(IOQLQuery)
    function Param_titulo: acOQLParamString;
    function Param_isbn: acOQLParamString;
    function Param_codigo: acOQLParamString;
  end;

  IObterLivros = interface(IOQLQuery)
    function Param_titulo: acOQLParamString;
    function Param_isbn: acOQLParamString;
    function Param_edicao: acOQLParamString;
  end;

  IObterUsuarios = interface(IOQLQuery)
    function Param_nome: acOQLParamString;
    function Param_cpf: acOQLParamString;
  end;

  utEmprestimoOQL = class
    class function ContarEmprestimosExemplar(piSessao: acPersistenceSession): IContarEmprestimosExemplar;
    class function ContarEmprestimosLivro(piSessao: acPersistenceSession): IContarEmprestimosLivro;
    class function ObterEmprestimos(piSessao: acPersistenceSession): IObterEmprestimos;
    class function ObterExemplares(piSessao: acPersistenceSession): IObterExemplares;
    class function ObterLivros(piSessao: acPersistenceSession): IObterLivros;
    class function ObterUsuarios(piSessao: acPersistenceSession): IObterUsuarios;
  end;

implementation

type

  TContarEmprestimosExemplar = class(acDataSetOQLQuery, IContarEmprestimosExemplar)
    function Param_oid: acOQLParamInt;
  end;

  TContarEmprestimosLivro = class(acDataSetOQLQuery, IContarEmprestimosLivro)
    function Param_oid: acOQLParamInt;
  end;

  TObterEmprestimos = class(acOQLQuery, IObterEmprestimos)
    function Param_oid: acOQLParamInt;
    function Param_nome: acOQLParamString;
    function Param_cpf: acOQLParamString;
  end;

  TObterExemplares = class(acOQLQuery, IObterExemplares)
    function Param_titulo: acOQLParamString;
    function Param_isbn: acOQLParamString;
    function Param_codigo: acOQLParamString;
  end;

  TObterLivros = class(acOQLQuery, IObterLivros)
    function Param_titulo: acOQLParamString;
    function Param_isbn: acOQLParamString;
    function Param_edicao: acOQLParamString;
  end;

  TObterUsuarios = class(acOQLQuery, IObterUsuarios)
    function Param_nome: acOQLParamString;
    function Param_cpf: acOQLParamString;
  end;

{ TContarEmprestimosExemplar }

function TContarEmprestimosExemplar.Param_oid: acOQLParamInt;
begin
  result := acOQLParamInt(Self.ParamByName('oid'));
end;

{ TContarEmprestimosLivro }

function TContarEmprestimosLivro.Param_oid: acOQLParamInt;
begin
  result := acOQLParamInt(Self.ParamByName('oid'));
end;

{ TObterEmprestimos }

function TObterEmprestimos.Param_oid: acOQLParamInt;
begin
  result := acOQLParamInt(Self.ParamByName('oid'));
end;

function TObterEmprestimos.Param_nome: acOQLParamString;
begin
  result := acOQLParamString(Self.ParamByName('nome'));
end;

function TObterEmprestimos.Param_cpf: acOQLParamString;
begin
  result := acOQLParamString(Self.ParamByName('cpf'));
end;

{ TObterExemplares }

function TObterExemplares.Param_titulo: acOQLParamString;
begin
  result := acOQLParamString(Self.ParamByName('titulo'));
end;

function TObterExemplares.Param_isbn: acOQLParamString;
begin
  result := acOQLParamString(Self.ParamByName('isbn'));
end;

function TObterExemplares.Param_codigo: acOQLParamString;
begin
  result := acOQLParamString(Self.ParamByName('codigo'));
end;

{ TObterLivros }

function TObterLivros.Param_titulo: acOQLParamString;
begin
  result := acOQLParamString(Self.ParamByName('titulo'));
end;

function TObterLivros.Param_isbn: acOQLParamString;
begin
  result := acOQLParamString(Self.ParamByName('isbn'));
end;

function TObterLivros.Param_edicao: acOQLParamString;
begin
  result := acOQLParamString(Self.ParamByName('edicao'));
end;

{ TObterUsuarios }

function TObterUsuarios.Param_nome: acOQLParamString;
begin
  result := acOQLParamString(Self.ParamByName('nome'));
end;

function TObterUsuarios.Param_cpf: acOQLParamString;
begin
  result := acOQLParamString(Self.ParamByName('cpf'));
end;

{ utOQLs }

class function utEmprestimoOQL.ContarEmprestimosExemplar(piSessao: acPersistenceSession): IContarEmprestimosExemplar;
begin
  result := TContarEmprestimosExemplar.Create(pisessao,
'SELECT count(*) as qnt' + #13#10 +
'FROM ngExemplar,' + #13#10 +
'     ngExemplar.Emprestimos' + #13#10 +
'WHERE ngExemplar.OID = ?oid:acInt');
end;

class function utEmprestimoOQL.ContarEmprestimosLivro(piSessao: acPersistenceSession): IContarEmprestimosLivro;
begin
  result := TContarEmprestimosLivro.Create(pisessao,
'SELECT count(*) as qnt' + #13#10 +
'FROM ngLivro,' + #13#10 +
'     ngLivro.Exemplares,' + #13#10 +
'     ngLivro.Exemplares.Emprestimos' + #13#10 +
'WHERE ngLivro.OID = ?oid:acInt');
end;

class function utEmprestimoOQL.ObterEmprestimos(piSessao: acPersistenceSession): IObterEmprestimos;
begin
  result := TObterEmprestimos.Create(pisessao,
'SELECT ngEmprestimo' + #13#10 +
'FROM ngEmprestimo' + #13#10 +
'WHERE (ngEmprestimo.Usuario.OID = ?oid:acInt OR ?oid:acInt IS NULL)' + #13#10 +
'	AND(ngEmprestimo.Usuario.Nome LIKE ''%''+?nome:acString+''%'' OR ?nome:acString IS NULL)' + #13#10 +
'	AND (ngEmprestimo.Usuario.CPF = ?cpf:acString OR ?cpf:acString IS NULL)');
end;

class function utEmprestimoOQL.ObterExemplares(piSessao: acPersistenceSession): IObterExemplares;
begin
  result := TObterExemplares.Create(pisessao,
'SELECT ngExemplar' + #13#10 +
'FROM ngExemplar,' + #13#10 +
'     ngExemplar.Livro' + #13#10 +
'WHERE (ngExemplar.Livro.Titulo LIKE ''%''+?titulo:acString+''%'' OR ?titulo:acString IS NULL)' + #13#10 +
'        AND (ngExemplar.Livro.ISBN = ?isbn:acString OR ?isbn:acString IS NULL)' + #13#10 +
'	AND (ngExemplar.Codigo = ?codigo:acString OR ?codigo:acString IS NULL)' + #13#10 +
'ORDER BY ngExemplar.Livro.OID ASC');
end;

class function utEmprestimoOQL.ObterLivros(piSessao: acPersistenceSession): IObterLivros;
begin
  result := TObterLivros.Create(pisessao,
'SELECT ngLivro' + #13#10 +
'FROM ngLivro' + #13#10 +
'WHERE (ngLivro.Titulo LIKE ''%''+?titulo:acString+''%'' OR ?titulo:acString IS NULL)' + #13#10 +
'        AND (ngLivro.ISBN = ?isbn:acString OR ?isbn:acString IS NULL)' + #13#10 +
'	AND (ngLivro.Edicao = ?edicao:acString OR ?edicao:acString IS NULL)' + #13#10 +
'ORDER BY ngLivro.Titulo ASC');
end;

class function utEmprestimoOQL.ObterUsuarios(piSessao: acPersistenceSession): IObterUsuarios;
begin
  result := TObterUsuarios.Create(pisessao,
'SELECT ngUsuario' + #13#10 +
'FROM ngUsuario' + #13#10 +
'WHERE (ngUsuario.Nome LIKE ''%''+?nome:acString+''%'' OR ?nome:acString IS NULL)' + #13#10 +
'	AND (ngUsuario.CPF = ?cpf:acString OR ?cpf:acString IS NULL)');
end;

end.
