unit acuRegisterModelMappings;


interface

uses
  acuframework, classes;

procedure RegisterModelMappings(piMetaModel: acMetaModel);
implementation

uses
  acuRepositorySQL, utuStateMachine;

procedure RegisterClassTickets1(piMetaModel: acMetaModel);
var
  lClassMapTicket: acClassTicket;
  lClassToDBMapTicket: acClassToDBMapTicket;
  lDBIntIdoMapTicket: acDBIdoMapTicket;
  prop: acAttributeTicket;
begin
  
    lClassMapTicket    := piMetaModel.NewClassRegisterTicket('362','ngAuditEvent','acPersistentObject', acOIDInt);
    lClassMapTicket.AuditDescription := '';
  
    lDBIntIdoMapTicket := acDBIntIdoMapTicket.Create('SISCIDAUDI');
    lClassToDBMapTicket := (piMetaModel.DefaultMetaModelPersistenceMap as acMetaModelPersistenceMapSql).NewClassToDBMapRegisterTicket('362', lClassMapTicket, lDBIntIdoMapTicket) ;
    lClassToDBMapTicket.TableName := 'SISCTAUDIT';
  // registrando os atributos da classe
    prop := lClassMapTicket.NewAttributeTicket('TransactionId', 'acString', pvPersistent, False);
    prop.FixSize := 0;
    prop.VarSize := 38;
    prop.Mandatory := True;
    prop.DBType := 'varchar';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'SISCTRANID';
    prop := lClassMapTicket.NewAttributeTicket('Date', 'acDateTime', pvPersistent, False);
    prop.FixSize := 0;
    prop.VarSize := 0;
    prop.Mandatory := True;
    prop.DBType := 'datetime';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'SISCDATETI';
    prop := lClassMapTicket.NewAttributeTicket('UserName', 'acString', pvPersistent, False);
    prop.FixSize := 0;
    prop.VarSize := 30;
    prop.Mandatory := True;
    prop.DBType := 'varchar';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'SISCUSERNA';
    prop := lClassMapTicket.NewAttributeTicket('EventType', 'acString', pvPersistent, False);
    prop.FixSize := 0;
    prop.VarSize := 10;
    prop.Mandatory := True;
    prop.DBType := 'varchar';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'SISCEVNTYP';
    prop := lClassMapTicket.NewAttributeTicket('UseCaseName', 'acString', pvPersistent, False);
    prop.FixSize := 0;
    prop.VarSize := 100;
    prop.Mandatory := True;
    prop.DBType := 'varchar';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'SISCUCNAME';
    prop := lClassMapTicket.NewAttributeTicket('ObjectClassName', 'acString', pvPersistent, False);
    prop.FixSize := 0;
    prop.VarSize := 100;
    prop.Mandatory := True;
    prop.DBType := 'varchar';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'SISCCLNAME';
    prop := lClassMapTicket.NewAttributeTicket('ObjectOID', 'acString', pvPersistent, False);
    prop.FixSize := 0;
    prop.VarSize := 40;
    prop.Mandatory := True;
    prop.DBType := 'varchar';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'SISCOBJOID';
    prop := lClassMapTicket.NewAttributeTicket('Context', 'acString', pvPersistent, False);
    prop.FixSize := 0;
    prop.VarSize := 255;
    prop.Mandatory := False;
    prop.DBType := 'VARCHAR';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'SISCCONTEX';
  
    lClassMapTicket    := piMetaModel.NewClassRegisterTicket('363','ngAuditEventData','acPersistentObject', acOIDInt);
    lClassMapTicket.AuditDescription := '';
  
    lDBIntIdoMapTicket := acDBIntIdoMapTicket.Create('SISDIDEVND');
    lClassToDBMapTicket := (piMetaModel.DefaultMetaModelPersistenceMap as acMetaModelPersistenceMapSql).NewClassToDBMapRegisterTicket('363', lClassMapTicket, lDBIntIdoMapTicket) ;
    lClassToDBMapTicket.TableName := 'SISDTEVNDA';
  // registrando os atributos da classe
    prop := lClassMapTicket.NewAttributeTicket('DataName', 'acString', pvPersistent, False);
    prop.FixSize := 0;
    prop.VarSize := 100;
    prop.Mandatory := True;
    prop.DBType := 'varchar';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'SISDDATNAM';
    prop := lClassMapTicket.NewAttributeTicket('OldValue', 'acString', pvPersistent, False);
    prop.FixSize := 0;
    prop.VarSize := 4000;
    prop.Mandatory := False;
    prop.DBType := 'varchar';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'SISDOLDVAL';
    prop := lClassMapTicket.NewAttributeTicket('NewValue', 'acString', pvPersistent, False);
    prop.FixSize := 0;
    prop.VarSize := 4000;
    prop.Mandatory := False;
    prop.DBType := 'varchar';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'SISDNEWVAL';
  
    lClassMapTicket    := piMetaModel.NewClassRegisterTicket('278','NGBusinessEvent','acPersistentObject', acOIDInt);
    lClassMapTicket.AuditDescription := '';
  
    lDBIntIdoMapTicket := acDBIntIdoMapTicket.Create('INTAIDBUEV');
    lClassToDBMapTicket := (piMetaModel.DefaultMetaModelPersistenceMap as acMetaModelPersistenceMapSql).NewClassToDBMapRegisterTicket('278', lClassMapTicket, lDBIntIdoMapTicket) ;
    lClassToDBMapTicket.TableName := 'INTATBUEVN';
  // registrando os atributos da classe
    prop := lClassMapTicket.NewAttributeTicket('Data', 'acText', pvPersistent, False);
    prop.FixSize := 0;
    prop.VarSize := 0;
    prop.Mandatory := True;
    prop.DBType := 'TEXT';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'INTADATAAA';
    prop := lClassMapTicket.NewAttributeTicket('PublishDateTime', 'acDateTime', pvPersistent, False);
    prop.FixSize := 0;
    prop.VarSize := 0;
    prop.Mandatory := True;
    prop.DBType := 'DATETIME';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'INTAPUBLDT';
  
    lClassMapTicket    := piMetaModel.NewClassRegisterTicket('744','NGBusinessEventDistributed','acPersistentObject', acOIDInt);
    lClassMapTicket.AuditDescription := '';
  
    lDBIntIdoMapTicket := acDBIntIdoMapTicket.Create('INTLIDBUED');
    lClassToDBMapTicket := (piMetaModel.DefaultMetaModelPersistenceMap as acMetaModelPersistenceMapSql).NewClassToDBMapRegisterTicket('744', lClassMapTicket, lDBIntIdoMapTicket) ;
    lClassToDBMapTicket.TableName := 'INTLTBUEVD';
  // registrando os atributos da classe
    prop := lClassMapTicket.NewAttributeTicket('DistributedDateTime', 'acDateTime', pvPersistent, False);
    prop.FixSize := 0;
    prop.VarSize := 0;
    prop.Mandatory := True;
    prop.DBType := 'DATETIME';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'INTLDISTDT';
  
    lClassMapTicket    := piMetaModel.NewClassRegisterTicket('279','NGBusinessEventSubscriber','acPersistentObject', acOIDInt);
    lClassMapTicket.AuditDescription := '';
  
    lDBIntIdoMapTicket := acDBIntIdoMapTicket.Create('INTBIDSUBS');
    lClassToDBMapTicket := (piMetaModel.DefaultMetaModelPersistenceMap as acMetaModelPersistenceMapSql).NewClassToDBMapRegisterTicket('279', lClassMapTicket, lDBIntIdoMapTicket) ;
    lClassToDBMapTicket.TableName := 'INTBTSUBSC';
  // registrando os atributos da classe
    prop := lClassMapTicket.NewAttributeTicket('code', 'acInt', pvPersistent, False);
    prop.FixSize := 0;
    prop.VarSize := 0;
    prop.Mandatory := True;
    prop.DBType := 'INT';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'INTBCODEE';
    prop := lClassMapTicket.NewAttributeTicket('Name', 'acString', pvPersistent, False);
    prop.FixSize := 0;
    prop.VarSize := 50;
    prop.Mandatory := True;
    prop.DBType := 'VARCHAR';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'INTBNAMEE';
  
    lClassMapTicket    := piMetaModel.NewClassRegisterTicket('743','NGBusinessEventSubscriberError','acPersistentObject', acOIDInt);
    lClassMapTicket.AuditDescription := '';
  
    lDBIntIdoMapTicket := acDBIntIdoMapTicket.Create('INTJIDSBER');
    lClassToDBMapTicket := (piMetaModel.DefaultMetaModelPersistenceMap as acMetaModelPersistenceMapSql).NewClassToDBMapRegisterTicket('743', lClassMapTicket, lDBIntIdoMapTicket) ;
    lClassToDBMapTicket.TableName := 'INTJTSBERR';
  // registrando os atributos da classe
    prop := lClassMapTicket.NewAttributeTicket('ErrorDate', 'acDateTime', pvPersistent, False);
    prop.FixSize := 8;
    prop.VarSize := 0;
    prop.Mandatory := True;
    prop.DBType := 'DATETIME';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'INTJDTERRO';
    prop := lClassMapTicket.NewAttributeTicket('Description', 'acText', pvPersistent, False);
    prop.FixSize := 0;
    prop.VarSize := 0;
    prop.Mandatory := True;
    prop.DBType := 'TEXT';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'INTJDESCRI';
  
    lClassMapTicket    := piMetaModel.NewClassRegisterTicket('280','NGBusinessEventType','acPersistentObject', acOIDInt);
    lClassMapTicket.AuditDescription := '';
  
    lDBIntIdoMapTicket := acDBIntIdoMapTicket.Create('INTCIDEVNT');
    lClassToDBMapTicket := (piMetaModel.DefaultMetaModelPersistenceMap as acMetaModelPersistenceMapSql).NewClassToDBMapRegisterTicket('280', lClassMapTicket, lDBIntIdoMapTicket) ;
    lClassToDBMapTicket.TableName := 'INTCTEVNTP';
  // registrando os atributos da classe
    prop := lClassMapTicket.NewAttributeTicket('Code', 'acInt', pvPersistent, False);
    prop.FixSize := 0;
    prop.VarSize := 0;
    prop.Mandatory := True;
    prop.DBType := 'INT';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'INTCCODEEE';
    prop := lClassMapTicket.NewAttributeTicket('Name', 'acString', pvPersistent, False);
    prop.FixSize := 0;
    prop.VarSize := 50;
    prop.Mandatory := True;
    prop.DBType := 'VARCHAR';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'INTCNAMEEE';
  
    lClassMapTicket    := piMetaModel.NewClassRegisterTicket('742','NGBusinessSubscriberNotifierEventualTimeWindow','acPersistentObject', acOIDInt);
    lClassMapTicket.AuditDescription := '';
  
    lDBIntIdoMapTicket := acDBIntIdoMapTicket.Create('INTHIDETMW');
    lClassToDBMapTicket := (piMetaModel.DefaultMetaModelPersistenceMap as acMetaModelPersistenceMapSql).NewClassToDBMapRegisterTicket('742', lClassMapTicket, lDBIntIdoMapTicket) ;
    lClassToDBMapTicket.TableName := 'INTHTETMWI';
  // registrando os atributos da classe
    prop := lClassMapTicket.NewAttributeTicket('ValidAt', 'acDateTime', pvPersistent, False);
    prop.FixSize := 8;
    prop.VarSize := 0;
    prop.Mandatory := True;
    prop.DBType := 'DATETIME';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'INTHVDATTT';
    prop := lClassMapTicket.NewAttributeTicket('StartAt', 'acInt', pvPersistent, False);
    prop.FixSize := 4;
    prop.VarSize := 0;
    prop.Mandatory := True;
    prop.DBType := 'INT';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'INTHSTARTA';
    prop := lClassMapTicket.NewAttributeTicket('EndAt', 'acInt', pvPersistent, False);
    prop.FixSize := 4;
    prop.VarSize := 0;
    prop.Mandatory := True;
    prop.DBType := 'INT';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'INTHENDATT';
    prop := lClassMapTicket.NewAttributeTicket('Code', 'acString', pvPersistent, False);
    prop.FixSize := 0;
    prop.VarSize := 20;
    prop.Mandatory := True;
    prop.DBType := 'VARCHAR';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'INTHCODEEE';
    prop := lClassMapTicket.NewAttributeTicket('ClosedAt', 'acInt', pvPersistent, False);
    prop.FixSize := 4;
    prop.VarSize := 0;
    prop.Mandatory := False;
    prop.DBType := 'INT';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'INTHCLOSAT';
    prop := lClassMapTicket.NewAttributeTicket('OpenedAt', 'acInt', pvPersistent, False);
    prop.FixSize := 4;
    prop.VarSize := 0;
    prop.Mandatory := False;
    prop.DBType := 'INT';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'INTHOPENAT';
  
    lClassMapTicket    := piMetaModel.NewClassRegisterTicket('740','NGBusinessSubscriberNotifierTimeGrid','acPersistentObject', acOIDInt);
    lClassMapTicket.AuditDescription := '';
  
    lDBIntIdoMapTicket := acDBIntIdoMapTicket.Create('INTFIDTMGR');
    lClassToDBMapTicket := (piMetaModel.DefaultMetaModelPersistenceMap as acMetaModelPersistenceMapSql).NewClassToDBMapRegisterTicket('740', lClassMapTicket, lDBIntIdoMapTicket) ;
    lClassToDBMapTicket.TableName := 'INTFTTMGRD';
  // registrando os atributos da classe
    prop := lClassMapTicket.NewAttributeTicket('ValidFrom', 'acDateTime', pvPersistent, False);
    prop.FixSize := 8;
    prop.VarSize := 0;
    prop.Mandatory := True;
    prop.DBType := 'DATETIME';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'INTFVDFROM';
    prop := lClassMapTicket.NewAttributeTicket('ValidTo', 'acDateTime', pvPersistent, False);
    prop.FixSize := 8;
    prop.VarSize := 0;
    prop.Mandatory := False;
    prop.DBType := 'DATETIME';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'INTFVDTOOO';
  
    lClassMapTicket    := piMetaModel.NewClassRegisterTicket('741','NGBusinessSubscriberNotifierTimeWindow','acPersistentObject', acOIDInt);
    lClassMapTicket.AuditDescription := '';
  
    lDBIntIdoMapTicket := acDBIntIdoMapTicket.Create('INTGIDTMWI');
    lClassToDBMapTicket := (piMetaModel.DefaultMetaModelPersistenceMap as acMetaModelPersistenceMapSql).NewClassToDBMapRegisterTicket('741', lClassMapTicket, lDBIntIdoMapTicket) ;
    lClassToDBMapTicket.TableName := 'INTGTTMWIN';
  // registrando os atributos da classe
    prop := lClassMapTicket.NewAttributeTicket('StartAt', 'acInt', pvPersistent, False);
    prop.FixSize := 4;
    prop.VarSize := 0;
    prop.Mandatory := True;
    prop.DBType := 'INT';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'INTGSTARTA';
    prop := lClassMapTicket.NewAttributeTicket('EndAt', 'acInt', pvPersistent, False);
    prop.FixSize := 4;
    prop.VarSize := 0;
    prop.Mandatory := True;
    prop.DBType := 'INT';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'INTGENDATT';
    prop := lClassMapTicket.NewAttributeTicket('Code', 'acString', pvPersistent, False);
    prop.FixSize := 0;
    prop.VarSize := 20;
    prop.Mandatory := True;
    prop.DBType := 'VARCHAR';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'INTGCODEEE';
    prop := lClassMapTicket.NewAttributeTicket('OpenedAt', 'acInt', pvPersistent, False);
    prop.FixSize := 4;
    prop.VarSize := 0;
    prop.Mandatory := False;
    prop.DBType := 'INT';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'INTGOPENAT';
    prop := lClassMapTicket.NewAttributeTicket('ClosedAt', 'acInt', pvPersistent, False);
    prop.FixSize := 4;
    prop.VarSize := 0;
    prop.Mandatory := False;
    prop.DBType := 'INT';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'INTGCLOSAT';
  
    lClassMapTicket    := piMetaModel.NewClassRegisterTicket('-3','ngCategory','acPersistentObject', acOIDInt);
    lClassMapTicket.AuditDescription := '';
  
    lDBIntIdoMapTicket := acDBIntIdoMapTicket.Create('IESDIDCATE');
    lClassToDBMapTicket := (piMetaModel.DefaultMetaModelPersistenceMap as acMetaModelPersistenceMapSql).NewClassToDBMapRegisterTicket('-3', lClassMapTicket, lDBIntIdoMapTicket) ;
    lClassToDBMapTicket.TableName := 'IESDTCATEG';
  // registrando os atributos da classe
    prop := lClassMapTicket.NewAttributeTicket('Name', 'acString', pvPersistent, False);
    prop.FixSize := 0;
    prop.VarSize := 20;
    prop.Mandatory := False;
    prop.DBType := 'varchar';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'IESDNMCATE';
    prop := lClassMapTicket.NewAttributeTicket('Code', 'acInt', pvPersistent, False);
    prop.FixSize := 10;
    prop.VarSize := 0;
    prop.Mandatory := True;
    prop.DBType := 'int';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'IESDCDCATE';
    prop := lClassMapTicket.NewAttributeTicket('Situation', 'acString', pvPersistent, False);
    prop.FixSize := 1;
    prop.VarSize := 0;
    prop.Mandatory := True;
    prop.DBType := 'CHAR';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'IESDCDSITU';
  
    lClassMapTicket    := piMetaModel.NewClassRegisterTicket('3002','ngEmprestimo','acPersistentObject', acOIDInt);
    lClassMapTicket.AuditDescription := '';
  
    lDBIntIdoMapTicket := acDBIntIdoMapTicket.Create('ID_EMPRESTIMO');
    lClassToDBMapTicket := (piMetaModel.DefaultMetaModelPersistenceMap as acMetaModelPersistenceMapSql).NewClassToDBMapRegisterTicket('3002', lClassMapTicket, lDBIntIdoMapTicket) ;
    lClassToDBMapTicket.TableName := 'EMPRESTIMO';
  // registrando os atributos da classe
    prop := lClassMapTicket.NewAttributeTicket('DataInicio', 'acDateTime', pvPersistent, False);
    prop.FixSize := 0;
    prop.VarSize := 0;
    prop.Mandatory := True;
    prop.DBType := 'DATETIME';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'DATA_INICIO';
    prop := lClassMapTicket.NewAttributeTicket('DataDevolucaoPrevista', 'acDateTime', pvPersistent, False);
    prop.FixSize := 0;
    prop.VarSize := 0;
    prop.Mandatory := True;
    prop.DBType := 'DATETIME';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'DATA_DEVOLUCAO_PREVISTA';
    prop := lClassMapTicket.NewAttributeTicket('DataDevolucao', 'acDateTime', pvPersistent, False);
    prop.FixSize := 0;
    prop.VarSize := 0;
    prop.Mandatory := False;
    prop.DBType := 'DATETIME';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'DATA_DEVOLUCAO';
  
    lClassMapTicket    := piMetaModel.NewClassRegisterTicket('-4','ngEntity','acPersistentObject', acOIDInt);
    lClassMapTicket.AuditDescription := '';
  
    lDBIntIdoMapTicket := acDBIntIdoMapTicket.Create('IESCIDENTI');
    lClassToDBMapTicket := (piMetaModel.DefaultMetaModelPersistenceMap as acMetaModelPersistenceMapSql).NewClassToDBMapRegisterTicket('-4', lClassMapTicket, lDBIntIdoMapTicket) ;
    lClassToDBMapTicket.TableName := 'IESCTENTID';
  // registrando os atributos da classe
    prop := lClassMapTicket.NewAttributeTicket('Name', 'acString', pvPersistent, False);
    prop.FixSize := 0;
    prop.VarSize := 20;
    prop.Mandatory := False;
    prop.DBType := 'varchar';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'IESCNMENTI';
    prop := lClassMapTicket.NewAttributeTicket('Code', 'acInt', pvPersistent, False);
    prop.FixSize := 10;
    prop.VarSize := 0;
    prop.Mandatory := False;
    prop.DBType := 'int';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'IESCCDENTI';
    prop := lClassMapTicket.NewAttributeTicket('Caption', 'acString', pvPersistent, False);
    prop.FixSize := 0;
    prop.VarSize := 20;
    prop.Mandatory := True;
    prop.DBType := 'varchar';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'IESCTIENTI';
    prop := lClassMapTicket.NewAttributeTicket('Situation', 'acString', pvPersistent, False);
    prop.FixSize := 1;
    prop.VarSize := 0;
    prop.Mandatory := True;
    prop.DBType := 'CHAR';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'IESCCDSITU';
  
    lClassMapTicket    := piMetaModel.NewClassRegisterTicket('-8','ngEvent','acPersistentObject', acOIDInt);
    lClassMapTicket.AuditDescription := '';
  
    lDBIntIdoMapTicket := acDBIntIdoMapTicket.Create('SEGCIDESEG');
    lClassToDBMapTicket := (piMetaModel.DefaultMetaModelPersistenceMap as acMetaModelPersistenceMapSql).NewClassToDBMapRegisterTicket('-8', lClassMapTicket, lDBIntIdoMapTicket) ;
    lClassToDBMapTicket.TableName := 'SEGCTEVSEG';
  // registrando os atributos da classe
    prop := lClassMapTicket.NewAttributeTicket('DtLaunching', 'acDateTime', pvPersistent, False);
    prop.FixSize := 8;
    prop.VarSize := 0;
    prop.Mandatory := False;
    prop.DBType := 'datetime';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'SEGCDTLANC';
    prop := lClassMapTicket.NewAttributeTicket('EventType', 'acString', pvPersistent, False);
    prop.FixSize := 1;
    prop.VarSize := 0;
    prop.Mandatory := False;
    prop.DBType := 'char';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'SEGCTPEVEN';
  
    lClassMapTicket    := piMetaModel.NewClassRegisterTicket('2998','ngExemplar','acPersistentObject', acOIDInt);
    lClassMapTicket.AuditDescription := '';
  
    lDBIntIdoMapTicket := acDBIntIdoMapTicket.Create('ID_EXEMPLAR');
    lClassToDBMapTicket := (piMetaModel.DefaultMetaModelPersistenceMap as acMetaModelPersistenceMapSql).NewClassToDBMapRegisterTicket('2998', lClassMapTicket, lDBIntIdoMapTicket) ;
    lClassToDBMapTicket.TableName := 'EXEMPLAR';
  // registrando os atributos da classe
    prop := lClassMapTicket.NewAttributeTicket('Codigo', 'acString', pvPersistent, False);
    prop.FixSize := 0;
    prop.VarSize := 20;
    prop.Mandatory := True;
    prop.DBType := 'VARCHAR';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'CODIGO';
  
    lClassMapTicket    := piMetaModel.NewClassRegisterTicket('128','ngGUITicket','acPersistentObject', acOIDInt);
    lClassMapTicket.AuditDescription := '';
  
    lDBIntIdoMapTicket := acDBIntIdoMapTicket.Create('IESOIDINTE');
    lClassToDBMapTicket := (piMetaModel.DefaultMetaModelPersistenceMap as acMetaModelPersistenceMapSql).NewClassToDBMapRegisterTicket('128', lClassMapTicket, lDBIntIdoMapTicket) ;
    lClassToDBMapTicket.TableName := 'IESOTINTER';
  // registrando os atributos da classe
    prop := lClassMapTicket.NewAttributeTicket('Name', 'acString', pvPersistent, False);
    prop.FixSize := 0;
    prop.VarSize := 50;
    prop.Mandatory := False;
    prop.DBType := 'varchar';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'IESONMINTE';
    prop := lClassMapTicket.NewAttributeTicket('Code', 'acInt', pvPersistent, False);
    prop.FixSize := 10;
    prop.VarSize := 0;
    prop.Mandatory := False;
    prop.DBType := 'int';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'IESOCDINTE';
    prop := lClassMapTicket.NewAttributeTicket('Description', 'acString', pvPersistent, False);
    prop.FixSize := 0;
    prop.VarSize := 250;
    prop.Mandatory := False;
    prop.DBType := 'varchar';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'IESODSINTE';
    prop := lClassMapTicket.NewAttributeTicket('Situation', 'acString', pvPersistent, False);
    prop.FixSize := 1;
    prop.VarSize := 0;
    prop.Mandatory := True;
    prop.DBType := 'CHAR';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'IESOCDSITU';
  
    lClassMapTicket    := piMetaModel.NewClassRegisterTicket('-2','ngIcon','acPersistentObject', acOIDInt);
    lClassMapTicket.AuditDescription := '';
  
    lDBIntIdoMapTicket := acDBIntIdoMapTicket.Create('IESFIDCUIC');
    lClassToDBMapTicket := (piMetaModel.DefaultMetaModelPersistenceMap as acMetaModelPersistenceMapSql).NewClassToDBMapRegisterTicket('-2', lClassMapTicket, lDBIntIdoMapTicket) ;
    lClassToDBMapTicket.TableName := 'IESFTCUICO';
  // registrando os atributos da classe
    prop := lClassMapTicket.NewAttributeTicket('Description', 'acString', pvPersistent, False);
    prop.FixSize := 0;
    prop.VarSize := 50;
    prop.Mandatory := True;
    prop.DBType := 'varchar';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'IESFDSCUIC';
    prop := lClassMapTicket.NewAttributeTicket('Code', 'acInt', pvPersistent, False);
    prop.FixSize := 10;
    prop.VarSize := 0;
    prop.Mandatory := True;
    prop.DBType := 'int';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'IESFCDCUIC';
    prop := lClassMapTicket.NewAttributeTicket('Image', 'acBlob', pvPersistent, False);
    prop.FixSize := 16;
    prop.VarSize := 0;
    prop.Mandatory := False;
    prop.DBType := 'image';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'IESFIMCUIC';
    prop := lClassMapTicket.NewAttributeTicket('Situation', 'acString', pvPersistent, False);
    prop.FixSize := 1;
    prop.VarSize := 0;
    prop.Mandatory := True;
    prop.DBType := 'CHAR';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'IESFCDSITU';
  
    lClassMapTicket    := piMetaModel.NewClassRegisterTicket('-11','ngLevel','acPersistentObject', acOIDInt);
    lClassMapTicket.AuditDescription := '';
  
    lDBIntIdoMapTicket := acDBIntIdoMapTicket.Create('IESHIDLEVE');
    lClassToDBMapTicket := (piMetaModel.DefaultMetaModelPersistenceMap as acMetaModelPersistenceMapSql).NewClassToDBMapRegisterTicket('-11', lClassMapTicket, lDBIntIdoMapTicket) ;
    lClassToDBMapTicket.TableName := 'IESHTLEVEL';
  // registrando os atributos da classe
    prop := lClassMapTicket.NewAttributeTicket('Code', 'acInt', pvPersistent, False);
    prop.FixSize := 10;
    prop.VarSize := 0;
    prop.Mandatory := False;
    prop.DBType := 'int';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'IESHCDLEVE';
    prop := lClassMapTicket.NewAttributeTicket('Description', 'acString', pvPersistent, False);
    prop.FixSize := 0;
    prop.VarSize := 50;
    prop.Mandatory := False;
    prop.DBType := 'varchar';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'IESHDSLEVE';
    prop := lClassMapTicket.NewAttributeTicket('Situation', 'acString', pvPersistent, False);
    prop.FixSize := 1;
    prop.VarSize := 0;
    prop.Mandatory := True;
    prop.DBType := 'CHAR';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'IESHCDSITU';
  
    lClassMapTicket    := piMetaModel.NewClassRegisterTicket('2997','ngLivro','acPersistentObject', acOIDInt);
    lClassMapTicket.AuditDescription := '';
  
    lDBIntIdoMapTicket := acDBIntIdoMapTicket.Create('ID_LIVRO');
    lClassToDBMapTicket := (piMetaModel.DefaultMetaModelPersistenceMap as acMetaModelPersistenceMapSql).NewClassToDBMapRegisterTicket('2997', lClassMapTicket, lDBIntIdoMapTicket) ;
    lClassToDBMapTicket.TableName := 'LIVRO';
  // registrando os atributos da classe
    prop := lClassMapTicket.NewAttributeTicket('ISBN', 'acString', pvPersistent, False);
    prop.FixSize := 0;
    prop.VarSize := 15;
    prop.Mandatory := True;
    prop.DBType := 'VARCHAR';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'ISBN';
    prop := lClassMapTicket.NewAttributeTicket('Titulo', 'acString', pvPersistent, False);
    prop.FixSize := 0;
    prop.VarSize := 200;
    prop.Mandatory := True;
    prop.DBType := 'VARCHAR';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'TITULO';
    prop := lClassMapTicket.NewAttributeTicket('Edicao', 'acString', pvPersistent, False);
    prop.FixSize := 0;
    prop.VarSize := 15;
    prop.Mandatory := True;
    prop.DBType := 'VARCHAR';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'EDICAO';
  
    lClassMapTicket    := piMetaModel.NewClassRegisterTicket('515','ngMessage','acPersistentObject', acOIDInt);
    lClassMapTicket.AuditDescription := '';
  
    lDBIntIdoMapTicket := acDBIntIdoMapTicket.Create('IESRIDMESS');
    lClassToDBMapTicket := (piMetaModel.DefaultMetaModelPersistenceMap as acMetaModelPersistenceMapSql).NewClassToDBMapRegisterTicket('515', lClassMapTicket, lDBIntIdoMapTicket) ;
    lClassToDBMapTicket.TableName := 'IESRTMESSG';
  // registrando os atributos da classe
    prop := lClassMapTicket.NewAttributeTicket('Code', 'acInt', pvPersistent, False);
    prop.FixSize := 0;
    prop.VarSize := 0;
    prop.Mandatory := True;
    prop.DBType := 'int';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'IESRCDMESS';
    prop := lClassMapTicket.NewAttributeTicket('Description', 'acString', pvPersistent, False);
    prop.FixSize := 0;
    prop.VarSize := 300;
    prop.Mandatory := True;
    prop.DBType := 'varchar';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'IESRDSMESS';
    prop := lClassMapTicket.NewAttributeTicket('Name', 'acString', pvPersistent, False);
    prop.FixSize := 0;
    prop.VarSize := 100;
    prop.Mandatory := True;
    prop.DBType := 'varchar';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'IESRSGMESS';
    prop := lClassMapTicket.NewAttributeTicket('Situation', 'acString', pvPersistent, False);
    prop.FixSize := 1;
    prop.VarSize := 0;
    prop.Mandatory := True;
    prop.DBType := 'CHAR';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'IESRCDSITU';
    prop := lClassMapTicket.NewAttributeTicket('DetailedDescription', 'acString', pvPersistent, False);
    prop.FixSize := 0;
    prop.VarSize := 4000;
    prop.Mandatory := False;
    prop.DBType := 'varchar';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'IESRDSDETA';
    prop := lClassMapTicket.NewAttributeTicket('ShowCode', 'acString', pvPersistent, False);
    prop.FixSize := 1;
    prop.VarSize := 0;
    prop.Mandatory := False;
    prop.DBType := 'char';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'IESRSHOCOD';
    prop := lClassMapTicket.NewAttributeTicket('DescriptionUser', 'acString', pvPersistent, False);
    prop.FixSize := 0;
    prop.VarSize := 300;
    prop.Mandatory := False;
    prop.DBType := 'varchar';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'IESRDSMEUS';
  
    lClassMapTicket    := piMetaModel.NewClassRegisterTicket('132','NGNatureza','acPersistentObject', acOIDInt);
    lClassMapTicket.AuditDescription := '';
  
    lDBIntIdoMapTicket := acDBIntIdoMapTicket.Create('SEGDIDNAUS');
    lClassToDBMapTicket := (piMetaModel.DefaultMetaModelPersistenceMap as acMetaModelPersistenceMapSql).NewClassToDBMapRegisterTicket('132', lClassMapTicket, lDBIntIdoMapTicket) ;
    lClassToDBMapTicket.TableName := 'SEGDTNAUSU';
  // registrando os atributos da classe
    prop := lClassMapTicket.NewAttributeTicket('Codigo', 'acInt', pvPersistent, False);
    prop.FixSize := 10;
    prop.VarSize := 0;
    prop.Mandatory := False;
    prop.DBType := 'int';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'SEGDCDNAUS';
    prop := lClassMapTicket.NewAttributeTicket('Descricao', 'acString', pvPersistent, False);
    prop.FixSize := 0;
    prop.VarSize := 50;
    prop.Mandatory := False;
    prop.DBType := 'varchar';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'SEGDDSNAUS';
  
    lClassMapTicket    := piMetaModel.NewClassRegisterTicket('-9','ngOperation','acPersistentObject', acOIDInt);
    lClassMapTicket.AuditDescription := '';
  
    lDBIntIdoMapTicket := acDBIntIdoMapTicket.Create('IESJIDOPER');
    lClassToDBMapTicket := (piMetaModel.DefaultMetaModelPersistenceMap as acMetaModelPersistenceMapSql).NewClassToDBMapRegisterTicket('-9', lClassMapTicket, lDBIntIdoMapTicket) ;
    lClassToDBMapTicket.TableName := 'IESJTOPERA';
  // registrando os atributos da classe
    prop := lClassMapTicket.NewAttributeTicket('Description', 'acString', pvPersistent, False);
    prop.FixSize := 0;
    prop.VarSize := 20;
    prop.Mandatory := False;
    prop.DBType := 'varchar';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'IESJDSOPER';
    prop := lClassMapTicket.NewAttributeTicket('Code', 'acInt', pvPersistent, False);
    prop.FixSize := 10;
    prop.VarSize := 0;
    prop.Mandatory := True;
    prop.DBType := 'int';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'IESJCDOPER';
    prop := lClassMapTicket.NewAttributeTicket('Situation', 'acString', pvPersistent, False);
    prop.FixSize := 1;
    prop.VarSize := 0;
    prop.Mandatory := True;
    prop.DBType := 'CHAR';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'IESJCDSITU';
  
    lClassMapTicket    := piMetaModel.NewClassRegisterTicket('-7','ngPermission','acPersistentObject', acOIDInt);
    lClassMapTicket.AuditDescription := '';
  
    lDBIntIdoMapTicket := acDBIntIdoMapTicket.Create('SEGBIDPERM');
    lClassToDBMapTicket := (piMetaModel.DefaultMetaModelPersistenceMap as acMetaModelPersistenceMapSql).NewClassToDBMapRegisterTicket('-7', lClassMapTicket, lDBIntIdoMapTicket) ;
    lClassToDBMapTicket.TableName := 'SEGBTPERMI';
  
    lClassMapTicket    := piMetaModel.NewClassRegisterTicket('1518','ngProfile','acPersistentObject', acOIDInt);
    lClassMapTicket.AuditDescription := '';
  
    lDBIntIdoMapTicket := acDBIntIdoMapTicket.Create('IESSIDPROF');
    lClassToDBMapTicket := (piMetaModel.DefaultMetaModelPersistenceMap as acMetaModelPersistenceMapSql).NewClassToDBMapRegisterTicket('1518', lClassMapTicket, lDBIntIdoMapTicket) ;
    lClassToDBMapTicket.TableName := 'IESSTPROFI';
  // registrando os atributos da classe
    prop := lClassMapTicket.NewAttributeTicket('Code', 'acInt', pvPersistent, False);
    prop.FixSize := 0;
    prop.VarSize := 0;
    prop.Mandatory := True;
    prop.DBType := 'int';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'IESSCDPROF';
    prop := lClassMapTicket.NewAttributeTicket('Name', 'acString', pvPersistent, False);
    prop.FixSize := 0;
    prop.VarSize := 40;
    prop.Mandatory := True;
    prop.DBType := 'varchar';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'IESSNMPROF';
    prop := lClassMapTicket.NewAttributeTicket('Description', 'acString', pvPersistent, False);
    prop.FixSize := 0;
    prop.VarSize := 100;
    prop.Mandatory := False;
    prop.DBType := 'varchar';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'IESSDSPROF';
  
    lClassMapTicket    := piMetaModel.NewClassRegisterTicket('3005','ngSituacao','acPersistentObject', acOIDInt);
    lClassMapTicket.AuditDescription := '';
  
    lDBIntIdoMapTicket := acDBIntIdoMapTicket.Create('ID_SITUACAO');
    lClassToDBMapTicket := (piMetaModel.DefaultMetaModelPersistenceMap as acMetaModelPersistenceMapSql).NewClassToDBMapRegisterTicket('3005', lClassMapTicket, lDBIntIdoMapTicket) ;
    lClassToDBMapTicket.TableName := 'SITUACAO';
  // registrando os atributos da classe
    prop := lClassMapTicket.NewAttributeTicket('Codigo', 'acString', pvPersistent, False);
    prop.FixSize := 0;
    prop.VarSize := 5;
    prop.Mandatory := True;
    prop.DBType := 'VARCHAR';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'CODIGO';
    prop := lClassMapTicket.NewAttributeTicket('Descricao', 'acString', pvPersistent, False);
    prop.FixSize := 0;
    prop.VarSize := 250;
    prop.Mandatory := True;
    prop.DBType := 'VARCHAR';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'DESCRICAO';
  
    lClassMapTicket    := piMetaModel.NewClassRegisterTicket('-5','ngSystem','acPersistentObject', acOIDInt);
    lClassMapTicket.AuditDescription := '';
  
    lDBIntIdoMapTicket := acDBIntIdoMapTicket.Create('IESAIDSIST');
    lClassToDBMapTicket := (piMetaModel.DefaultMetaModelPersistenceMap as acMetaModelPersistenceMapSql).NewClassToDBMapRegisterTicket('-5', lClassMapTicket, lDBIntIdoMapTicket) ;
    lClassToDBMapTicket.TableName := 'IESATSISTE';
  // registrando os atributos da classe
    prop := lClassMapTicket.NewAttributeTicket('Name', 'acString', pvPersistent, False);
    prop.FixSize := 0;
    prop.VarSize := 10;
    prop.Mandatory := False;
    prop.DBType := 'varchar';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'IESANMSIST';
    prop := lClassMapTicket.NewAttributeTicket('Description', 'acString', pvPersistent, False);
    prop.FixSize := 0;
    prop.VarSize := 50;
    prop.Mandatory := False;
    prop.DBType := 'varchar';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'IESADSSIST';
    prop := lClassMapTicket.NewAttributeTicket('Version', 'acString', pvPersistent, False);
    prop.FixSize := 0;
    prop.VarSize := 10;
    prop.Mandatory := False;
    prop.DBType := 'varchar';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'IESAVERSAO';
    prop := lClassMapTicket.NewAttributeTicket('Code', 'acInt', pvPersistent, False);
    prop.FixSize := 10;
    prop.VarSize := 0;
    prop.Mandatory := True;
    prop.DBType := 'int';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'IESACDSIST';
    prop := lClassMapTicket.NewAttributeTicket('Situation', 'acString', pvPersistent, False);
    prop.FixSize := 1;
    prop.VarSize := 0;
    prop.Mandatory := True;
    prop.DBType := 'CHAR';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'IESACDSITU';
  
    lClassMapTicket    := piMetaModel.NewClassRegisterTicket('-12','ngSystemConfigUpdateLog','acPersistentObject', acOIDInt);
    lClassMapTicket.AuditDescription := '';
  
    lDBIntIdoMapTicket := acDBIntIdoMapTicket.Create('IESQIDUPLO');
    lClassToDBMapTicket := (piMetaModel.DefaultMetaModelPersistenceMap as acMetaModelPersistenceMapSql).NewClassToDBMapRegisterTicket('-12', lClassMapTicket, lDBIntIdoMapTicket) ;
    lClassToDBMapTicket.TableName := 'IESQTUPLOG';
  // registrando os atributos da classe
    prop := lClassMapTicket.NewAttributeTicket('XMLLog', 'acString', pvPersistent, False);
    prop.FixSize := 9999999;
    prop.VarSize := 0;
    prop.Mandatory := True;
    prop.DBType := 'Text';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'IESQXMLOG';
    prop := lClassMapTicket.NewAttributeTicket('UpdateDate', 'acDateTime', pvPersistent, False);
    prop.FixSize := 0;
    prop.VarSize := 0;
    prop.Mandatory := True;
    prop.DBType := 'datetime';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'IESQUDATE';
    prop := lClassMapTicket.NewAttributeTicket('UserLogin', 'acString', pvPersistent, False);
    prop.FixSize := 0;
    prop.VarSize := 50;
    prop.Mandatory := True;
    prop.DBType := 'VARCHAR';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'IESQCDLOGI';
  
    lClassMapTicket    := piMetaModel.NewClassRegisterTicket('129','ngSystemGUITickets','acPersistentObject', acOIDInt);
    lClassMapTicket.AuditDescription := '';
  
    lDBIntIdoMapTicket := acDBIntIdoMapTicket.Create('IESPIDSISI');
    lClassToDBMapTicket := (piMetaModel.DefaultMetaModelPersistenceMap as acMetaModelPersistenceMapSql).NewClassToDBMapRegisterTicket('129', lClassMapTicket, lDBIntIdoMapTicket) ;
    lClassToDBMapTicket.TableName := 'IESPTSISIN';
  // registrando os atributos da classe
    prop := lClassMapTicket.NewAttributeTicket('Situation', 'acString', pvPersistent, False);
    prop.FixSize := 1;
    prop.VarSize := 0;
    prop.Mandatory := True;
    prop.DBType := 'CHAR';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'IESPCDSITU';
  
    lClassMapTicket    := piMetaModel.NewClassRegisterTicket('-14','ngSystemUseCaseTicket','acPersistentObject', acOIDInt);
    lClassMapTicket.AuditDescription := '';
  
    lDBIntIdoMapTicket := acDBIntIdoMapTicket.Create('IESEIDSISC');
    lClassToDBMapTicket := (piMetaModel.DefaultMetaModelPersistenceMap as acMetaModelPersistenceMapSql).NewClassToDBMapRegisterTicket('-14', lClassMapTicket, lDBIntIdoMapTicket) ;
    lClassToDBMapTicket.TableName := 'IESETSISCU';
  // registrando os atributos da classe
    prop := lClassMapTicket.NewAttributeTicket('Situation', 'acString', pvPersistent, False);
    prop.FixSize := 1;
    prop.VarSize := 0;
    prop.Mandatory := False;
    prop.DBType := 'CHAR';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'IESECDSITU';
  
    lClassMapTicket    := piMetaModel.NewClassRegisterTicket('-1','ngUseCaseTicket','acPersistentObject', acOIDInt);
    lClassMapTicket.AuditDescription := '';
  
    lDBIntIdoMapTicket := acDBIntIdoMapTicket.Create('IESBIDCASO');
    lClassToDBMapTicket := (piMetaModel.DefaultMetaModelPersistenceMap as acMetaModelPersistenceMapSql).NewClassToDBMapRegisterTicket('-1', lClassMapTicket, lDBIntIdoMapTicket) ;
    lClassToDBMapTicket.TableName := 'IESBTCASOU';
  // registrando os atributos da classe
    prop := lClassMapTicket.NewAttributeTicket('Description', 'acString', pvPersistent, False);
    prop.FixSize := 0;
    prop.VarSize := 250;
    prop.Mandatory := False;
    prop.DBType := 'varchar';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'IESBDSCASO';
    prop := lClassMapTicket.NewAttributeTicket('Name', 'acString', pvPersistent, False);
    prop.FixSize := 0;
    prop.VarSize := 50;
    prop.Mandatory := False;
    prop.DBType := 'varchar';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'IESBNMCASO';
    prop := lClassMapTicket.NewAttributeTicket('Code', 'acInt', pvPersistent, False);
    prop.FixSize := 10;
    prop.VarSize := 0;
    prop.Mandatory := False;
    prop.DBType := 'int';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'IESBCDCASO';
    prop := lClassMapTicket.NewAttributeTicket('UseCaseType', 'acString', pvPersistent, False);
    prop.FixSize := 1;
    prop.VarSize := 0;
    prop.Mandatory := False;
    prop.DBType := 'char';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'IESBTPCASO';
    prop := lClassMapTicket.NewAttributeTicket('Situation', 'acString', pvPersistent, False);
    prop.FixSize := 1;
    prop.VarSize := 0;
    prop.Mandatory := False;
    prop.DBType := 'CHAR';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'IESBCDSITU';
  
    lClassMapTicket    := piMetaModel.NewClassRegisterTicket('-10','ngUseCaseTicketOperation','acPersistentObject', acOIDInt);
    lClassMapTicket.AuditDescription := '';
  
    lDBIntIdoMapTicket := acDBIntIdoMapTicket.Create('IESGIDCUOP');
    lClassToDBMapTicket := (piMetaModel.DefaultMetaModelPersistenceMap as acMetaModelPersistenceMapSql).NewClassToDBMapRegisterTicket('-10', lClassMapTicket, lDBIntIdoMapTicket) ;
    lClassToDBMapTicket.TableName := 'IESGTCUOPE';
  // registrando os atributos da classe
    prop := lClassMapTicket.NewAttributeTicket('Situation', 'acString', pvPersistent, False);
    prop.FixSize := 1;
    prop.VarSize := 0;
    prop.Mandatory := True;
    prop.DBType := 'CHAR';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'IESGCDSITU';
    prop := lClassMapTicket.NewAttributeTicket('AccessControlExternalCode', 'acString', pvPersistent, False);
    prop.FixSize := 0;
    prop.VarSize := 20;
    prop.Mandatory := False;
    prop.DBType := 'VARCHAR';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'IESGCDACEX';
  
    lClassMapTicket    := piMetaModel.NewClassRegisterTicket('-6','NGUser','acPersistentObject', acOIDInt);
    lClassMapTicket.AuditDescription := '';
  
    lDBIntIdoMapTicket := acDBIntIdoMapTicket.Create('SEGAIDUSUA');
    lClassToDBMapTicket := (piMetaModel.DefaultMetaModelPersistenceMap as acMetaModelPersistenceMapSql).NewClassToDBMapRegisterTicket('-6', lClassMapTicket, lDBIntIdoMapTicket) ;
    lClassToDBMapTicket.TableName := 'SEGATUSUAR';
    lClassToDBMapTicket.TypeColumnName := 'SEGACDHERA';
  // registrando os atributos da classe
    prop := lClassMapTicket.NewAttributeTicket('Login', 'acString', pvPersistent, False);
    prop.FixSize := 0;
    prop.VarSize := 25;
    prop.Mandatory := True;
    prop.DBType := 'varchar';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'SEGACDUSUA';
    prop := lClassMapTicket.NewAttributeTicket('Password', 'acString', pvPersistent, False);
    prop.FixSize := 0;
    prop.VarSize := 12;
    prop.Mandatory := False;
    prop.DBType := 'varchar';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'SEGASENHAU';
    prop := lClassMapTicket.NewAttributeTicket('PasswordResetCode', 'acString', pvPersistent, False);
    prop.FixSize := 0;
    prop.VarSize := 20;
    prop.Mandatory := False;
    prop.DBType := 'varchar';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'SEGAPRSETC';
    prop := lClassMapTicket.NewAttributeTicket('DtRegister', 'acDateTime', pvPersistent, False);
    prop.FixSize := 8;
    prop.VarSize := 0;
    prop.Mandatory := True;
    prop.DBType := 'datetime';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'SEGADTCADU';
    prop := lClassMapTicket.NewAttributeTicket('DtLastChangePassword', 'acDateTime', pvPersistent, False);
    prop.FixSize := 8;
    prop.VarSize := 0;
    prop.Mandatory := False;
    prop.DBType := 'datetime';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'SEGADTULSE';
    prop := lClassMapTicket.NewAttributeTicket('CancelIndicator', 'acString', pvPersistent, False);
    prop.FixSize := 1;
    prop.VarSize := 0;
    prop.Mandatory := True;
    prop.DBType := 'char';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'SEGAINCANC';
    prop := lClassMapTicket.NewAttributeTicket('CodigoReferencia', 'acString', pvPersistent, False);
    prop.FixSize := 0;
    prop.VarSize := 25;
    prop.Mandatory := False;
    prop.DBType := 'varchar';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'SEGACDREFE';
    prop := lClassMapTicket.NewAttributeTicket('PasswordFormat', 'acInt', pvPersistent, False);
    prop.FixSize := 10;
    prop.VarSize := 0;
    prop.Mandatory := False;
    prop.DBType := 'int';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'SEGAFORMSE';
    prop := lClassMapTicket.NewAttributeTicket('PasswordSalt', 'acString', pvPersistent, False);
    prop.FixSize := 0;
    prop.VarSize := 128;
    prop.Mandatory := False;
    prop.DBType := 'varchar';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'SEGASALTSE';
    prop := lClassMapTicket.NewAttributeTicket('MobilePIN', 'acString', pvPersistent, False);
    prop.FixSize := 0;
    prop.VarSize := 16;
    prop.Mandatory := False;
    prop.DBType := 'varchar';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'SEGAMOBILE';
    prop := lClassMapTicket.NewAttributeTicket('Email', 'acString', pvPersistent, False);
    prop.FixSize := 0;
    prop.VarSize := 256;
    prop.Mandatory := False;
    prop.DBType := 'varchar';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'SEGAEEMAIL';
    prop := lClassMapTicket.NewAttributeTicket('LoweredEmail', 'acString', pvPersistent, False);
    prop.FixSize := 0;
    prop.VarSize := 256;
    prop.Mandatory := False;
    prop.DBType := 'varchar';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'SEGALEMAIL';
    prop := lClassMapTicket.NewAttributeTicket('PasswordQuestion', 'acString', pvPersistent, False);
    prop.FixSize := 0;
    prop.VarSize := 256;
    prop.Mandatory := False;
    prop.DBType := 'varchar';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'SEGASENHAQ';
    prop := lClassMapTicket.NewAttributeTicket('PasswordAnswer', 'acString', pvPersistent, False);
    prop.FixSize := 0;
    prop.VarSize := 256;
    prop.Mandatory := False;
    prop.DBType := 'varchar';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'SEGASENHAA';
    prop := lClassMapTicket.NewAttributeTicket('IsLockedOut', 'acString', pvPersistent, False);
    prop.FixSize := 1;
    prop.VarSize := 0;
    prop.Mandatory := False;
    prop.DBType := 'char';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'SEGABLOQUE';
    prop := lClassMapTicket.NewAttributeTicket('LastLoginDate', 'acDateTime', pvPersistent, False);
    prop.FixSize := 8;
    prop.VarSize := 0;
    prop.Mandatory := False;
    prop.DBType := 'datetime';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'SEGAULTLGN';
    prop := lClassMapTicket.NewAttributeTicket('LastLockoutDate', 'acDateTime', pvPersistent, False);
    prop.FixSize := 8;
    prop.VarSize := 0;
    prop.Mandatory := False;
    prop.DBType := 'datetime';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'SEGAULTBLQ';
    prop := lClassMapTicket.NewAttributeTicket('FailedPasswordAttemptCount', 'acInt', pvPersistent, False);
    prop.FixSize := 10;
    prop.VarSize := 0;
    prop.Mandatory := False;
    prop.DBType := 'int';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'SEGAFSACOU';
    prop := lClassMapTicket.NewAttributeTicket('FailedPasswordAttemptWindowStart', 'acDateTime', pvPersistent, False);
    prop.FixSize := 8;
    prop.VarSize := 0;
    prop.Mandatory := False;
    prop.DBType := 'datetime';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'SEGAFSAWST';
    prop := lClassMapTicket.NewAttributeTicket('FailedPasswordAnswerAttemptCount', 'acInt', pvPersistent, False);
    prop.FixSize := 10;
    prop.VarSize := 0;
    prop.Mandatory := False;
    prop.DBType := 'int';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'SEGAFSAACO';
    prop := lClassMapTicket.NewAttributeTicket('FailedPasswordAnswerAttemptWindowStart', 'acDateTime', pvPersistent, False);
    prop.FixSize := 8;
    prop.VarSize := 0;
    prop.Mandatory := False;
    prop.DBType := 'datetime';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'SEGAFSAAWS';
    prop := lClassMapTicket.NewAttributeTicket('Comment', 'acString', pvPersistent, False);
    prop.FixSize := 16;
    prop.VarSize := 0;
    prop.Mandatory := False;
    prop.DBType := 'text';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'SEGACOMMEN';
    prop := lClassMapTicket.NewAttributeTicket('LastActivityDate', 'acDateTime', pvPersistent, False);
    prop.FixSize := 8;
    prop.VarSize := 0;
    prop.Mandatory := False;
    prop.DBType := 'datetime';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'SEGAULTACT';
  
    lClassMapTicket    := piMetaModel.NewClassRegisterTicket('1540','ngUserProfile','acPersistentObject', acOIDInt);
    lClassMapTicket.AuditDescription := '';
  
    lDBIntIdoMapTicket := acDBIntIdoMapTicket.Create('IESUIDUSEP');
    lClassToDBMapTicket := (piMetaModel.DefaultMetaModelPersistenceMap as acMetaModelPersistenceMapSql).NewClassToDBMapRegisterTicket('1540', lClassMapTicket, lDBIntIdoMapTicket) ;
    lClassToDBMapTicket.TableName := 'IESUTUSERP';
  
    lClassMapTicket    := piMetaModel.NewClassRegisterTicket('3004','ngUsuario','acPersistentObject', acOIDInt);
    lClassMapTicket.AuditDescription := '';
  
    lDBIntIdoMapTicket := acDBIntIdoMapTicket.Create('ID_USUARIO');
    lClassToDBMapTicket := (piMetaModel.DefaultMetaModelPersistenceMap as acMetaModelPersistenceMapSql).NewClassToDBMapRegisterTicket('3004', lClassMapTicket, lDBIntIdoMapTicket) ;
    lClassToDBMapTicket.TableName := 'USUARIO';
  // registrando os atributos da classe
    prop := lClassMapTicket.NewAttributeTicket('Nome', 'acString', pvPersistent, False);
    prop.FixSize := 0;
    prop.VarSize := 200;
    prop.Mandatory := True;
    prop.DBType := 'VARCHAR';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'NOME';
    prop := lClassMapTicket.NewAttributeTicket('CPF', 'acString', pvPersistent, False);
    prop.FixSize := 0;
    prop.VarSize := 11;
    prop.Mandatory := True;
    prop.DBType := 'VARCHAR';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'CPF';
    prop := lClassMapTicket.NewAttributeTicket('DataNascimento', 'acDateTime', pvPersistent, False);
    prop.FixSize := 0;
    prop.VarSize := 0;
    prop.Mandatory := True;
    prop.DBType := 'DATETIME';
    lClassToDBMapTicket.NewDbColumnMapRegisterTicket(prop).ColumnName := 'DATA_NASCIMENTO';
end;

procedure RegisterClassRelationTickets(piMetaModel: acMetaModel);
var
  lRelationTicket: acRelationTicket;
begin
  lRelationTicket := piMetaModel.NewRelationRegisterTicket('NGBusinessEvent', 'Distributed', 0, 1, pvComposite, 'Distributed BusinessEvent', 'NGBusinessEventDistributed', '', 1, 1, pvNone, False, False);
  if lRelationTicket <> nil then (piMetaModel.DefaultMetaModelPersistenceMap as acMetaModelPersistenceMapSql).NewOneToOneDbRelationMapRegisterTicket(lRelationTicket, 'INTLIDBUEV');
  
  lRelationTicket := piMetaModel.NewRelationRegisterTicket('NGBusinessEvent', '', 0, 2147483647, pvNone, 'SubscriberError has Event', 'NGBusinessEventSubscriberError', 'BusinessEvent', 1, 1, pvNone, False, False);
  if lRelationTicket <> nil then (piMetaModel.DefaultMetaModelPersistenceMap as acMetaModelPersistenceMapSql).NewOneToManyDbRelationMapRegisterTicket(lRelationTicket, 'INTJIDBUEV');
  
  lRelationTicket := piMetaModel.NewRelationRegisterTicket('NGBusinessEventSubscriber', 'ActiveError', 1, 1, pvNone, '', 'NGBusinessEventSubscriberError', '', 1, 1, pvNone, False, False);
  if lRelationTicket <> nil then (piMetaModel.DefaultMetaModelPersistenceMap as acMetaModelPersistenceMapSql).NewIndirectOneToOneDbRelationMapRegisterTicket(lRelationTicket, 'INTBIDSUBS', 'INTJIDSBER', 'INTNTSUBER');
  
  lRelationTicket := piMetaModel.NewRelationRegisterTicket('NGBusinessEventSubscriber', 'NotifierEventualTimeWindows', 0, 2147483647, pvComposite, 'Subscriber has eventual notifier time windows', 'NGBusinessSubscriberNotifierEventualTimeWindow', 'Subscriber', 1, 1, pvNone, True, False);
  if lRelationTicket <> nil then (piMetaModel.DefaultMetaModelPersistenceMap as acMetaModelPersistenceMapSql).NewOneToManyDbRelationMapRegisterTicket(lRelationTicket, 'INTHIDSUBS');
  
  lRelationTicket := piMetaModel.NewRelationRegisterTicket('NGBusinessEventSubscriber', 'NotifierTimeGrids', 0, 2147483647, pvComposite, 'Subscriber has notifier time grids', 'NGBusinessSubscriberNotifierTimeGrid', 'Subscriber', 1, 1, pvNone, True, False);
  if lRelationTicket <> nil then (piMetaModel.DefaultMetaModelPersistenceMap as acMetaModelPersistenceMapSql).NewOneToManyDbRelationMapRegisterTicket(lRelationTicket, 'INTFIDSUBS');
  
  lRelationTicket := piMetaModel.NewRelationRegisterTicket('NGBusinessEventSubscriber', 'ActiveError', 0, 1, pvNone, 'Subscriber''s Active Error', 'NGBusinessEventSubscriberError', '', 1, 1, pvNone, False, False);
  if lRelationTicket <> nil then (piMetaModel.DefaultMetaModelPersistenceMap as acMetaModelPersistenceMapSql).NewIndirectOneToOneDbRelationMapRegisterTicket(lRelationTicket, 'INTBIDSUBS', 'INTJIDSBER', 'INTKTSUBER');
  
  lRelationTicket := piMetaModel.NewRelationRegisterTicket('NGBusinessEventSubscriber', 'Errors', 0, 2147483647, pvComposite, 'Subscriber''s Errors', 'NGBusinessEventSubscriberError', '', 1, 1, pvNone, False, False);
  if lRelationTicket <> nil then (piMetaModel.DefaultMetaModelPersistenceMap as acMetaModelPersistenceMapSql).NewOneToManyDbRelationMapRegisterTicket(lRelationTicket, 'INTJIDSUBS');
  
  lRelationTicket := piMetaModel.NewRelationRegisterTicket('NGBusinessEventSubscriber', 'EventsType', 0, 2147483647, pvNone, 'Subscriber''s Events Type of Interest', 'NGBusinessEventType', 'Subscribers', 0, 2147483647, pvNone, True, False);
  if lRelationTicket <> nil then (piMetaModel.DefaultMetaModelPersistenceMap as acMetaModelPersistenceMapSql).NewManyToManyDbRelationMapRegisterTicket(lRelationTicket, 'INTBIDSUBS', 'INTCIDEVNT', 'INTETINTER');
  
  lRelationTicket := piMetaModel.NewRelationRegisterTicket('NGBusinessEventSubscriber', 'IgnoredEvents', 0, 2147483647, pvNone, 'Subscriber''s Ignored Events', 'NGBusinessEvent', '', 0, 2147483647, pvNone, False, False);
  if lRelationTicket <> nil then (piMetaModel.DefaultMetaModelPersistenceMap as acMetaModelPersistenceMapSql).NewManyToManyDbRelationMapRegisterTicket(lRelationTicket, 'INTBIDSUBS', 'INTAIDBUEV', 'INTITIGNOR');
  
  lRelationTicket := piMetaModel.NewRelationRegisterTicket('NGBusinessEventSubscriber', 'NotifiedEvents', 0, 2147483647, pvNone, 'Subscriber''s Notified Events', 'NGBusinessEvent', '', 0, 2147483647, pvNone, False, False);
  if lRelationTicket <> nil then (piMetaModel.DefaultMetaModelPersistenceMap as acMetaModelPersistenceMapSql).NewManyToManyDbRelationMapRegisterTicket(lRelationTicket, 'INTBIDSUBS', 'INTAIDBUEV', 'INTMTNOTEV');
  
  lRelationTicket := piMetaModel.NewRelationRegisterTicket('NGBusinessEventSubscriber', 'UnnotifiedEvents', 0, 2147483647, pvNone, 'Subscriber''s Unnotified Events', 'NGBusinessEvent', '', 0, 2147483647, pvNone, False, False);
  if lRelationTicket <> nil then (piMetaModel.DefaultMetaModelPersistenceMap as acMetaModelPersistenceMapSql).NewManyToManyDbRelationMapRegisterTicket(lRelationTicket, 'INTBIDSUBS', 'INTAIDBUEV', 'INTDTUNNOT');
  
  lRelationTicket := piMetaModel.NewRelationRegisterTicket('NGBusinessEventType', '', 0, 2147483647, pvNone, 'Event has type', 'NGBusinessEvent', 'EventType', 1, 1, pvNone, False, False);
  if lRelationTicket <> nil then (piMetaModel.DefaultMetaModelPersistenceMap as acMetaModelPersistenceMapSql).NewOneToManyDbRelationMapRegisterTicket(lRelationTicket, 'INTAIDEVNT');
  
  lRelationTicket := piMetaModel.NewRelationRegisterTicket('NGBusinessSubscriberNotifierTimeGrid', 'TimeWindows', 0, 2147483647, pvComposite, 'Time grid has time windows', 'NGBusinessSubscriberNotifierTimeWindow', 'TimeGrid', 1, 1, pvNone, True, False);
  if lRelationTicket <> nil then (piMetaModel.DefaultMetaModelPersistenceMap as acMetaModelPersistenceMapSql).NewOneToManyDbRelationMapRegisterTicket(lRelationTicket, 'INTGIDTMGR');
  
  lRelationTicket := piMetaModel.NewRelationRegisterTicket('NGNatureza', '', 0, 2147483647, pvNone, 'User has nature', 'NGUser', 'Natureza', 1, 1, pvNone, False, False);
  if lRelationTicket <> nil then (piMetaModel.DefaultMetaModelPersistenceMap as acMetaModelPersistenceMapSql).NewOneToManyDbRelationMapRegisterTicket(lRelationTicket, 'SEGAIDNAUS');
  
  lRelationTicket := piMetaModel.NewRelationRegisterTicket('NGNatureza', 'Systems', 0, 2147483647, pvNone, 'User nature can access systems', 'ngSystem', '', 0, 2147483647, pvNone, False, False);
  if lRelationTicket <> nil then (piMetaModel.DefaultMetaModelPersistenceMap as acMetaModelPersistenceMapSql).NewManyToManyDbRelationMapRegisterTicket(lRelationTicket, 'SEGEIDNAUS', 'SEGEIDSIST', 'SEGETSINAU');
  
  lRelationTicket := piMetaModel.NewRelationRegisterTicket('NGUser', 'PermissionSecurityEvents', 0, 2147483647, pvNone, 'User generate security events', 'ngEvent', 'User', 1, 1, pvNone, True, False);
  if lRelationTicket <> nil then (piMetaModel.DefaultMetaModelPersistenceMap as acMetaModelPersistenceMapSql).NewOneToManyDbRelationMapRegisterTicket(lRelationTicket, 'SEGCIDUSUA');
  
  lRelationTicket := piMetaModel.NewRelationRegisterTicket('NGUser', 'Permissions', 0, 2147483647, pvNone, 'User has Permissions', 'ngPermission', 'User', 1, 1, pvNone, True, False);
  if lRelationTicket <> nil then (piMetaModel.DefaultMetaModelPersistenceMap as acMetaModelPersistenceMapSql).NewOneToManyDbRelationMapRegisterTicket(lRelationTicket, 'SEGBIDUSUA');
  
  lRelationTicket := piMetaModel.NewRelationRegisterTicket('NGUser', '', 0, 2147483647, pvNone, 'User has Profiles', 'ngUserProfile', 'User', 1, 1, pvNone, False, False);
  if lRelationTicket <> nil then (piMetaModel.DefaultMetaModelPersistenceMap as acMetaModelPersistenceMapSql).NewOneToManyDbRelationMapRegisterTicket(lRelationTicket, 'IESUIDUSUA');
  
  lRelationTicket := piMetaModel.NewRelationRegisterTicket('NGUser', 'SecurityEvents', 0, 2147483647, pvNone, 'User has security events', 'ngEvent', 'AuthorizedUser', 1, 1, pvNone, True, False);
  if lRelationTicket <> nil then (piMetaModel.DefaultMetaModelPersistenceMap as acMetaModelPersistenceMapSql).NewOneToManyDbRelationMapRegisterTicket(lRelationTicket, 'SEGCIDRESP');
  
  lRelationTicket := piMetaModel.NewRelationRegisterTicket('ngAuditEvent', 'Data', 0, 2147483647, pvNone, 'Audit Event has Data', 'ngAuditEventData', 'AuditEvent', 1, 1, pvNone, True, False);
  if lRelationTicket <> nil then (piMetaModel.DefaultMetaModelPersistenceMap as acMetaModelPersistenceMapSql).NewOneToManyDbRelationMapRegisterTicket(lRelationTicket, 'SISDIDAUDI');
  
  lRelationTicket := piMetaModel.NewRelationRegisterTicket('ngCategory', 'UseCases', 0, 2147483647, pvNone, 'Usecases have a category', 'ngUseCaseTicket', 'Category', 1, 1, pvNone, True, False);
  if lRelationTicket <> nil then (piMetaModel.DefaultMetaModelPersistenceMap as acMetaModelPersistenceMapSql).NewOneToManyDbRelationMapRegisterTicket(lRelationTicket, 'IESBIDCATE');
  
  lRelationTicket := piMetaModel.NewRelationRegisterTicket('ngEntity', 'UseCases', 0, 2147483647, pvNone, 'Entity has Usecases', 'ngUseCaseTicket', 'Entity', 1, 1, pvNone, True, False);
  if lRelationTicket <> nil then (piMetaModel.DefaultMetaModelPersistenceMap as acMetaModelPersistenceMapSql).NewOneToManyDbRelationMapRegisterTicket(lRelationTicket, 'IESBIDENTI');
  
  lRelationTicket := piMetaModel.NewRelationRegisterTicket('ngExemplar', 'Emprestimos', 0, 2147483647, pvComposite, '', 'ngEmprestimo', 'Exemplar', 1, 1, pvNone, True, False);
  if lRelationTicket <> nil then (piMetaModel.DefaultMetaModelPersistenceMap as acMetaModelPersistenceMapSql).NewOneToManyDbRelationMapRegisterTicket(lRelationTicket, 'ID_EXEMPLAR');
  
  lRelationTicket := piMetaModel.NewRelationRegisterTicket('ngGUITicket', 'SystemGUIs', 0, 2147483647, pvNone, 'System GUIs have GUI', 'ngSystemGUITickets', 'GUI', 1, 1, pvNone, True, False);
  if lRelationTicket <> nil then (piMetaModel.DefaultMetaModelPersistenceMap as acMetaModelPersistenceMapSql).NewOneToManyDbRelationMapRegisterTicket(lRelationTicket, 'IESPIDINTE');
  
  lRelationTicket := piMetaModel.NewRelationRegisterTicket('ngIcon', 'UseCases', 0, 2147483647, pvNone, 'Usecases have an icon', 'ngUseCaseTicket', 'Icon', 1, 1, pvNone, True, False);
  if lRelationTicket <> nil then (piMetaModel.DefaultMetaModelPersistenceMap as acMetaModelPersistenceMapSql).NewOneToManyDbRelationMapRegisterTicket(lRelationTicket, 'IESBIDCUIC');
  
  lRelationTicket := piMetaModel.NewRelationRegisterTicket('ngLivro', 'Exemplares', 0, 2147483647, pvComposite, '', 'ngExemplar', 'Livro', 1, 1, pvNone, True, False);
  if lRelationTicket <> nil then (piMetaModel.DefaultMetaModelPersistenceMap as acMetaModelPersistenceMapSql).NewOneToManyDbRelationMapRegisterTicket(lRelationTicket, 'ID_LIVRO');
  
  lRelationTicket := piMetaModel.NewRelationRegisterTicket('ngOperation', 'UseCaseOperations', 0, 2147483647, pvNone, 'UseCase operations has operation', 'ngUseCaseTicketOperation', 'Operation', 1, 1, pvNone, True, False);
  if lRelationTicket <> nil then (piMetaModel.DefaultMetaModelPersistenceMap as acMetaModelPersistenceMapSql).NewOneToManyDbRelationMapRegisterTicket(lRelationTicket, 'IESGIDOPER');
  
  lRelationTicket := piMetaModel.NewRelationRegisterTicket('ngProfile', 'UseCaseOperations', 0, 2147483647, pvNone, 'Profile has Usecase Operations', 'ngUseCaseTicketOperation', '', 0, 2147483647, pvNone, False, False);
  if lRelationTicket <> nil then (piMetaModel.DefaultMetaModelPersistenceMap as acMetaModelPersistenceMapSql).NewManyToManyDbRelationMapRegisterTicket(lRelationTicket, 'IESSIDPROF', 'IESGIDCUOP', 'IESTTOPPRO');
  
  lRelationTicket := piMetaModel.NewRelationRegisterTicket('ngProfile', 'UserProfiles', 0, 2147483647, pvNone, 'Profile has Users', 'ngUserProfile', 'Profile', 1, 1, pvNone, True, False);
  if lRelationTicket <> nil then (piMetaModel.DefaultMetaModelPersistenceMap as acMetaModelPersistenceMapSql).NewOneToManyDbRelationMapRegisterTicket(lRelationTicket, 'IESUIDPROF');
  
  lRelationTicket := piMetaModel.NewRelationRegisterTicket('ngSituacao', '', 0, 2147483647, pvNone, '', 'ngExemplar', 'Situacao', 1, 1, pvNone, False, False);
  if lRelationTicket <> nil then (piMetaModel.DefaultMetaModelPersistenceMap as acMetaModelPersistenceMapSql).NewOneToManyDbRelationMapRegisterTicket(lRelationTicket, 'ID_SITUACAO');
  
  lRelationTicket := piMetaModel.NewRelationRegisterTicket('ngSystem', 'SystemGUIs', 0, 2147483647, pvNone, 'System has GUIs', 'ngSystemGUITickets', 'System', 1, 1, pvNone, True, False);
  if lRelationTicket <> nil then (piMetaModel.DefaultMetaModelPersistenceMap as acMetaModelPersistenceMapSql).NewOneToManyDbRelationMapRegisterTicket(lRelationTicket, 'IESPIDSIST');
  
  lRelationTicket := piMetaModel.NewRelationRegisterTicket('ngSystem', 'Levels', 0, 2147483647, pvNone, 'System has Levels', 'ngLevel', 'System', 1, 1, pvNone, True, False);
  if lRelationTicket <> nil then (piMetaModel.DefaultMetaModelPersistenceMap as acMetaModelPersistenceMapSql).NewOneToManyDbRelationMapRegisterTicket(lRelationTicket, 'IESHIDSIST');
  
  lRelationTicket := piMetaModel.NewRelationRegisterTicket('ngSystem', '', 0, 2147483647, pvNone, 'System has Message', 'ngMessage', 'System', 1, 1, pvNone, False, False);
  if lRelationTicket <> nil then (piMetaModel.DefaultMetaModelPersistenceMap as acMetaModelPersistenceMapSql).NewOneToManyDbRelationMapRegisterTicket(lRelationTicket, 'IESRIDSIST');
  
  lRelationTicket := piMetaModel.NewRelationRegisterTicket('ngSystem', 'SystemUseCases', 0, 2147483647, pvNone, 'System has Usecases', 'ngSystemUseCaseTicket', 'System', 1, 1, pvNone, True, False);
  if lRelationTicket <> nil then (piMetaModel.DefaultMetaModelPersistenceMap as acMetaModelPersistenceMapSql).NewOneToManyDbRelationMapRegisterTicket(lRelationTicket, 'IESEIDSIST');
  
  lRelationTicket := piMetaModel.NewRelationRegisterTicket('ngSystem', 'Permissions', 0, 2147483647, pvNone, 'System has permissions', 'ngPermission', 'System', 1, 1, pvNone, True, False);
  if lRelationTicket <> nil then (piMetaModel.DefaultMetaModelPersistenceMap as acMetaModelPersistenceMapSql).NewOneToManyDbRelationMapRegisterTicket(lRelationTicket, 'SEGBIDSIST');
  
  lRelationTicket := piMetaModel.NewRelationRegisterTicket('ngSystem', 'Events', 0, 2147483647, pvNone, 'System has security events', 'ngEvent', '', 1, 1, pvNone, False, False);
  if lRelationTicket <> nil then (piMetaModel.DefaultMetaModelPersistenceMap as acMetaModelPersistenceMapSql).NewOneToManyDbRelationMapRegisterTicket(lRelationTicket, 'SEGCIDSIST');
  
  lRelationTicket := piMetaModel.NewRelationRegisterTicket('ngUseCaseTicket', 'SystemGUIs', 0, 2147483647, pvNone, 'UseCase has system GUIs', 'ngSystemGUITickets', 'UseCase', 1, 1, pvNone, True, False);
  if lRelationTicket <> nil then (piMetaModel.DefaultMetaModelPersistenceMap as acMetaModelPersistenceMapSql).NewOneToManyDbRelationMapRegisterTicket(lRelationTicket, 'IESPIDCASO');
  
  lRelationTicket := piMetaModel.NewRelationRegisterTicket('ngUseCaseTicket', 'UseCaseSystems', 0, 2147483647, pvNone, 'Usecas has systems', 'ngSystemUseCaseTicket', 'UseCase', 1, 1, pvNone, True, False);
  if lRelationTicket <> nil then (piMetaModel.DefaultMetaModelPersistenceMap as acMetaModelPersistenceMapSql).NewOneToManyDbRelationMapRegisterTicket(lRelationTicket, 'IESEIDCASO');
  
  lRelationTicket := piMetaModel.NewRelationRegisterTicket('ngUseCaseTicket', 'UseCaseOperations', 0, 2147483647, pvNone, 'Usecase has usecase operations', 'ngUseCaseTicketOperation', 'UseCase', 1, 1, pvNone, True, False);
  if lRelationTicket <> nil then (piMetaModel.DefaultMetaModelPersistenceMap as acMetaModelPersistenceMapSql).NewOneToManyDbRelationMapRegisterTicket(lRelationTicket, 'IESGIDCASO');
  
  lRelationTicket := piMetaModel.NewRelationRegisterTicket('ngUseCaseTicketOperation', 'Events', 0, 2147483647, pvNone, 'Use Case Operations have security events', 'ngEvent', '', 1, 1, pvNone, False, False);
  if lRelationTicket <> nil then (piMetaModel.DefaultMetaModelPersistenceMap as acMetaModelPersistenceMapSql).NewOneToManyDbRelationMapRegisterTicket(lRelationTicket, 'SEGCIDCUOP');
  
  lRelationTicket := piMetaModel.NewRelationRegisterTicket('ngUseCaseTicketOperation', 'Permissions', 0, 2147483647, pvNone, 'UseCase Operation has permissions', 'ngPermission', 'UseCaseOperation', 1, 1, pvNone, True, False);
  if lRelationTicket <> nil then (piMetaModel.DefaultMetaModelPersistenceMap as acMetaModelPersistenceMapSql).NewOneToManyDbRelationMapRegisterTicket(lRelationTicket, 'SEGBIDCUOP');
  
  lRelationTicket := piMetaModel.NewRelationRegisterTicket('ngUseCaseTicketOperation', 'Levels', 0, 2147483647, pvNone, 'Usecase Operations has levels', 'ngLevel', 'UseCaseOperations', 0, 2147483647, pvNone, True, False);
  if lRelationTicket <> nil then (piMetaModel.DefaultMetaModelPersistenceMap as acMetaModelPersistenceMapSql).NewManyToManyDbRelationMapRegisterTicket(lRelationTicket, 'IESIIDCUOP', 'IESIIDLEVE', 'IESITOPLEV');
  
  lRelationTicket := piMetaModel.NewRelationRegisterTicket('ngUsuario', 'Emprestimos', 0, 2147483647, pvNone, '', 'ngEmprestimo', 'Usuario', 1, 1, pvNone, True, False);
  if lRelationTicket <> nil then (piMetaModel.DefaultMetaModelPersistenceMap as acMetaModelPersistenceMapSql).NewOneToManyDbRelationMapRegisterTicket(lRelationTicket, 'ID_USUARIO');
  
end;

procedure NewUseCaseTicket_ucImportaConfiguracaoSistema_1327(piMetaModel: acMetaModel);
var
  lUseCaseTicket: acUseCaseTicket;
begin
  //Criao do UseCaseTicket ucImportaConfiguracaoSistema (1327)
    lUseCaseTicket := piMetaModel.NewUseCaseTicket('1327', nil, True);
    lUseCaseTicket.Name := 'ucImportaConfiguracaoSistema';
    lUseCaseTicket.InheritsFrom := 'ucUseCase';
end;

procedure NewUseCaseTicket_ucCadastroNatureza_1360(piMetaModel: acMetaModel);
var
  lUseCaseTicket: acUseCaseTicket;
begin
  //Criao do UseCaseTicket ucCadastroNatureza (1360)
    lUseCaseTicket := piMetaModel.NewUseCaseTicket('1360', nil, True);
    lUseCaseTicket.Name := 'ucCadastroNatureza';
    lUseCaseTicket.InheritsFrom := 'ucUseCase';
end;

procedure NewUseCaseTicket_ucDetalhesAtualizacaoSistema_1359(piMetaModel: acMetaModel);
var
  lUseCaseTicket: acUseCaseTicket;
begin
  //Criao do UseCaseTicket ucDetalhesAtualizacaoSistema (1359)
    lUseCaseTicket := piMetaModel.NewUseCaseTicket('1359', nil, True);
    lUseCaseTicket.Name := 'ucDetalhesAtualizacaoSistema';
    lUseCaseTicket.InheritsFrom := 'ucUseCase';
end;

procedure NewUseCaseTicket_ucControleAcesso_104(piMetaModel: acMetaModel);
var
  lUseCaseTicket: acUseCaseTicket;
begin
  //Criao do UseCaseTicket ucControleAcesso (104)
    lUseCaseTicket := piMetaModel.NewUseCaseTicket('104', nil, True);
    lUseCaseTicket.Name := 'ucControleAcesso';
    lUseCaseTicket.InheritsFrom := 'ucUseCase';
end;

procedure NewUseCaseTicket_ucExplorerV4_1432(piMetaModel: acMetaModel);
var
  lUseCaseTicket: acUseCaseTicket;
begin
  //Criao do UseCaseTicket ucExplorerV4 (1432)
    lUseCaseTicket := piMetaModel.NewUseCaseTicket('1432', nil, True);
    lUseCaseTicket.Name := 'ucExplorerV4';
    lUseCaseTicket.InheritsFrom := 'ucUseCase';
end;

procedure NewUseCaseTicket_ucCadastroPerfil_1963(piMetaModel: acMetaModel);
var
  lUseCaseTicket: acUseCaseTicket;
begin
  //Criao do UseCaseTicket ucCadastroPerfil (1963)
    lUseCaseTicket := piMetaModel.NewUseCaseTicket('1963', nil, False);
    lUseCaseTicket.Name := 'ucCadastroPerfil';
    lUseCaseTicket.InheritsFrom := 'ucUseCase';
end;

procedure NewUseCaseTicket_ucCadastroUsuarioSistema_101(piMetaModel: acMetaModel);
var
  lUseCaseTicket: acUseCaseTicket;
begin
  //Criao do UseCaseTicket ucCadastroUsuarioSistema (101)
    lUseCaseTicket := piMetaModel.NewUseCaseTicket('101', nil, True);
    lUseCaseTicket.Name := 'ucCadastroUsuarioSistema';
    lUseCaseTicket.InheritsFrom := 'ucUseCase';
end;

procedure NewUseCaseTicket_ucEfetuarEmprestimo_3220(piMetaModel: acMetaModel);
var
  lUseCaseTicket: acUseCaseTicket;
begin
  //Criao do UseCaseTicket ucEfetuarEmprestimo (3220)
    lUseCaseTicket := piMetaModel.NewUseCaseTicket('3220', nil, True);
    lUseCaseTicket.Name := 'ucEfetuarEmprestimo';
    lUseCaseTicket.InheritsFrom := 'ucUseCase';
end;

procedure NewUseCaseTicket_ucConsultarEmprestimo_3222(piMetaModel: acMetaModel);
var
  lUseCaseTicket: acUseCaseTicket;
begin
  //Criao do UseCaseTicket ucConsultarEmprestimo (3222)
    lUseCaseTicket := piMetaModel.NewUseCaseTicket('3222', nil, True);
    lUseCaseTicket.Name := 'ucConsultarEmprestimo';
    lUseCaseTicket.InheritsFrom := 'ucUseCase';
end;

procedure NewUseCaseTicket_ucCadastrarLivro_3226(piMetaModel: acMetaModel);
var
  lUseCaseTicket: acUseCaseTicket;
begin
  //Criao do UseCaseTicket ucCadastrarLivro (3226)
    lUseCaseTicket := piMetaModel.NewUseCaseTicket('3226', nil, True);
    lUseCaseTicket.Name := 'ucCadastrarLivro';
    lUseCaseTicket.InheritsFrom := 'ucUseCase';
end;

function GetXSDIn_3220_smucEfetuarEmprestimo_PesquisandoUsuario_RM_PESQUISAR_USUARIO: String;
begin
    Result := '<?xml version="1.0"?>' + #13#10 +
  '<!--Created with Liquid XML Studio 6.1.18.0 - FREE Community Edition (http://www.liquid-technologies.com)-->' + #13#10 +
  '<xs:schema elementFormDefault="qualified" xmlns:xs="http://www.w3.org/2001/XMLSchema">' + #13#10 +
  '	<xs:element name="SYSMSG">' + #13#10 +
  '		<xs:complexType>' + #13#10 +
  '			<xs:sequence>' + #13#10 +
  '				<xs:element name="Usuario">' + #13#10 +
  '					<xs:complexType>' + #13#10 +
  '						<xs:attribute name="Nome" type="xs:string" use="optional"/>' + #13#10 +
  '						<xs:attribute name="CPF" type="xs:string" use="optional"/>' + #13#10 +
  '						<xs:anyAttribute processContents="skip"/>' + #13#10 +
  '					</xs:complexType>' + #13#10 +
  '				</xs:element>' + #13#10 +
  '			</xs:sequence>' + #13#10 +
  '			<xs:anyAttribute processContents="skip"/>' + #13#10 +
  '		</xs:complexType>' + #13#10 +
  '	</xs:element>' + #13#10 +
  '</xs:schema>' + #13#10 +
  '';
end;

function GetXSDOut_3220_smucEfetuarEmprestimo_PesquisandoUsuario_RM_PESQUISAR_USUARIO: String;
begin
    Result := '<?xml version="1.0"?>' + #13#10 +
  '<!--Created with Liquid XML Studio 6.1.18.0 - FREE Community Edition (http://www.liquid-technologies.com)-->' + #13#10 +
  '<xs:schema elementFormDefault="qualified" xmlns:xs="http://www.w3.org/2001/XMLSchema">' + #13#10 +
  '	<xs:element name="SYSMSG">' + #13#10 +
  '		<xs:complexType>' + #13#10 +
  '			<xs:sequence>' + #13#10 +
  '				<xs:element name="Usuarios">' + #13#10 +
  '					<xs:complexType>' + #13#10 +
  '						<xs:sequence minOccurs="0" maxOccurs="unbounded">' + #13#10 +
  '							<xs:element name="Usuario">' + #13#10 +
  '								<xs:complexType>' + #13#10 +
  '									<xs:attribute name="OID" type="xs:int" use="required"/>' + #13#10 +
  '									<xs:attribute name="Nome" type="xs:string" use="required"/>' + #13#10 +
  '									<xs:attribute name="CPF" type="xs:string" use="required"/>' + #13#10 +
  '									<xs:anyAttribute processContents="skip"/>' + #13#10 +
  '								</xs:complexType>' + #13#10 +
  '							</xs:element>' + #13#10 +
  '						</xs:sequence>' + #13#10 +
  '					</xs:complexType>' + #13#10 +
  '				</xs:element>' + #13#10 +
  '			</xs:sequence>' + #13#10 +
  '			<xs:anyAttribute processContents="skip"/>' + #13#10 +
  '		</xs:complexType>' + #13#10 +
  '	</xs:element>' + #13#10 +
  '</xs:schema>' + #13#10 +
  '';
end;

function GetXSDIn_3220_smucEfetuarEmprestimo_EscolhendoUsuario_RM_ESCOLHER_USUARIO: String;
begin
    Result := '<?xml version="1.0"?>' + #13#10 +
  '<!--Created with Liquid XML Studio 6.1.18.0 - FREE Community Edition (http://www.liquid-technologies.com)-->' + #13#10 +
  '<xs:schema elementFormDefault="qualified" xmlns:xs="http://www.w3.org/2001/XMLSchema">' + #13#10 +
  '	<xs:element name="SYSMSG">' + #13#10 +
  '		<xs:complexType>' + #13#10 +
  '			<xs:sequence>' + #13#10 +
  '				<xs:element name="Usuario">' + #13#10 +
  '					<xs:complexType>' + #13#10 +
  '						<xs:attribute name="OID" type="xs:int" use="required"/>' + #13#10 +
  '						<xs:anyAttribute processContents="skip"/>' + #13#10 +
  '					</xs:complexType>' + #13#10 +
  '				</xs:element>' + #13#10 +
  '			</xs:sequence>' + #13#10 +
  '			<xs:anyAttribute processContents="skip"/>' + #13#10 +
  '		</xs:complexType>' + #13#10 +
  '	</xs:element>' + #13#10 +
  '</xs:schema>' + #13#10 +
  '';
end;

function GetXSDOut_3220_smucEfetuarEmprestimo_EscolhendoUsuario_RM_ESCOLHER_USUARIO: String;
begin
    Result := '<?xml version="1.0"?>' + #13#10 +
  '<!--Created with Liquid XML Studio 6.1.18.0 - FREE Community Edition (http://www.liquid-technologies.com)-->' + #13#10 +
  '<xs:schema elementFormDefault="qualified" xmlns:xs="http://www.w3.org/2001/XMLSchema">' + #13#10 +
  '	<xs:element name="SYSMSG">' + #13#10 +
  '		<xs:complexType>' + #13#10 +
  '			<xs:sequence>' + #13#10 +
  '				<xs:element name="Usuario">' + #13#10 +
  '					<xs:complexType>' + #13#10 +
  '						<xs:attribute name="OID" type="xs:int" use="required"/>' + #13#10 +
  '						<xs:attribute name="Nome" type="xs:string" use="required"/>' + #13#10 +
  '						<xs:attribute name="CPF" type="xs:string" use="required"/>' + #13#10 +
  '						<xs:anyAttribute processContents="skip"/>' + #13#10 +
  '					</xs:complexType>' + #13#10 +
  '				</xs:element>' + #13#10 +
  '			</xs:sequence>' + #13#10 +
  '			<xs:anyAttribute processContents="skip"/>' + #13#10 +
  '		</xs:complexType>' + #13#10 +
  '	</xs:element>' + #13#10 +
  '</xs:schema>' + #13#10 +
  '';
end;

function GetXSDIn_3220_smucEfetuarEmprestimo_EscolhendoUsuario_RM_PESQUISAR_USUARIO: String;
begin
    Result := '<?xml version="1.0"?>' + #13#10 +
  '<!--Created with Liquid XML Studio 6.1.18.0 - FREE Community Edition (http://www.liquid-technologies.com)-->' + #13#10 +
  '<xs:schema elementFormDefault="qualified" xmlns:xs="http://www.w3.org/2001/XMLSchema">' + #13#10 +
  '	<xs:element name="SYSMSG">' + #13#10 +
  '		<xs:complexType>' + #13#10 +
  '			<xs:sequence>' + #13#10 +
  '				<xs:element name="Usuario">' + #13#10 +
  '					<xs:complexType>' + #13#10 +
  '						<xs:attribute name="Nome" type="xs:string" use="optional"/>' + #13#10 +
  '						<xs:attribute name="CPF" type="xs:string" use="optional"/>' + #13#10 +
  '						<xs:anyAttribute processContents="skip"/>' + #13#10 +
  '					</xs:complexType>' + #13#10 +
  '				</xs:element>' + #13#10 +
  '			</xs:sequence>' + #13#10 +
  '			<xs:anyAttribute processContents="skip"/>' + #13#10 +
  '		</xs:complexType>' + #13#10 +
  '	</xs:element>' + #13#10 +
  '</xs:schema>' + #13#10 +
  '';
end;

function GetXSDOut_3220_smucEfetuarEmprestimo_EscolhendoUsuario_RM_PESQUISAR_USUARIO: String;
begin
    Result := '<?xml version="1.0"?>' + #13#10 +
  '<!--Created with Liquid XML Studio 6.1.18.0 - FREE Community Edition (http://www.liquid-technologies.com)-->' + #13#10 +
  '<xs:schema elementFormDefault="qualified" xmlns:xs="http://www.w3.org/2001/XMLSchema">' + #13#10 +
  '	<xs:element name="SYSMSG">' + #13#10 +
  '		<xs:complexType>' + #13#10 +
  '			<xs:sequence>' + #13#10 +
  '				<xs:element name="Usuarios">' + #13#10 +
  '					<xs:complexType>' + #13#10 +
  '						<xs:sequence minOccurs="0" maxOccurs="unbounded">' + #13#10 +
  '							<xs:element name="Usuario">' + #13#10 +
  '								<xs:complexType>' + #13#10 +
  '									<xs:attribute name="OID" type="xs:int" use="required"/>' + #13#10 +
  '									<xs:attribute name="Nome" type="xs:string" use="required"/>' + #13#10 +
  '									<xs:attribute name="CPF" type="xs:string" use="required"/>' + #13#10 +
  '									<xs:anyAttribute processContents="skip"/>' + #13#10 +
  '								</xs:complexType>' + #13#10 +
  '							</xs:element>' + #13#10 +
  '						</xs:sequence>' + #13#10 +
  '					</xs:complexType>' + #13#10 +
  '				</xs:element>' + #13#10 +
  '			</xs:sequence>' + #13#10 +
  '			<xs:anyAttribute processContents="skip"/>' + #13#10 +
  '		</xs:complexType>' + #13#10 +
  '	</xs:element>' + #13#10 +
  '</xs:schema>' + #13#10 +
  '';
end;

function GetXSDIn_3220_smucEfetuarEmprestimo_EditandoEmprestimos_RM_PESQUISAR_EXEMPLAR: String;
begin
    Result := '<?xml version="1.0"?>' + #13#10 +
  '<!--Created with Liquid XML Studio 6.1.18.0 - FREE Community Edition (http://www.liquid-technologies.com)-->' + #13#10 +
  '<xs:schema elementFormDefault="qualified" xmlns:xs="http://www.w3.org/2001/XMLSchema">' + #13#10 +
  '	<xs:element name="SYSMSG">' + #13#10 +
  '		<xs:complexType>' + #13#10 +
  '			<xs:sequence>' + #13#10 +
  '				<xs:element name="Exemplar">' + #13#10 +
  '					<xs:complexType>' + #13#10 +
  '						<xs:sequence>' + #13#10 +
  '							<xs:element minOccurs="0" name="Livro">' + #13#10 +
  '								<xs:complexType>' + #13#10 +
  '									<xs:attribute name="Titulo" type="xs:string"/>' + #13#10 +
  '									<xs:attribute name="ISBN" type="xs:string"/>' + #13#10 +
  '									<xs:anyAttribute processContents="skip"/>' + #13#10 +
  '								</xs:complexType>' + #13#10 +
  '							</xs:element>' + #13#10 +
  '						</xs:sequence>' + #13#10 +
  '						<xs:attribute name="Codigo" type="xs:string"/>' + #13#10 +
  '						<xs:anyAttribute processContents="skip"/>' + #13#10 +
  '					</xs:complexType>' + #13#10 +
  '				</xs:element>' + #13#10 +
  '			</xs:sequence>' + #13#10 +
  '			<xs:anyAttribute processContents="skip"/>' + #13#10 +
  '		</xs:complexType>' + #13#10 +
  '	</xs:element>' + #13#10 +
  '</xs:schema>' + #13#10 +
  '';
end;

function GetXSDOut_3220_smucEfetuarEmprestimo_EditandoEmprestimos_RM_PESQUISAR_EXEMPLAR: String;
begin
    Result := '<?xml version="1.0"?>' + #13#10 +
  '<!--Created with Liquid XML Studio 6.1.18.0 - FREE Community Edition (http://www.liquid-technologies.com)-->' + #13#10 +
  '<xs:schema elementFormDefault="qualified" xmlns:xs="http://www.w3.org/2001/XMLSchema">' + #13#10 +
  '	<xs:element name="SYSMSG">' + #13#10 +
  '		<xs:complexType>' + #13#10 +
  '			<xs:sequence>' + #13#10 +
  '				<xs:element name="Livros">' + #13#10 +
  '					<xs:complexType>' + #13#10 +
  '						<xs:sequence minOccurs="0" maxOccurs="unbounded">' + #13#10 +
  '							<xs:element name="Livro">' + #13#10 +
  '								<xs:complexType>' + #13#10 +
  '									<xs:sequence>' + #13#10 +
  '										<xs:element name="Exemplares">' + #13#10 +
  '											<xs:complexType>' + #13#10 +
  '												<xs:sequence minOccurs="0" maxOccurs="unbounded">' + #13#10 +
  '													<xs:element name="Exemplar">' + #13#10 +
  '														<xs:complexType>' + #13#10 +
  '															<xs:attribute name="OID" type="xs:int" use="required"/>' + #13#10 +
  '															<xs:attribute name="Codigo" type="xs:string" use="required"/>' + #13#10 +
  '															<xs:anyAttribute processContents="skip"/>' + #13#10 +
  '														</xs:complexType>' + #13#10 +
  '													</xs:element>' + #13#10 +
  '												</xs:sequence>' + #13#10 +
  '											</xs:complexType>' + #13#10 +
  '										</xs:element>' + #13#10 +
  '									</xs:sequence>' + #13#10 +
  '									<xs:attribute name="OID" type="xs:int" use="required"/>' + #13#10 +
  '									<xs:attribute name="Titulo" type="xs:string" use="required"/>' + #13#10 +
  '									<xs:attribute name="ISBN" type="xs:string" use="required"/>' + #13#10 +
  '									<xs:anyAttribute processContents="skip"/>' + #13#10 +
  '								</xs:complexType>' + #13#10 +
  '							</xs:element>' + #13#10 +
  '						</xs:sequence>' + #13#10 +
  '					</xs:complexType>' + #13#10 +
  '				</xs:element>' + #13#10 +
  '			</xs:sequence>' + #13#10 +
  '			<xs:anyAttribute processContents="skip"/>' + #13#10 +
  '		</xs:complexType>' + #13#10 +
  '	</xs:element>' + #13#10 +
  '</xs:schema>' + #13#10 +
  '';
end;

function GetXSDIn_3220_smucEfetuarEmprestimo_EditandoEmprestimos_RM_REMOVER_EXEMPLAR: String;
begin
    Result := '<?xml version="1.0"?>' + #13#10 +
  '<!--Created with Liquid XML Studio 6.1.18.0 - FREE Community Edition (http://www.liquid-technologies.com)-->' + #13#10 +
  '<xs:schema elementFormDefault="qualified" xmlns:xs="http://www.w3.org/2001/XMLSchema">' + #13#10 +
  '	<xs:element name="SYSMSG">' + #13#10 +
  '		<xs:complexType>' + #13#10 +
  '			<xs:sequence>' + #13#10 +
  '				<xs:element name="Exemplar">' + #13#10 +
  '					<xs:complexType>' + #13#10 +
  '						<xs:attribute name="OID" type="xs:int" use="required"/>' + #13#10 +
  '						<xs:anyAttribute processContents="skip"/>' + #13#10 +
  '					</xs:complexType>' + #13#10 +
  '				</xs:element>' + #13#10 +
  '			</xs:sequence>' + #13#10 +
  '			<xs:anyAttribute processContents="skip"/>' + #13#10 +
  '		</xs:complexType>' + #13#10 +
  '	</xs:element>' + #13#10 +
  '</xs:schema>' + #13#10 +
  '';
end;

function GetXSDOut_3220_smucEfetuarEmprestimo_EditandoEmprestimos_RM_REMOVER_EXEMPLAR: String;
begin
    Result := '<?xml version="1.0"?>' + #13#10 +
  '<!--Created with Liquid XML Studio 6.1.18.0 - FREE Community Edition (http://www.liquid-technologies.com)-->' + #13#10 +
  '<xs:schema elementFormDefault="qualified" xmlns:xs="http://www.w3.org/2001/XMLSchema">' + #13#10 +
  '	<xs:element name="SYSMSG">' + #13#10 +
  '		<xs:complexType>' + #13#10 +
  '			<xs:sequence>' + #13#10 +
  '				<xs:element name="Exemplares">' + #13#10 +
  '					<xs:complexType>' + #13#10 +
  '						<xs:sequence minOccurs="0" maxOccurs="unbounded">' + #13#10 +
  '							<xs:element name="Exemplar">' + #13#10 +
  '								<xs:complexType>' + #13#10 +
  '									<xs:sequence minOccurs="1" maxOccurs="1">' + #13#10 +
  '										<xs:element name="Livro">' + #13#10 +
  '											<xs:complexType>' + #13#10 +
  '												<xs:attribute name="OID" type="xs:int" use="required"/>' + #13#10 +
  '												<xs:attribute name="Titulo" type="xs:string" use="required"/>' + #13#10 +
  '												<xs:attribute name="ISBN" type="xs:string" use="required"/>' + #13#10 +
  '												<xs:anyAttribute processContents="skip"/>' + #13#10 +
  '											</xs:complexType>' + #13#10 +
  '										</xs:element>' + #13#10 +
  '									</xs:sequence>' + #13#10 +
  '									<xs:attribute name="OID" type="xs:int" use="required"/>' + #13#10 +
  '									<xs:attribute name="Codigo" type="xs:string" use="required"/>' + #13#10 +
  '									<xs:anyAttribute processContents="skip"/>' + #13#10 +
  '								</xs:complexType>' + #13#10 +
  '							</xs:element>' + #13#10 +
  '						</xs:sequence>' + #13#10 +
  '					</xs:complexType>' + #13#10 +
  '				</xs:element>' + #13#10 +
  '			</xs:sequence>' + #13#10 +
  '			<xs:anyAttribute processContents="skip"/>' + #13#10 +
  '		</xs:complexType>' + #13#10 +
  '	</xs:element>' + #13#10 +
  '</xs:schema>' + #13#10 +
  '';
end;

function GetXSDOut_3220_smucEfetuarEmprestimo_EditandoEmprestimos_RM_REALIZAR_EMPRESTIMO: String;
begin
    Result := '<?xml version="1.0"?>' + #13#10 +
  '<!--Created with Liquid XML Studio 6.1.18.0 - FREE Community Edition (http://www.liquid-technologies.com)-->' + #13#10 +
  '<xs:schema elementFormDefault="qualified" xmlns:xs="http://www.w3.org/2001/XMLSchema">' + #13#10 +
  '	<xs:element name="SYSMSG">' + #13#10 +
  '		<xs:complexType>' + #13#10 +
  '			<xs:sequence>' + #13#10 +
  '				<xs:element name="Emprestimos">' + #13#10 +
  '					<xs:complexType>' + #13#10 +
  '						<xs:sequence minOccurs="0" maxOccurs="unbounded">' + #13#10 +
  '							<xs:element name="Emprestimo">' + #13#10 +
  '								<xs:complexType>' + #13#10 +
  '									<xs:sequence>' + #13#10 +
  '										<xs:element name="Exemplar">' + #13#10 +
  '											<xs:complexType>' + #13#10 +
  '												<xs:sequence>' + #13#10 +
  '													<xs:element name="Livro">' + #13#10 +
  '														<xs:complexType>' + #13#10 +
  '															<xs:attribute name="Titulo" type="xs:string" use="required"/>' + #13#10 +
  '															<xs:attribute name="ISBN" type="xs:string" use="required"/>' + #13#10 +
  '															<xs:anyAttribute processContents="skip"/>' + #13#10 +
  '														</xs:complexType>' + #13#10 +
  '													</xs:element>' + #13#10 +
  '												</xs:sequence>' + #13#10 +
  '												<xs:attribute name="Codigo" type="xs:string" use="required"/>' + #13#10 +
  '												<xs:anyAttribute processContents="skip"/>' + #13#10 +
  '											</xs:complexType>' + #13#10 +
  '										</xs:element>' + #13#10 +
  '									</xs:sequence>' + #13#10 +
  '									<xs:attribute name="DataInicio" type="xs:date" use="required"/>' + #13#10 +
  '									<xs:attribute name="DataDevolucaoPrevista" type="xs:date" use="required"/>' + #13#10 +
  '									<xs:attribute name="OID" type="xs:string" use="required"/>' + #13#10 +
  '									<xs:anyAttribute processContents="skip"/>' + #13#10 +
  '								</xs:complexType>' + #13#10 +
  '							</xs:element>' + #13#10 +
  '						</xs:sequence>' + #13#10 +
  '						<xs:anyAttribute processContents="skip"/>' + #13#10 +
  '					</xs:complexType>' + #13#10 +
  '				</xs:element>' + #13#10 +
  '				<xs:element name="Cliente">' + #13#10 +
  '					<xs:complexType>' + #13#10 +
  '						<xs:attribute name="OID" type="xs:string" use="required"/>' + #13#10 +
  '						<xs:attribute name="Nome" type="xs:string" use="required"/>' + #13#10 +
  '						<xs:attribute name="CPF" type="xs:string" use="required"/>' + #13#10 +
  '						<xs:anyAttribute processContents="skip"/>' + #13#10 +
  '					</xs:complexType>' + #13#10 +
  '				</xs:element>' + #13#10 +
  '			</xs:sequence>' + #13#10 +
  '			<xs:anyAttribute processContents="skip"/>' + #13#10 +
  '		</xs:complexType>' + #13#10 +
  '	</xs:element>' + #13#10 +
  '</xs:schema>' + #13#10 +
  '';
end;

function GetXSDIn_3220_smucEfetuarEmprestimo_EscolhendoExemplares_RM_PESQUISAR_EXEMPLAR: String;
begin
    Result := '<?xml version="1.0"?>' + #13#10 +
  '<!--Created with Liquid XML Studio 6.1.18.0 - FREE Community Edition (http://www.liquid-technologies.com)-->' + #13#10 +
  '<xs:schema elementFormDefault="qualified" xmlns:xs="http://www.w3.org/2001/XMLSchema">' + #13#10 +
  '	<xs:element name="SYSMSG">' + #13#10 +
  '		<xs:complexType>' + #13#10 +
  '			<xs:sequence>' + #13#10 +
  '				<xs:element name="Exemplar">' + #13#10 +
  '					<xs:complexType>' + #13#10 +
  '						<xs:sequence>' + #13#10 +
  '							<xs:element minOccurs="0" name="Livro">' + #13#10 +
  '								<xs:complexType>' + #13#10 +
  '									<xs:attribute name="Titulo" type="xs:string"/>' + #13#10 +
  '									<xs:attribute name="ISBN" type="xs:string"/>' + #13#10 +
  '									<xs:anyAttribute processContents="skip"/>' + #13#10 +
  '								</xs:complexType>' + #13#10 +
  '							</xs:element>' + #13#10 +
  '						</xs:sequence>' + #13#10 +
  '						<xs:attribute name="Codigo" type="xs:string"/>' + #13#10 +
  '						<xs:anyAttribute processContents="skip"/>' + #13#10 +
  '					</xs:complexType>' + #13#10 +
  '				</xs:element>' + #13#10 +
  '			</xs:sequence>' + #13#10 +
  '			<xs:anyAttribute processContents="skip"/>' + #13#10 +
  '		</xs:complexType>' + #13#10 +
  '	</xs:element>' + #13#10 +
  '</xs:schema>' + #13#10 +
  '';
end;

function GetXSDOut_3220_smucEfetuarEmprestimo_EscolhendoExemplares_RM_PESQUISAR_EXEMPLAR: String;
begin
    Result := '<?xml version="1.0"?>' + #13#10 +
  '<!--Created with Liquid XML Studio 6.1.18.0 - FREE Community Edition (http://www.liquid-technologies.com)-->' + #13#10 +
  '<xs:schema elementFormDefault="qualified" xmlns:xs="http://www.w3.org/2001/XMLSchema">' + #13#10 +
  '	<xs:element name="SYSMSG">' + #13#10 +
  '		<xs:complexType>' + #13#10 +
  '			<xs:sequence>' + #13#10 +
  '				<xs:element name="Livros">' + #13#10 +
  '					<xs:complexType>' + #13#10 +
  '						<xs:sequence minOccurs="0" maxOccurs="unbounded">' + #13#10 +
  '							<xs:element name="Livro">' + #13#10 +
  '								<xs:complexType>' + #13#10 +
  '									<xs:sequence>' + #13#10 +
  '										<xs:element name="Exemplares">' + #13#10 +
  '											<xs:complexType>' + #13#10 +
  '												<xs:sequence minOccurs="0" maxOccurs="unbounded">' + #13#10 +
  '													<xs:element name="Exemplar">' + #13#10 +
  '														<xs:complexType>' + #13#10 +
  '															<xs:attribute name="OID" type="xs:int" use="required"/>' + #13#10 +
  '															<xs:attribute name="Codigo" type="xs:string" use="required"/>' + #13#10 +
  '															<xs:anyAttribute processContents="skip"/>' + #13#10 +
  '														</xs:complexType>' + #13#10 +
  '													</xs:element>' + #13#10 +
  '												</xs:sequence>' + #13#10 +
  '											</xs:complexType>' + #13#10 +
  '										</xs:element>' + #13#10 +
  '									</xs:sequence>' + #13#10 +
  '									<xs:attribute name="OID" type="xs:int" use="required"/>' + #13#10 +
  '									<xs:attribute name="Titulo" type="xs:string" use="required"/>' + #13#10 +
  '									<xs:attribute name="ISBN" type="xs:string" use="required"/>' + #13#10 +
  '									<xs:anyAttribute processContents="skip"/>' + #13#10 +
  '								</xs:complexType>' + #13#10 +
  '							</xs:element>' + #13#10 +
  '						</xs:sequence>' + #13#10 +
  '					</xs:complexType>' + #13#10 +
  '				</xs:element>' + #13#10 +
  '			</xs:sequence>' + #13#10 +
  '			<xs:anyAttribute processContents="skip"/>' + #13#10 +
  '		</xs:complexType>' + #13#10 +
  '	</xs:element>' + #13#10 +
  '</xs:schema>' + #13#10 +
  '';
end;

function GetXSDOut_3220_smucEfetuarEmprestimo_EscolhendoExemplares_RM_CANCELAR_ESCOLHA_EXEMPLAR: String;
begin
    Result := '<?xml version="1.0"?>' + #13#10 +
  '<!--Created with Liquid XML Studio 6.1.18.0 - FREE Community Edition (http://www.liquid-technologies.com)-->' + #13#10 +
  '<xs:schema elementFormDefault="qualified" xmlns:xs="http://www.w3.org/2001/XMLSchema">' + #13#10 +
  '	<xs:element name="SYSMSG">' + #13#10 +
  '		<xs:complexType>' + #13#10 +
  '			<xs:sequence>' + #13#10 +
  '				<xs:element name="Exemplares">' + #13#10 +
  '					<xs:complexType>' + #13#10 +
  '						<xs:sequence minOccurs="0" maxOccurs="unbounded">' + #13#10 +
  '							<xs:element name="Exemplar">' + #13#10 +
  '								<xs:complexType>' + #13#10 +
  '									<xs:sequence minOccurs="1" maxOccurs="1">' + #13#10 +
  '										<xs:element name="Livro">' + #13#10 +
  '											<xs:complexType>' + #13#10 +
  '												<xs:attribute name="OID" type="xs:int" use="required"/>' + #13#10 +
  '												<xs:attribute name="Titulo" type="xs:string" use="required"/>' + #13#10 +
  '												<xs:attribute name="ISBN" type="xs:string" use="required"/>' + #13#10 +
  '												<xs:anyAttribute processContents="skip"/>' + #13#10 +
  '											</xs:complexType>' + #13#10 +
  '										</xs:element>' + #13#10 +
  '									</xs:sequence>' + #13#10 +
  '									<xs:attribute name="OID" type="xs:int" use="required"/>' + #13#10 +
  '									<xs:attribute name="Codigo" type="xs:string" use="required"/>' + #13#10 +
  '									<xs:anyAttribute processContents="skip"/>' + #13#10 +
  '								</xs:complexType>' + #13#10 +
  '							</xs:element>' + #13#10 +
  '						</xs:sequence>' + #13#10 +
  '					</xs:complexType>' + #13#10 +
  '				</xs:element>' + #13#10 +
  '			</xs:sequence>' + #13#10 +
  '			<xs:anyAttribute processContents="skip"/>' + #13#10 +
  '		</xs:complexType>' + #13#10 +
  '	</xs:element>' + #13#10 +
  '</xs:schema>' + #13#10 +
  '';
end;

function GetXSDIn_3220_smucEfetuarEmprestimo_EscolhendoExemplares_RM_SELECIONAR_EXEMPLAR: String;
begin
    Result := '<?xml version="1.0"?>' + #13#10 +
  '<!--Created with Liquid XML Studio 6.1.18.0 - FREE Community Edition (http://www.liquid-technologies.com)-->' + #13#10 +
  '<xs:schema elementFormDefault="qualified" xmlns:xs="http://www.w3.org/2001/XMLSchema">' + #13#10 +
  '	<xs:element name="SYSMSG">' + #13#10 +
  '		<xs:complexType>' + #13#10 +
  '			<xs:sequence>' + #13#10 +
  '				<xs:element name="Exemplar">' + #13#10 +
  '					<xs:complexType>' + #13#10 +
  '						<xs:attribute name="OID" type="xs:int" use="required"/>' + #13#10 +
  '						<xs:anyAttribute processContents="skip"/>' + #13#10 +
  '					</xs:complexType>' + #13#10 +
  '				</xs:element>' + #13#10 +
  '			</xs:sequence>' + #13#10 +
  '			<xs:anyAttribute processContents="skip"/>' + #13#10 +
  '		</xs:complexType>' + #13#10 +
  '	</xs:element>' + #13#10 +
  '</xs:schema>' + #13#10 +
  '';
end;

function GetXSDOut_3220_smucEfetuarEmprestimo_EscolhendoExemplares_RM_SELECIONAR_EXEMPLAR: String;
begin
    Result := '<?xml version="1.0"?>' + #13#10 +
  '<!--Created with Liquid XML Studio 6.1.18.0 - FREE Community Edition (http://www.liquid-technologies.com)-->' + #13#10 +
  '<xs:schema elementFormDefault="qualified" xmlns:xs="http://www.w3.org/2001/XMLSchema">' + #13#10 +
  '	<xs:element name="SYSMSG">' + #13#10 +
  '		<xs:complexType>' + #13#10 +
  '			<xs:sequence>' + #13#10 +
  '				<xs:element name="Exemplares">' + #13#10 +
  '					<xs:complexType>' + #13#10 +
  '						<xs:sequence minOccurs="0" maxOccurs="unbounded">' + #13#10 +
  '							<xs:element name="Exemplar">' + #13#10 +
  '								<xs:complexType>' + #13#10 +
  '									<xs:sequence minOccurs="1" maxOccurs="1">' + #13#10 +
  '										<xs:element name="Livro">' + #13#10 +
  '											<xs:complexType>' + #13#10 +
  '												<xs:attribute name="OID" type="xs:int" use="required"/>' + #13#10 +
  '												<xs:attribute name="Titulo" type="xs:string" use="required"/>' + #13#10 +
  '												<xs:attribute name="ISBN" type="xs:string" use="required"/>' + #13#10 +
  '												<xs:anyAttribute processContents="skip"/>' + #13#10 +
  '											</xs:complexType>' + #13#10 +
  '										</xs:element>' + #13#10 +
  '									</xs:sequence>' + #13#10 +
  '									<xs:attribute name="OID" type="xs:int" use="required"/>' + #13#10 +
  '									<xs:attribute name="Codigo" type="xs:string" use="required"/>' + #13#10 +
  '									<xs:anyAttribute processContents="skip"/>' + #13#10 +
  '								</xs:complexType>' + #13#10 +
  '							</xs:element>' + #13#10 +
  '						</xs:sequence>' + #13#10 +
  '					</xs:complexType>' + #13#10 +
  '				</xs:element>' + #13#10 +
  '			</xs:sequence>' + #13#10 +
  '			<xs:anyAttribute processContents="skip"/>' + #13#10 +
  '		</xs:complexType>' + #13#10 +
  '	</xs:element>' + #13#10 +
  '</xs:schema>' + #13#10 +
  '';
end;

function GetXSDOut_3220_smucEfetuarEmprestimo_Confirmando_RM_CANCELAR_CONFIRMACAO: String;
begin
    Result := '<?xml version="1.0"?>' + #13#10 +
  '<!--Created with Liquid XML Studio 6.1.18.0 - FREE Community Edition (http://www.liquid-technologies.com)-->' + #13#10 +
  '<xs:schema elementFormDefault="qualified" xmlns:xs="http://www.w3.org/2001/XMLSchema">' + #13#10 +
  '	<xs:element name="SYSMSG">' + #13#10 +
  '		<xs:complexType>' + #13#10 +
  '			<xs:sequence>' + #13#10 +
  '				<xs:element name="Exemplares">' + #13#10 +
  '					<xs:complexType>' + #13#10 +
  '						<xs:sequence minOccurs="0" maxOccurs="unbounded">' + #13#10 +
  '							<xs:element name="Exemplar">' + #13#10 +
  '								<xs:complexType>' + #13#10 +
  '									<xs:sequence minOccurs="1" maxOccurs="1">' + #13#10 +
  '										<xs:element name="Livro">' + #13#10 +
  '											<xs:complexType>' + #13#10 +
  '												<xs:attribute name="OID" type="xs:int" use="required"/>' + #13#10 +
  '												<xs:attribute name="Titulo" type="xs:string" use="required"/>' + #13#10 +
  '												<xs:attribute name="ISBN" type="xs:string" use="required"/>' + #13#10 +
  '												<xs:anyAttribute processContents="skip"/>' + #13#10 +
  '											</xs:complexType>' + #13#10 +
  '										</xs:element>' + #13#10 +
  '									</xs:sequence>' + #13#10 +
  '									<xs:attribute name="OID" type="xs:int" use="required"/>' + #13#10 +
  '									<xs:attribute name="Codigo" type="xs:string" use="required"/>' + #13#10 +
  '									<xs:anyAttribute processContents="skip"/>' + #13#10 +
  '								</xs:complexType>' + #13#10 +
  '							</xs:element>' + #13#10 +
  '						</xs:sequence>' + #13#10 +
  '					</xs:complexType>' + #13#10 +
  '				</xs:element>' + #13#10 +
  '			</xs:sequence>' + #13#10 +
  '			<xs:anyAttribute processContents="skip"/>' + #13#10 +
  '		</xs:complexType>' + #13#10 +
  '	</xs:element>' + #13#10 +
  '</xs:schema>' + #13#10 +
  '';
end;

function GetXSDIn_3222_smucConsultarEmprestimo_Consultando_RM_CONSULTAR: String;
begin
    Result := '<?xml version="1.0"?>' + #13#10 +
  '<!--Created with Liquid XML Studio 6.1.18.0 - FREE Community Edition (http://www.liquid-technologies.com)-->' + #13#10 +
  '<xs:schema elementFormDefault="qualified" xmlns:xs="http://www.w3.org/2001/XMLSchema">' + #13#10 +
  '	<xs:element name="SYSMSG">' + #13#10 +
  '		<xs:complexType>' + #13#10 +
  '			<xs:sequence>' + #13#10 +
  '				<xs:element name="Usuario">' + #13#10 +
  '					<xs:complexType>' + #13#10 +
  '						<xs:attribute name="OID" type="xs:string" use="optional"/>' + #13#10 +
  '						<xs:attribute name="Nome" type="xs:string" use="optional"/>' + #13#10 +
  '						<xs:attribute name="CPF" type="xs:string" use="optional"/>' + #13#10 +
  '						<xs:anyAttribute processContents="skip"/>' + #13#10 +
  '					</xs:complexType>' + #13#10 +
  '				</xs:element>' + #13#10 +
  '			</xs:sequence>' + #13#10 +
  '			<xs:anyAttribute processContents="skip"/>' + #13#10 +
  '		</xs:complexType>' + #13#10 +
  '	</xs:element>' + #13#10 +
  '</xs:schema>' + #13#10 +
  '';
end;

function GetXSDOut_3222_smucConsultarEmprestimo_Consultando_RM_CONSULTAR: String;
begin
    Result := '<?xml version="1.0"?>' + #13#10 +
  '<!--Created with Liquid XML Studio 6.1.18.0 - FREE Community Edition (http://www.liquid-technologies.com)-->' + #13#10 +
  '<xs:schema elementFormDefault="qualified" xmlns:xs="http://www.w3.org/2001/XMLSchema">' + #13#10 +
  '	<xs:element name="SYSMSG">' + #13#10 +
  '		<xs:complexType>' + #13#10 +
  '			<xs:sequence>' + #13#10 +
  '				<xs:element name="Emprestimos">' + #13#10 +
  '					<xs:complexType>' + #13#10 +
  '						<xs:sequence minOccurs="0" maxOccurs="unbounded">' + #13#10 +
  '							<xs:element name="Emprestimo">' + #13#10 +
  '								<xs:complexType>' + #13#10 +
  '									<xs:sequence>' + #13#10 +
  '										<xs:element name="Usuario">' + #13#10 +
  '											<xs:complexType>' + #13#10 +
  '												<xs:attribute name="OID" type="xs:string" use="required"/>' + #13#10 +
  '												<xs:attribute name="Nome" type="xs:string" use="required"/>' + #13#10 +
  '												<xs:attribute name="CPF" type="xs:string" use="required"/>' + #13#10 +
  '												<xs:anyAttribute processContents="skip"/>' + #13#10 +
  '											</xs:complexType>' + #13#10 +
  '										</xs:element>' + #13#10 +
  '										<xs:element name="Exemplar">' + #13#10 +
  '											<xs:complexType>' + #13#10 +
  '												<xs:sequence>' + #13#10 +
  '													<xs:element name="Livro">' + #13#10 +
  '														<xs:complexType>' + #13#10 +
  '															<xs:attribute name="Titulo" type="xs:string" use="required"/>' + #13#10 +
  '															<xs:attribute name="ISBN" type="xs:string" use="required"/>' + #13#10 +
  '															<xs:anyAttribute processContents="skip"/>' + #13#10 +
  '														</xs:complexType>' + #13#10 +
  '													</xs:element>' + #13#10 +
  '												</xs:sequence>' + #13#10 +
  '												<xs:attribute name="Codigo" type="xs:string" use="required"/>' + #13#10 +
  '												<xs:anyAttribute processContents="skip"/>' + #13#10 +
  '											</xs:complexType>' + #13#10 +
  '										</xs:element>' + #13#10 +
  '									</xs:sequence>' + #13#10 +
  '									<xs:attribute name="DataInicio" type="xs:date" use="required"/>' + #13#10 +
  '									<xs:attribute name="DataDevolucaoPrevista" type="xs:date" use="required"/>' + #13#10 +
  '									<xs:attribute name="OID" type="xs:string" use="required"/>' + #13#10 +
  '									<xs:anyAttribute processContents="skip"/>' + #13#10 +
  '								</xs:complexType>' + #13#10 +
  '							</xs:element>' + #13#10 +
  '						</xs:sequence>' + #13#10 +
  '						<xs:anyAttribute processContents="skip"/>' + #13#10 +
  '					</xs:complexType>' + #13#10 +
  '				</xs:element>' + #13#10 +
  '			</xs:sequence>' + #13#10 +
  '			<xs:anyAttribute processContents="skip"/>' + #13#10 +
  '		</xs:complexType>' + #13#10 +
  '	</xs:element>' + #13#10 +
  '</xs:schema>' + #13#10 +
  '';
end;

function GetXSDOut_3226_smucCadastrarLivro_BuscandoLivro_RM_INCLUIR_LIVRO: String;
begin
    Result := '<?xml version="1.0"?>' + #13#10 +
  '<!--Created with Liquid XML Studio 6.1.18.0 - FREE Community Edition (http://www.liquid-technologies.com)-->' + #13#10 +
  '<xs:schema elementFormDefault="qualified" xmlns:xs="http://www.w3.org/2001/XMLSchema">' + #13#10 +
  '	<xs:element name="SYSMSG">' + #13#10 +
  '		<xs:complexType>' + #13#10 +
  '			<xs:sequence>' + #13#10 +
  '				<xs:element name="Livro">' + #13#10 +
  '					<xs:complexType>' + #13#10 +
  '						<xs:attribute name="OID" use="required" type="xs:string"/>' + #13#10 +
  '						<xs:anyAttribute processContents="skip"/>' + #13#10 +
  '					</xs:complexType>' + #13#10 +
  '				</xs:element>' + #13#10 +
  '			</xs:sequence>' + #13#10 +
  '			<xs:anyAttribute processContents="skip"/>' + #13#10 +
  '		</xs:complexType>' + #13#10 +
  '	</xs:element>' + #13#10 +
  '</xs:schema>' + #13#10 +
  '';
end;

function GetXSDIn_3226_smucCadastrarLivro_BuscandoLivro_RM_EDITAR_LIVRO: String;
begin
    Result := '<?xml version="1.0"?>' + #13#10 +
  '<!--Created with Liquid XML Studio 6.1.18.0 - FREE Community Edition (http://www.liquid-technologies.com)-->' + #13#10 +
  '<xs:schema elementFormDefault="qualified" xmlns:xs="http://www.w3.org/2001/XMLSchema">' + #13#10 +
  '	<xs:element name="SYSMSG">' + #13#10 +
  '		<xs:complexType>' + #13#10 +
  '			<xs:sequence>' + #13#10 +
  '				<xs:element name="Livro">' + #13#10 +
  '					<xs:complexType>' + #13#10 +
  '						<xs:attribute name="OID" use="required" type="xs:string"/>' + #13#10 +
  '						<xs:anyAttribute processContents="skip"/>' + #13#10 +
  '					</xs:complexType>' + #13#10 +
  '				</xs:element>' + #13#10 +
  '			</xs:sequence>' + #13#10 +
  '			<xs:anyAttribute processContents="skip"/>' + #13#10 +
  '		</xs:complexType>' + #13#10 +
  '	</xs:element>' + #13#10 +
  '</xs:schema>' + #13#10 +
  '';
end;

function GetXSDOut_3226_smucCadastrarLivro_BuscandoLivro_RM_EDITAR_LIVRO: String;
begin
    Result := '<?xml version="1.0"?>' + #13#10 +
  '<!--Created with Liquid XML Studio 6.1.18.0 - FREE Community Edition (http://www.liquid-technologies.com)-->' + #13#10 +
  '<xs:schema elementFormDefault="qualified" xmlns:xs="http://www.w3.org/2001/XMLSchema">' + #13#10 +
  '	<xs:element name="SYSMSG">' + #13#10 +
  '		<xs:complexType>' + #13#10 +
  '			<xs:sequence>' + #13#10 +
  '				<xs:element name="Livro">' + #13#10 +
  '					<xs:complexType>' + #13#10 +
  '						<xs:sequence>' + #13#10 +
  '							<xs:element name="Exemplares">' + #13#10 +
  '								<xs:complexType>' + #13#10 +
  '									<xs:sequence minOccurs="0" maxOccurs="unbounded">' + #13#10 +
  '										<xs:element name="Exemplar">' + #13#10 +
  '											<xs:complexType>' + #13#10 +
  '												<xs:attribute name="OID" type="xs:int" use="required"/>' + #13#10 +
  '												<xs:attribute name="Codigo" type="xs:string" use="required"/>' + #13#10 +
  '												<xs:anyAttribute processContents="skip"/>' + #13#10 +
  '											</xs:complexType>' + #13#10 +
  '										</xs:element>' + #13#10 +
  '									</xs:sequence>' + #13#10 +
  '								</xs:complexType>' + #13#10 +
  '							</xs:element>' + #13#10 +
  '						</xs:sequence>' + #13#10 +
  '						<xs:attribute name="OID" type="xs:int" use="required"/>' + #13#10 +
  '						<xs:attribute name="Titulo" type="xs:string" use="required"/>' + #13#10 +
  '						<xs:attribute name="ISBN" type="xs:string" use="required"/>' + #13#10 +
  '						<xs:attribute name="Edicao" type="xs:string" use="required"/>' + #13#10 +
  '						<xs:anyAttribute processContents="skip"/>' + #13#10 +
  '					</xs:complexType>' + #13#10 +
  '				</xs:element>' + #13#10 +
  '			</xs:sequence>' + #13#10 +
  '			<xs:anyAttribute processContents="skip"/>' + #13#10 +
  '		</xs:complexType>' + #13#10 +
  '	</xs:element>' + #13#10 +
  '</xs:schema>' + #13#10 +
  '';
end;

function GetXSDIn_3226_smucCadastrarLivro_BuscandoLivro_RM_BUSCAR_LIVRO: String;
begin
    Result := '<?xml version="1.0"?>' + #13#10 +
  '<!--Created with Liquid XML Studio 6.1.18.0 - FREE Community Edition (http://www.liquid-technologies.com)-->' + #13#10 +
  '<xs:schema elementFormDefault="qualified" xmlns:xs="http://www.w3.org/2001/XMLSchema">' + #13#10 +
  '	<xs:element name="SYSMSG">' + #13#10 +
  '		<xs:complexType>' + #13#10 +
  '			<xs:sequence>' + #13#10 +
  '				<xs:element name="Livro">' + #13#10 +
  '					<xs:complexType>' + #13#10 +
  '						<xs:attribute name="ISBN" use="optional" type="xs:string"/>' + #13#10 +
  '						<xs:attribute name="Titulo" use="optional" type="xs:string"/>' + #13#10 +
  '						<xs:attribute name="Edicao" use="optional" type="xs:string"/>' + #13#10 +
  '						<xs:anyAttribute processContents="skip"/>' + #13#10 +
  '					</xs:complexType>' + #13#10 +
  '				</xs:element>' + #13#10 +
  '			</xs:sequence>' + #13#10 +
  '			<xs:anyAttribute processContents="skip"/>' + #13#10 +
  '		</xs:complexType>' + #13#10 +
  '	</xs:element>' + #13#10 +
  '</xs:schema>' + #13#10 +
  '';
end;

function GetXSDOut_3226_smucCadastrarLivro_BuscandoLivro_RM_BUSCAR_LIVRO: String;
begin
    Result := '<?xml version="1.0"?>' + #13#10 +
  '<!--Created with Liquid XML Studio 6.1.18.0 - FREE Community Edition (http://www.liquid-technologies.com)-->' + #13#10 +
  '<xs:schema elementFormDefault="qualified" xmlns:xs="http://www.w3.org/2001/XMLSchema">' + #13#10 +
  '	<xs:element name="SYSMSG">' + #13#10 +
  '		<xs:complexType>' + #13#10 +
  '			<xs:sequence>' + #13#10 +
  '				<xs:element name="Livros">' + #13#10 +
  '					<xs:complexType>' + #13#10 +
  '						<xs:sequence minOccurs="0" maxOccurs="unbounded">' + #13#10 +
  '							<xs:element name="Livro">' + #13#10 +
  '								<xs:complexType>' + #13#10 +
  '									<xs:attribute name="Titulo" type="xs:string" use="required"/>' + #13#10 +
  '									<xs:attribute name="ISBN" type="xs:string" use="required"/>' + #13#10 +
  '									<xs:attribute name="Edicao" type="xs:string" use="required"/>' + #13#10 +
  '									<xs:anyAttribute processContents="skip"/>' + #13#10 +
  '								</xs:complexType>' + #13#10 +
  '							</xs:element>' + #13#10 +
  '						</xs:sequence>' + #13#10 +
  '					</xs:complexType>' + #13#10 +
  '				</xs:element>' + #13#10 +
  '			</xs:sequence>' + #13#10 +
  '			<xs:anyAttribute processContents="skip"/>' + #13#10 +
  '		</xs:complexType>' + #13#10 +
  '	</xs:element>' + #13#10 +
  '</xs:schema>' + #13#10 +
  '';
end;

function GetXSDIn_3226_smucCadastrarLivro_BuscandoLivro_RM_EXCLUIR_LIVRO: String;
begin
    Result := '<?xml version="1.0"?>' + #13#10 +
  '<!--Created with Liquid XML Studio 6.1.18.0 - FREE Community Edition (http://www.liquid-technologies.com)-->' + #13#10 +
  '<xs:schema elementFormDefault="qualified" xmlns:xs="http://www.w3.org/2001/XMLSchema">' + #13#10 +
  '	<xs:element name="SYSMSG">' + #13#10 +
  '		<xs:complexType>' + #13#10 +
  '			<xs:sequence>' + #13#10 +
  '				<xs:element name="Livro">' + #13#10 +
  '					<xs:complexType>' + #13#10 +
  '						<xs:attribute name="OID" use="required" type="xs:string"/>' + #13#10 +
  '						<xs:anyAttribute processContents="skip"/>' + #13#10 +
  '					</xs:complexType>' + #13#10 +
  '				</xs:element>' + #13#10 +
  '			</xs:sequence>' + #13#10 +
  '			<xs:anyAttribute processContents="skip"/>' + #13#10 +
  '		</xs:complexType>' + #13#10 +
  '	</xs:element>' + #13#10 +
  '</xs:schema>' + #13#10 +
  '';
end;

function GetXSDOut_3226_smucCadastrarLivro_BuscandoLivro_RM_EXCLUIR_LIVRO: String;
begin
    Result := '<?xml version="1.0"?>' + #13#10 +
  '<!--Created with Liquid XML Studio 6.1.18.0 - FREE Community Edition (http://www.liquid-technologies.com)-->' + #13#10 +
  '<xs:schema elementFormDefault="qualified" xmlns:xs="http://www.w3.org/2001/XMLSchema">' + #13#10 +
  '	<xs:element name="SYSMSG">' + #13#10 +
  '		<xs:complexType>' + #13#10 +
  '			<xs:sequence>' + #13#10 +
  '				<xs:element name="Livros">' + #13#10 +
  '					<xs:complexType>' + #13#10 +
  '						<xs:sequence minOccurs="0" maxOccurs="unbounded">' + #13#10 +
  '							<xs:element name="Livro">' + #13#10 +
  '								<xs:complexType>' + #13#10 +
  '									<xs:attribute name="Titulo" type="xs:string" use="required"/>' + #13#10 +
  '									<xs:attribute name="ISBN" type="xs:string" use="required"/>' + #13#10 +
  '									<xs:attribute name="Edicao" type="xs:string" use="required"/>' + #13#10 +
  '									<xs:anyAttribute processContents="skip"/>' + #13#10 +
  '								</xs:complexType>' + #13#10 +
  '							</xs:element>' + #13#10 +
  '						</xs:sequence>' + #13#10 +
  '					</xs:complexType>' + #13#10 +
  '				</xs:element>' + #13#10 +
  '			</xs:sequence>' + #13#10 +
  '			<xs:anyAttribute processContents="skip"/>' + #13#10 +
  '		</xs:complexType>' + #13#10 +
  '	</xs:element>' + #13#10 +
  '</xs:schema>' + #13#10 +
  '';
end;

function GetXSDIn_3226_smucCadastrarLivro_CadastrandoLivro_RM_INCLUIR_EXEMPLAR: String;
begin
    Result := '<?xml version="1.0"?>' + #13#10 +
  '<!--Created with Liquid XML Studio 6.1.18.0 - FREE Community Edition (http://www.liquid-technologies.com)-->' + #13#10 +
  '<xs:schema elementFormDefault="qualified" xmlns:xs="http://www.w3.org/2001/XMLSchema">' + #13#10 +
  '	<xs:element name="SYSMSG">' + #13#10 +
  '		<xs:complexType>' + #13#10 +
  '			<xs:sequence>' + #13#10 +
  '				<xs:element name="Exemplar">' + #13#10 +
  '					<xs:complexType>' + #13#10 +
  '						<xs:attribute name="Codigo" type="xs:string" use="required"/>' + #13#10 +
  '						<xs:anyAttribute processContents="skip"/>' + #13#10 +
  '					</xs:complexType>' + #13#10 +
  '				</xs:element>' + #13#10 +
  '			</xs:sequence>' + #13#10 +
  '			<xs:anyAttribute processContents="skip"/>' + #13#10 +
  '		</xs:complexType>' + #13#10 +
  '	</xs:element>' + #13#10 +
  '</xs:schema>' + #13#10 +
  '';
end;

function GetXSDOut_3226_smucCadastrarLivro_CadastrandoLivro_RM_INCLUIR_EXEMPLAR: String;
begin
    Result := '<?xml version="1.0"?>' + #13#10 +
  '<!--Created with Liquid XML Studio 6.1.18.0 - FREE Community Edition (http://www.liquid-technologies.com)-->' + #13#10 +
  '<xs:schema elementFormDefault="qualified" xmlns:xs="http://www.w3.org/2001/XMLSchema">' + #13#10 +
  '	<xs:element name="SYSMSG">' + #13#10 +
  '		<xs:complexType>' + #13#10 +
  '			<xs:sequence>' + #13#10 +
  '				<xs:element name="Exemplares">' + #13#10 +
  '					<xs:complexType>' + #13#10 +
  '						<xs:sequence minOccurs="0" maxOccurs="unbounded">' + #13#10 +
  '							<xs:element name="Exemplar">' + #13#10 +
  '								<xs:complexType>' + #13#10 +
  '									<xs:attribute name="OID" type="xs:int" use="required"/>' + #13#10 +
  '									<xs:attribute name="Codigo" type="xs:string" use="required"/>' + #13#10 +
  '									<xs:anyAttribute processContents="skip"/>' + #13#10 +
  '								</xs:complexType>' + #13#10 +
  '							</xs:element>' + #13#10 +
  '						</xs:sequence>' + #13#10 +
  '					</xs:complexType>' + #13#10 +
  '				</xs:element>' + #13#10 +
  '			</xs:sequence>' + #13#10 +
  '			<xs:anyAttribute processContents="skip"/>' + #13#10 +
  '		</xs:complexType>' + #13#10 +
  '	</xs:element>' + #13#10 +
  '</xs:schema>' + #13#10 +
  '';
end;

function GetXSDIn_3226_smucCadastrarLivro_CadastrandoLivro_RM_CONCLUIR_CADASTRO: String;
begin
    Result := '<?xml version="1.0"?>' + #13#10 +
  '<!--Created with Liquid XML Studio 6.1.18.0 - FREE Community Edition (http://www.liquid-technologies.com)-->' + #13#10 +
  '<xs:schema elementFormDefault="qualified" xmlns:xs="http://www.w3.org/2001/XMLSchema">' + #13#10 +
  '	<xs:element name="SYSMSG">' + #13#10 +
  '		<xs:complexType>' + #13#10 +
  '			<xs:sequence>' + #13#10 +
  '				<xs:element name="Livro">' + #13#10 +
  '					<xs:complexType>' + #13#10 +
  '						<xs:attribute name="Titulo" type="xs:string" use="required"/>' + #13#10 +
  '						<xs:attribute name="ISBN" type="xs:string" use="required"/>' + #13#10 +
  '						<xs:attribute name="Edicao" type="xs:string" use="required"/>' + #13#10 +
  '						<xs:anyAttribute processContents="skip"/>' + #13#10 +
  '					</xs:complexType>' + #13#10 +
  '				</xs:element>' + #13#10 +
  '			</xs:sequence>' + #13#10 +
  '			<xs:anyAttribute processContents="skip"/>' + #13#10 +
  '		</xs:complexType>' + #13#10 +
  '	</xs:element>' + #13#10 +
  '</xs:schema>' + #13#10 +
  '';
end;

function GetXSDOut_3226_smucCadastrarLivro_CadastrandoLivro_RM_CONCLUIR_CADASTRO: String;
begin
    Result := '<?xml version="1.0"?>' + #13#10 +
  '<!--Created with Liquid XML Studio 6.1.18.0 - FREE Community Edition (http://www.liquid-technologies.com)-->' + #13#10 +
  '<xs:schema elementFormDefault="qualified" xmlns:xs="http://www.w3.org/2001/XMLSchema">' + #13#10 +
  '	<xs:element name="SYSMSG">' + #13#10 +
  '		<xs:complexType>' + #13#10 +
  '			<xs:sequence>' + #13#10 +
  '				<xs:element name="Livro">' + #13#10 +
  '					<xs:complexType>' + #13#10 +
  '						<xs:sequence>' + #13#10 +
  '							<xs:element name="Exemplares">' + #13#10 +
  '								<xs:complexType>' + #13#10 +
  '									<xs:sequence minOccurs="0" maxOccurs="unbounded">' + #13#10 +
  '										<xs:element name="Exemplar">' + #13#10 +
  '											<xs:complexType>' + #13#10 +
  '												<xs:attribute name="OID" type="xs:int" use="required"/>' + #13#10 +
  '												<xs:attribute name="Codigo" type="xs:string" use="required"/>' + #13#10 +
  '												<xs:anyAttribute processContents="skip"/>' + #13#10 +
  '											</xs:complexType>' + #13#10 +
  '										</xs:element>' + #13#10 +
  '									</xs:sequence>' + #13#10 +
  '								</xs:complexType>' + #13#10 +
  '							</xs:element>' + #13#10 +
  '						</xs:sequence>' + #13#10 +
  '						<xs:attribute name="OID" type="xs:int" use="required"/>' + #13#10 +
  '						<xs:attribute name="Titulo" type="xs:string" use="required"/>' + #13#10 +
  '						<xs:attribute name="ISBN" type="xs:string" use="required"/>' + #13#10 +
  '						<xs:attribute name="Edicao" type="xs:string" use="required"/>' + #13#10 +
  '						<xs:anyAttribute processContents="skip"/>' + #13#10 +
  '					</xs:complexType>' + #13#10 +
  '				</xs:element>' + #13#10 +
  '			</xs:sequence>' + #13#10 +
  '			<xs:anyAttribute processContents="skip"/>' + #13#10 +
  '		</xs:complexType>' + #13#10 +
  '	</xs:element>' + #13#10 +
  '</xs:schema>' + #13#10 +
  '';
end;

procedure RegisterUseCases1(piMetaModel: acMetaModel);
var
  lUseCaseTicket: acUseCaseTicket;
  lSubMachineUseCaseTicket: acUseCaseTicket;
  lStateMachine: acUseCaseStateMachine;
  lSubMachineState: utSubMachineState;
  lState: utState;
  lTransition: utTransition;
begin
    NewUseCaseTicket_ucImportaConfiguracaoSistema_1327(piMetaModel);
    NewUseCaseTicket_ucCadastroNatureza_1360(piMetaModel);
    NewUseCaseTicket_ucDetalhesAtualizacaoSistema_1359(piMetaModel);
    NewUseCaseTicket_ucControleAcesso_104(piMetaModel);
    NewUseCaseTicket_ucExplorerV4_1432(piMetaModel);
    NewUseCaseTicket_ucCadastroPerfil_1963(piMetaModel);
    NewUseCaseTicket_ucCadastroUsuarioSistema_101(piMetaModel);
    NewUseCaseTicket_ucEfetuarEmprestimo_3220(piMetaModel);
    NewUseCaseTicket_ucConsultarEmprestimo_3222(piMetaModel);
    NewUseCaseTicket_ucCadastrarLivro_3226(piMetaModel);
  
    //Gerando StateMachine para o casu de uso 'ucImportaConfiguracaoSistema'
    lUseCaseTicket := piMetaModel.UseCaseTicketByCode['1327'];
    lStateMachine := lUseCaseTicket.StateMachine;
  
    lStateMachine.Name := 'smServer';
    utState.Create(lStateMachine, 'Initializing');
    lSubMachineState := utSubMachineState.Create(lStateMachine, 'UseCaseSubmachine');
    lSubMachineUseCaseTicket := piMetaModel.UseCaseTicketByCode['1327'];
    lSubMachineState.StateMachine := acUseCaseStateMachine.Create(lSubMachineUseCaseTicket, lSubMachineState);
    utFinalState.Create(lStateMachine, 'smBase_FinalState');
  
  //Define o InitialState do StateMachine
    lStateMachine.InitialState := lStateMachine.FindState('Initializing');
  
  //Adiciona as transicoes dos estados
    lState := lStateMachine.FindState('Initializing');
    lTransition := lState.NewOutgoingTransition('READY');
    lTransition.SourceState := lState;
    lTransition.TargetState := lStateMachine.FindState('UseCaseSubmachine');
    lTransition.AddTrigger('READY');
  
    lState := lStateMachine.FindState('UseCaseSubmachine');
    lTransition := lState.NewOutgoingTransition('ABORT');
    lTransition.SourceState := lState;
    lTransition.TargetState := lStateMachine.FindState('smBase_FinalState');
    lTransition.AddTrigger('UM_ABORT','4');
    lTransition.AddEffect('EFFECT_Abort');
    lTransition := lState.NewOutgoingTransition('TIMEOUTCHECK');
    lTransition.SourceState := lState;
    lTransition.TargetState := lState;
    lTransition.AddTrigger('RM_TIMEOUT_CHECK','16');
    lTransition.AddEffect('EFFECT_TimeOutCheck');
    lTransition := lState.NewOutgoingTransition('GETTRIGGERSFROMCURRENTSTATE');
    lTransition.SourceState := lState;
    lTransition.TargetState := lState;
    lTransition.AddTrigger('RM_GET_TRIGGERS_FROM_CURRENT_STATE');
    lTransition.AddEffect('EFFECT_GetTriggersFromCurrentState');
    lTransition := lState.NewOutgoingTransition('GETXSDBYTRIGGERFROMCURRENTSTATE');
    lTransition.SourceState := lState;
    lTransition.TargetState := lState;
    lTransition.AddTrigger('RM_GET_XSD_BY_TRIGGER_FROM_CURRENT_STATE');
    lTransition.AddEffect('EFFECT_GetXSDByTriggerFromCurrentState');
  
  
  // SUBSTATEMACHINE smImportaConfiguracaoSistema ///////////////////////
    lStateMachine := lUseCaseTicket.FindStateMachine('smServer');
    lStateMachine := utSubMachineState(lStateMachine.FindState('UseCaseSubmachine')).StateMachine as acUseCaseStateMachine;
    lStateMachine.Name := 'smImportaConfiguracaoSistema';
    utState.Create(lStateMachine, 'AguardandoXML');
    utState.Create(lStateMachine, 'XMLCarregado_AlteracoesMapeadas');
    utFinalState.Create(lStateMachine, 'FinalState1');
  
  //Define o InitialState do StateMachine
    lStateMachine.InitialState := lStateMachine.FindState('AguardandoXML');
  
  //Adiciona as transicoes dos estados
    lState := lStateMachine.FindState('AguardandoXML');
    lTransition := lState.NewOutgoingTransition('RM_CARREGARXML');
    lTransition.SourceState := lState;
    lTransition.TargetState := lStateMachine.FindState('XMLCarregado_AlteracoesMapeadas');
    lTransition.AddTrigger('RM_CARREGARXML');
    lTransition.AddEffect('EFFECT_CARREGARXML');
    lTransition := lState.NewOutgoingTransition('RM_IMPORTA_CONFIGURACAO');
    lTransition.SourceState := lState;
    lTransition.TargetState := lStateMachine.FindState('FinalState1');
    lTransition.AddTrigger('RM_IMPORTA_CONFIGURACAO');
    lTransition.AddEffect('EFFECT_IMPORTA_CONFIGURACAO');
  
    lState := lStateMachine.FindState('XMLCarregado_AlteracoesMapeadas');
    lTransition := lState.NewOutgoingTransition('RM_APLICAR_ALTERACOES');
    lTransition.SourceState := lState;
    lTransition.TargetState := lStateMachine.FindState('FinalState1');
    lTransition.AddTrigger('RM_APLICAR_ALTERACOES');
    lTransition.AddEffect('EFFECT_APLICAR_ALTERACOES');
  
  
  
    //Gerando StateMachine para o casu de uso 'ucCadastroNatureza'
    lUseCaseTicket := piMetaModel.UseCaseTicketByCode['1360'];
    lStateMachine := lUseCaseTicket.StateMachine;
  
    lStateMachine.Name := 'smServer';
    utState.Create(lStateMachine, 'Initializing');
    lSubMachineState := utSubMachineState.Create(lStateMachine, 'UseCaseSubmachine');
    lSubMachineUseCaseTicket := piMetaModel.UseCaseTicketByCode['1360'];
    lSubMachineState.StateMachine := acUseCaseStateMachine.Create(lSubMachineUseCaseTicket, lSubMachineState);
    utFinalState.Create(lStateMachine, 'smBase_FinalState');
  
  //Define o InitialState do StateMachine
    lStateMachine.InitialState := lStateMachine.FindState('Initializing');
  
  //Adiciona as transicoes dos estados
    lState := lStateMachine.FindState('Initializing');
    lTransition := lState.NewOutgoingTransition('READY');
    lTransition.SourceState := lState;
    lTransition.TargetState := lStateMachine.FindState('UseCaseSubmachine');
    lTransition.AddTrigger('READY');
  
    lState := lStateMachine.FindState('UseCaseSubmachine');
    lTransition := lState.NewOutgoingTransition('ABORT');
    lTransition.SourceState := lState;
    lTransition.TargetState := lStateMachine.FindState('smBase_FinalState');
    lTransition.AddTrigger('UM_ABORT','4');
    lTransition.AddEffect('EFFECT_Abort');
    lTransition := lState.NewOutgoingTransition('TIMEOUTCHECK');
    lTransition.SourceState := lState;
    lTransition.TargetState := lState;
    lTransition.AddTrigger('RM_TIMEOUT_CHECK','16');
    lTransition.AddEffect('EFFECT_TimeOutCheck');
    lTransition := lState.NewOutgoingTransition('GETTRIGGERSFROMCURRENTSTATE');
    lTransition.SourceState := lState;
    lTransition.TargetState := lState;
    lTransition.AddTrigger('RM_GET_TRIGGERS_FROM_CURRENT_STATE');
    lTransition.AddEffect('EFFECT_GetTriggersFromCurrentState');
    lTransition := lState.NewOutgoingTransition('GETXSDBYTRIGGERFROMCURRENTSTATE');
    lTransition.SourceState := lState;
    lTransition.TargetState := lState;
    lTransition.AddTrigger('RM_GET_XSD_BY_TRIGGER_FROM_CURRENT_STATE');
    lTransition.AddEffect('EFFECT_GetXSDByTriggerFromCurrentState');
  
  
  // SUBSTATEMACHINE smCadastroNatureza ///////////////////////
    lStateMachine := lUseCaseTicket.FindStateMachine('smServer');
    lStateMachine := utSubMachineState(lStateMachine.FindState('UseCaseSubmachine')).StateMachine as acUseCaseStateMachine;
    lStateMachine.Name := 'smCadastroNatureza';
    utState.Create(lStateMachine, 'stEditando');
    utState.Create(lStateMachine, 'stConsultando');
    utState.Create(lStateMachine, 'stAguardando');
  
  //Define o InitialState do StateMachine
    lStateMachine.InitialState := lStateMachine.FindState('stEditando');
  
  //Adiciona as transicoes dos estados
    lState := lStateMachine.FindState('stEditando');
    lTransition := lState.NewOutgoingTransition('RM_OBTEM_CONTEXTO');
    lTransition.SourceState := lState;
    lTransition.TargetState := lState;
    lTransition.AddTrigger('RM_OBTEM_CONTEXTO');
    lTransition.AddEffect('EFFECT_MontaContexto');
    lTransition := lState.NewOutgoingTransition('RM_SALVA_OBJETO');
    lTransition.GuardCondition := 'GUARD_ValidaObjeto';
    lTransition.SourceState := lState;
    lTransition.TargetState := lStateMachine.FindState('stConsultando');
    lTransition.AddTrigger('RM_SALVA_OBJETO');
    lTransition.AddEffect('EFFECT_SalvaObjeto');
    lTransition := lState.NewOutgoingTransition('RM_EXCLUI_OBJETO');
    lTransition.SourceState := lState;
    lTransition.TargetState := lStateMachine.FindState('stAguardando');
    lTransition.AddTrigger('RM_EXCLUI_OBJETO');
    lTransition.AddEffect('EFFECT_ExcluiObjeto');
    lTransition := lState.NewOutgoingTransition('RM_VALIDA_OBJETO');
    lTransition.GuardCondition := 'GUARD_ValidaObjeto';
    lTransition.SourceState := lState;
    lTransition.TargetState := lState;
    lTransition.AddTrigger('RM_VALIDA_OBJETO');
  
    lState := lStateMachine.FindState('stConsultando');
    lTransition := lState.NewOutgoingTransition('RM_INCLUI_OBJETO');
    lTransition.SourceState := lState;
    lTransition.TargetState := lStateMachine.FindState('stEditando');
    lTransition.AddTrigger('RM_INCLUI_OBJETO');
    lTransition.AddEffect('EFFECT_IncluiObjeto');
    lTransition := lState.NewOutgoingTransition('RM_EDITA_OBJETO');
    lTransition.SourceState := lState;
    lTransition.TargetState := lStateMachine.FindState('stEditando');
    lTransition.AddTrigger('RM_EDITA_OBJETO');
    lTransition.AddEffect('EFFECT_MontaContexto');
    lTransition := lState.NewOutgoingTransition('RM_EXCLUI_OBJETO');
    lTransition.SourceState := lState;
    lTransition.TargetState := lStateMachine.FindState('stAguardando');
    lTransition.AddTrigger('RM_EXCLUI_OBJETO');
    lTransition.AddEffect('EFFECT_ExcluiObjeto');
  
    lState := lStateMachine.FindState('stAguardando');
    lTransition := lState.NewOutgoingTransition('RM_INCLUI_OBJETO');
    lTransition.SourceState := lState;
    lTransition.TargetState := lStateMachine.FindState('stEditando');
    lTransition.AddTrigger('RM_INCLUI_OBJETO');
    lTransition.AddEffect('EFFECT_IncluiObjeto');
  
  
  
    //Gerando StateMachine para o casu de uso 'ucDetalhesAtualizacaoSistema'
    lUseCaseTicket := piMetaModel.UseCaseTicketByCode['1359'];
    lStateMachine := lUseCaseTicket.StateMachine;
  
    lStateMachine.Name := 'smServer';
    utState.Create(lStateMachine, 'Initializing');
    lSubMachineState := utSubMachineState.Create(lStateMachine, 'UseCaseSubmachine');
    lSubMachineUseCaseTicket := piMetaModel.UseCaseTicketByCode['1359'];
    lSubMachineState.StateMachine := acUseCaseStateMachine.Create(lSubMachineUseCaseTicket, lSubMachineState);
    utFinalState.Create(lStateMachine, 'smBase_FinalState');
  
  //Define o InitialState do StateMachine
    lStateMachine.InitialState := lStateMachine.FindState('Initializing');
  
  //Adiciona as transicoes dos estados
    lState := lStateMachine.FindState('Initializing');
    lTransition := lState.NewOutgoingTransition('READY');
    lTransition.SourceState := lState;
    lTransition.TargetState := lStateMachine.FindState('UseCaseSubmachine');
    lTransition.AddTrigger('READY');
  
    lState := lStateMachine.FindState('UseCaseSubmachine');
    lTransition := lState.NewOutgoingTransition('ABORT');
    lTransition.SourceState := lState;
    lTransition.TargetState := lStateMachine.FindState('smBase_FinalState');
    lTransition.AddTrigger('UM_ABORT','4');
    lTransition.AddEffect('EFFECT_Abort');
    lTransition := lState.NewOutgoingTransition('TIMEOUTCHECK');
    lTransition.SourceState := lState;
    lTransition.TargetState := lState;
    lTransition.AddTrigger('RM_TIMEOUT_CHECK','16');
    lTransition.AddEffect('EFFECT_TimeOutCheck');
    lTransition := lState.NewOutgoingTransition('GETTRIGGERSFROMCURRENTSTATE');
    lTransition.SourceState := lState;
    lTransition.TargetState := lState;
    lTransition.AddTrigger('RM_GET_TRIGGERS_FROM_CURRENT_STATE');
    lTransition.AddEffect('EFFECT_GetTriggersFromCurrentState');
    lTransition := lState.NewOutgoingTransition('GETXSDBYTRIGGERFROMCURRENTSTATE');
    lTransition.SourceState := lState;
    lTransition.TargetState := lState;
    lTransition.AddTrigger('RM_GET_XSD_BY_TRIGGER_FROM_CURRENT_STATE');
    lTransition.AddEffect('EFFECT_GetXSDByTriggerFromCurrentState');
  
  
  // SUBSTATEMACHINE smDetalhesAtualizacaoSistema ///////////////////////
    lStateMachine := lUseCaseTicket.FindStateMachine('smServer');
    lStateMachine := utSubMachineState(lStateMachine.FindState('UseCaseSubmachine')).StateMachine as acUseCaseStateMachine;
    lStateMachine.Name := 'smDetalhesAtualizacaoSistema';
    utState.Create(lStateMachine, 'Executando');
    utFinalState.Create(lStateMachine, 'FinalState1');
  
  //Define o InitialState do StateMachine
    lStateMachine.InitialState := lStateMachine.FindState('Executando');
  
  //Adiciona as transicoes dos estados
    lState := lStateMachine.FindState('Executando');
    lTransition := lState.NewOutgoingTransition('RM_RETORNA_XML');
    lTransition.SourceState := lState;
    lTransition.TargetState := lStateMachine.FindState('FinalState1');
    lTransition.AddTrigger('RM_RETORNA_XML');
    lTransition.AddEffect('EFFECT_RETORNA_XML');
  
  
  
    //Gerando StateMachine para o casu de uso 'ucControleAcesso'
    lUseCaseTicket := piMetaModel.UseCaseTicketByCode['104'];
    lStateMachine := lUseCaseTicket.StateMachine;
  
    lStateMachine.Name := 'smServer';
    utState.Create(lStateMachine, 'Initializing');
    lSubMachineState := utSubMachineState.Create(lStateMachine, 'UseCaseSubmachine');
    lSubMachineUseCaseTicket := piMetaModel.UseCaseTicketByCode['104'];
    lSubMachineState.StateMachine := acUseCaseStateMachine.Create(lSubMachineUseCaseTicket, lSubMachineState);
    utFinalState.Create(lStateMachine, 'smBase_FinalState');
  
  //Define o InitialState do StateMachine
    lStateMachine.InitialState := lStateMachine.FindState('Initializing');
  
  //Adiciona as transicoes dos estados
    lState := lStateMachine.FindState('Initializing');
    lTransition := lState.NewOutgoingTransition('READY');
    lTransition.SourceState := lState;
    lTransition.TargetState := lStateMachine.FindState('UseCaseSubmachine');
    lTransition.AddTrigger('READY');
  
    lState := lStateMachine.FindState('UseCaseSubmachine');
    lTransition := lState.NewOutgoingTransition('ABORT');
    lTransition.SourceState := lState;
    lTransition.TargetState := lStateMachine.FindState('smBase_FinalState');
    lTransition.AddTrigger('UM_ABORT','4');
    lTransition.AddEffect('EFFECT_Abort');
    lTransition := lState.NewOutgoingTransition('TIMEOUTCHECK');
    lTransition.SourceState := lState;
    lTransition.TargetState := lState;
    lTransition.AddTrigger('RM_TIMEOUT_CHECK','16');
    lTransition.AddEffect('EFFECT_TimeOutCheck');
    lTransition := lState.NewOutgoingTransition('GETTRIGGERSFROMCURRENTSTATE');
    lTransition.SourceState := lState;
    lTransition.TargetState := lState;
    lTransition.AddTrigger('RM_GET_TRIGGERS_FROM_CURRENT_STATE');
    lTransition.AddEffect('EFFECT_GetTriggersFromCurrentState');
    lTransition := lState.NewOutgoingTransition('GETXSDBYTRIGGERFROMCURRENTSTATE');
    lTransition.SourceState := lState;
    lTransition.TargetState := lState;
    lTransition.AddTrigger('RM_GET_XSD_BY_TRIGGER_FROM_CURRENT_STATE');
    lTransition.AddEffect('EFFECT_GetXSDByTriggerFromCurrentState');
  
  
  // SUBSTATEMACHINE smControleAcesso ///////////////////////
    lStateMachine := lUseCaseTicket.FindStateMachine('smServer');
    lStateMachine := utSubMachineState(lStateMachine.FindState('UseCaseSubmachine')).StateMachine as acUseCaseStateMachine;
    lStateMachine.Name := 'smControleAcesso';
    utState.Create(lStateMachine, 'Inicializando');
    utState.Create(lStateMachine, 'Executando');
  
  //Define o InitialState do StateMachine
    lStateMachine.InitialState := lStateMachine.FindState('Inicializando');
  
  //Adiciona as transicoes dos estados
    lState := lStateMachine.FindState('Inicializando');
    lTransition := lState.NewOutgoingTransition('RM_INICIALIZAR_INTERFACE');
    lTransition.SourceState := lState;
    lTransition.TargetState := lStateMachine.FindState('Executando');
    lTransition.AddTrigger('RM_INICIALIZAR_INTERFACE');
    lTransition.AddEffect('EFFECT_INICIALIZAR_INTERFACE');
  
    lState := lStateMachine.FindState('Executando');
    lTransition := lState.NewOutgoingTransition('RM_CARREGAR_PERMISSOES');
    lTransition.SourceState := lState;
    lTransition.TargetState := lState;
    lTransition.AddTrigger('RM_CARREGAR_PERMISSOES');
    lTransition.AddEffect('EFFECT_CARREGAR_PERMISSOES');
    lTransition := lState.NewOutgoingTransition('RM_SALVAR');
    lTransition.SourceState := lState;
    lTransition.TargetState := lState;
    lTransition.AddTrigger('RM_SALVAR');
    lTransition.AddEffect('EFFECT_SALVAR');
  
  
  
    //Gerando StateMachine para o casu de uso 'ucExplorerV4'
    lUseCaseTicket := piMetaModel.UseCaseTicketByCode['1432'];
    lStateMachine := lUseCaseTicket.StateMachine;
  
    lStateMachine.Name := 'smServer';
    utState.Create(lStateMachine, 'Initializing');
    lSubMachineState := utSubMachineState.Create(lStateMachine, 'UseCaseSubmachine');
    lSubMachineUseCaseTicket := piMetaModel.UseCaseTicketByCode['1432'];
    lSubMachineState.StateMachine := acUseCaseStateMachine.Create(lSubMachineUseCaseTicket, lSubMachineState);
    utFinalState.Create(lStateMachine, 'smBase_FinalState');
  
  //Define o InitialState do StateMachine
    lStateMachine.InitialState := lStateMachine.FindState('Initializing');
  
  //Adiciona as transicoes dos estados
    lState := lStateMachine.FindState('Initializing');
    lTransition := lState.NewOutgoingTransition('READY');
    lTransition.SourceState := lState;
    lTransition.TargetState := lStateMachine.FindState('UseCaseSubmachine');
    lTransition.AddTrigger('READY');
  
    lState := lStateMachine.FindState('UseCaseSubmachine');
    lTransition := lState.NewOutgoingTransition('ABORT');
    lTransition.SourceState := lState;
    lTransition.TargetState := lStateMachine.FindState('smBase_FinalState');
    lTransition.AddTrigger('UM_ABORT','4');
    lTransition.AddEffect('EFFECT_Abort');
    lTransition := lState.NewOutgoingTransition('TIMEOUTCHECK');
    lTransition.SourceState := lState;
    lTransition.TargetState := lState;
    lTransition.AddTrigger('RM_TIMEOUT_CHECK','16');
    lTransition.AddEffect('EFFECT_TimeOutCheck');
    lTransition := lState.NewOutgoingTransition('GETTRIGGERSFROMCURRENTSTATE');
    lTransition.SourceState := lState;
    lTransition.TargetState := lState;
    lTransition.AddTrigger('RM_GET_TRIGGERS_FROM_CURRENT_STATE');
    lTransition.AddEffect('EFFECT_GetTriggersFromCurrentState');
    lTransition := lState.NewOutgoingTransition('GETXSDBYTRIGGERFROMCURRENTSTATE');
    lTransition.SourceState := lState;
    lTransition.TargetState := lState;
    lTransition.AddTrigger('RM_GET_XSD_BY_TRIGGER_FROM_CURRENT_STATE');
    lTransition.AddEffect('EFFECT_GetXSDByTriggerFromCurrentState');
  
  
  // SUBSTATEMACHINE smExplorerV4 ///////////////////////
    lStateMachine := lUseCaseTicket.FindStateMachine('smServer');
    lStateMachine := utSubMachineState(lStateMachine.FindState('UseCaseSubmachine')).StateMachine as acUseCaseStateMachine;
    lStateMachine.Name := 'smExplorerV4';
    utState.Create(lStateMachine, 'Aguardando');
  
  //Define o InitialState do StateMachine
    lStateMachine.InitialState := lStateMachine.FindState('Aguardando');
  
  //Adiciona as transicoes dos estados
    lState := lStateMachine.FindState('Aguardando');
    lTransition := lState.NewOutgoingTransition('RM_EXECUTE_OQL');
    lTransition.SourceState := lState;
    lTransition.TargetState := lState;
    lTransition.AddTrigger('RM_EXECUTE_OQL');
    lTransition.AddEffect('EFFECT_EXECUTE_OQL');
    lTransition := lState.NewOutgoingTransition('RM_GET_OBJECT_DATA');
    lTransition.SourceState := lState;
    lTransition.TargetState := lState;
    lTransition.AddTrigger('RM_GET_OBJECT_DATA');
    lTransition.AddEffect('EFFECT_GET_OBJECT_DATA');
    lTransition := lState.NewOutgoingTransition('RM_EXECUTE_SQL');
    lTransition.SourceState := lState;
    lTransition.TargetState := lState;
    lTransition.AddTrigger('RM_EXECUTE_SQL');
    lTransition.AddEffect('EFFECT_EXECUTE_SQL');
    lTransition := lState.NewOutgoingTransition('RM_GET_MODEL_OBJECT_DATA');
    lTransition.SourceState := lState;
    lTransition.TargetState := lState;
    lTransition.AddTrigger('RM_GET_MODEL_OBJECT_DATA');
    lTransition.AddEffect('EFFECT_GET_MODEL_OBJECT_DATA');
    lTransition := lState.NewOutgoingTransition('RM_GET_OQL_FROM_OBJECT');
    lTransition.SourceState := lState;
    lTransition.TargetState := lState;
    lTransition.AddTrigger('RM_GET_OQL_FROM_OBJECT');
    lTransition.AddEffect('EFFECT_GET_OQL_FROM_OBJECT');
  
  
  
    //Gerando StateMachine para o casu de uso 'ucCadastroPerfil'
    lUseCaseTicket := piMetaModel.UseCaseTicketByCode['1963'];
    lStateMachine := lUseCaseTicket.StateMachine;
  
    lStateMachine.Name := 'smServer';
    utState.Create(lStateMachine, 'Initializing');
    lSubMachineState := utSubMachineState.Create(lStateMachine, 'UseCaseSubmachine');
    lSubMachineUseCaseTicket := piMetaModel.UseCaseTicketByCode['1963'];
    lSubMachineState.StateMachine := acUseCaseStateMachine.Create(lSubMachineUseCaseTicket, lSubMachineState);
    utFinalState.Create(lStateMachine, 'smBase_FinalState');
  
  //Define o InitialState do StateMachine
    lStateMachine.InitialState := lStateMachine.FindState('Initializing');
  
  //Adiciona as transicoes dos estados
    lState := lStateMachine.FindState('Initializing');
    lTransition := lState.NewOutgoingTransition('READY');
    lTransition.SourceState := lState;
    lTransition.TargetState := lStateMachine.FindState('UseCaseSubmachine');
    lTransition.AddTrigger('READY');
  
    lState := lStateMachine.FindState('UseCaseSubmachine');
    lTransition := lState.NewOutgoingTransition('ABORT');
    lTransition.SourceState := lState;
    lTransition.TargetState := lStateMachine.FindState('smBase_FinalState');
    lTransition.AddTrigger('UM_ABORT','4');
    lTransition.AddEffect('EFFECT_Abort');
    lTransition := lState.NewOutgoingTransition('TIMEOUTCHECK');
    lTransition.SourceState := lState;
    lTransition.TargetState := lState;
    lTransition.AddTrigger('RM_TIMEOUT_CHECK','16');
    lTransition.AddEffect('EFFECT_TimeOutCheck');
    lTransition := lState.NewOutgoingTransition('GETTRIGGERSFROMCURRENTSTATE');
    lTransition.SourceState := lState;
    lTransition.TargetState := lState;
    lTransition.AddTrigger('RM_GET_TRIGGERS_FROM_CURRENT_STATE');
    lTransition.AddEffect('EFFECT_GetTriggersFromCurrentState');
    lTransition := lState.NewOutgoingTransition('GETXSDBYTRIGGERFROMCURRENTSTATE');
    lTransition.SourceState := lState;
    lTransition.TargetState := lState;
    lTransition.AddTrigger('RM_GET_XSD_BY_TRIGGER_FROM_CURRENT_STATE');
    lTransition.AddEffect('EFFECT_GetXSDByTriggerFromCurrentState');
  
  
  // SUBSTATEMACHINE smucCadastroPerfil ///////////////////////
    lStateMachine := lUseCaseTicket.FindStateMachine('smServer');
    lStateMachine := utSubMachineState(lStateMachine.FindState('UseCaseSubmachine')).StateMachine as acUseCaseStateMachine;
    lStateMachine.Name := 'smucCadastroPerfil';
    utState.Create(lStateMachine, 'stAguardando');
    utState.Create(lStateMachine, 'stEditando');
    utState.Create(lStateMachine, 'stConsultando');
  
  //Define o InitialState do StateMachine
    lStateMachine.InitialState := lStateMachine.FindState('stAguardando');
  
  //Adiciona as transicoes dos estados
    lState := lStateMachine.FindState('stAguardando');
    lTransition := lState.NewOutgoingTransition('RM_OBTEM_CONTEXTO');
    lTransition.SourceState := lState;
    lTransition.TargetState := lState;
    lTransition.AddTrigger('RM_OBTEM_CONTEXTO');
    lTransition.AddEffect('EFFECT_MontaContexto');
    lTransition := lState.NewOutgoingTransition('RM_INCLUI_OBJETO');
    lTransition.SourceState := lState;
    lTransition.TargetState := lStateMachine.FindState('stEditando');
    lTransition.AddTrigger('RM_INCLUI_OBJETO');
    lTransition.AddEffect('EFFECT_IncluiObjeto');
    lTransition := lState.NewOutgoingTransition('RM_EXCLUI_OBJETO');
    lTransition.SourceState := lState;
    lTransition.TargetState := lState;
    lTransition.AddTrigger('RM_EXCLUI_OBJETO');
    lTransition.AddEffect('EFFECT_ExcluiObjeto');
    lTransition := lState.NewOutgoingTransition('RM_EDITA_OBJETO');
    lTransition.SourceState := lState;
    lTransition.TargetState := lStateMachine.FindState('stEditando');
    lTransition.AddTrigger('RM_EDITA_OBJETO');
    lTransition.AddEffect('EFFECT_EditaObjeto');
    lTransition := lState.NewOutgoingTransition('RM_CONSULTA_OBJETO');
    lTransition.SourceState := lState;
    lTransition.TargetState := lStateMachine.FindState('stConsultando');
    lTransition.AddTrigger('RM_CONSULTA_OBJETO');
    lTransition.AddEffect('Effect_ConsultaObjeto');
  
    lState := lStateMachine.FindState('stEditando');
    lTransition := lState.NewOutgoingTransition('RM_EXCLUI_OBJETO');
    lTransition.SourceState := lState;
    lTransition.TargetState := lStateMachine.FindState('stAguardando');
    lTransition.AddTrigger('RM_EXCLUI_OBJETO');
    lTransition.AddEffect('EFFECT_ExcluiObjeto');
    lTransition := lState.NewOutgoingTransition('RM_SALVA_OBJETO');
    lTransition.SourceState := lState;
    lTransition.TargetState := lStateMachine.FindState('stConsultando');
    lTransition.AddTrigger('RM_SALVA_OBJETO');
    lTransition.AddEffect('Effect_SalvaObjeto');
  
    lState := lStateMachine.FindState('stConsultando');
    lTransition := lState.NewOutgoingTransition('RM_INCLUI_OBJETO');
    lTransition.SourceState := lState;
    lTransition.TargetState := lStateMachine.FindState('stEditando');
    lTransition.AddTrigger('RM_INCLUI_OBJETO');
    lTransition.AddEffect('EFFECT_IncluiObjeto');
    lTransition := lState.NewOutgoingTransition('RM_EDITA_OBJETO');
    lTransition.SourceState := lState;
    lTransition.TargetState := lStateMachine.FindState('stEditando');
    lTransition.AddTrigger('RM_EDITA_OBJETO');
    lTransition.AddEffect('EFFECT_EditaObjeto');
    lTransition := lState.NewOutgoingTransition('RM_EXCLUI_OBJETO');
    lTransition.SourceState := lState;
    lTransition.TargetState := lStateMachine.FindState('stAguardando');
    lTransition.AddTrigger('RM_EXCLUI_OBJETO');
    lTransition.AddEffect('EFFECT_ExcluiObjeto');
    lTransition := lState.NewOutgoingTransition('RM_CONSULTA_OBJETO');
    lTransition.SourceState := lState;
    lTransition.TargetState := lState;
    lTransition.AddTrigger('RM_CONSULTA_OBJETO');
    lTransition.AddEffect('Effect_ConsultaObjeto');
  
  
  
    //Gerando StateMachine para o casu de uso 'ucCadastroUsuarioSistema'
    lUseCaseTicket := piMetaModel.UseCaseTicketByCode['101'];
    lStateMachine := lUseCaseTicket.StateMachine;
  
    lStateMachine.Name := 'smServer';
    utState.Create(lStateMachine, 'Initializing');
    lSubMachineState := utSubMachineState.Create(lStateMachine, 'UseCaseSubmachine');
    lSubMachineUseCaseTicket := piMetaModel.UseCaseTicketByCode['101'];
    lSubMachineState.StateMachine := acUseCaseStateMachine.Create(lSubMachineUseCaseTicket, lSubMachineState);
    utFinalState.Create(lStateMachine, 'smBase_FinalState');
  
  //Define o InitialState do StateMachine
    lStateMachine.InitialState := lStateMachine.FindState('Initializing');
  
  //Adiciona as transicoes dos estados
    lState := lStateMachine.FindState('Initializing');
    lTransition := lState.NewOutgoingTransition('READY');
    lTransition.SourceState := lState;
    lTransition.TargetState := lStateMachine.FindState('UseCaseSubmachine');
    lTransition.AddTrigger('READY');
  
    lState := lStateMachine.FindState('UseCaseSubmachine');
    lTransition := lState.NewOutgoingTransition('ABORT');
    lTransition.SourceState := lState;
    lTransition.TargetState := lStateMachine.FindState('smBase_FinalState');
    lTransition.AddTrigger('UM_ABORT','4');
    lTransition.AddEffect('EFFECT_Abort');
    lTransition := lState.NewOutgoingTransition('TIMEOUTCHECK');
    lTransition.SourceState := lState;
    lTransition.TargetState := lState;
    lTransition.AddTrigger('RM_TIMEOUT_CHECK','16');
    lTransition.AddEffect('EFFECT_TimeOutCheck');
    lTransition := lState.NewOutgoingTransition('GETTRIGGERSFROMCURRENTSTATE');
    lTransition.SourceState := lState;
    lTransition.TargetState := lState;
    lTransition.AddTrigger('RM_GET_TRIGGERS_FROM_CURRENT_STATE');
    lTransition.AddEffect('EFFECT_GetTriggersFromCurrentState');
    lTransition := lState.NewOutgoingTransition('GETXSDBYTRIGGERFROMCURRENTSTATE');
    lTransition.SourceState := lState;
    lTransition.TargetState := lState;
    lTransition.AddTrigger('RM_GET_XSD_BY_TRIGGER_FROM_CURRENT_STATE');
    lTransition.AddEffect('EFFECT_GetXSDByTriggerFromCurrentState');
  
  
  // SUBSTATEMACHINE smCadastroUsuarioSistema ///////////////////////
    lStateMachine := lUseCaseTicket.FindStateMachine('smServer');
    lStateMachine := utSubMachineState(lStateMachine.FindState('UseCaseSubmachine')).StateMachine as acUseCaseStateMachine;
    lStateMachine.Name := 'smCadastroUsuarioSistema';
    utState.Create(lStateMachine, 'stConsultando');
    utState.Create(lStateMachine, 'stEditando');
    utState.Create(lStateMachine, 'stAguardando');
  
  //Define o InitialState do StateMachine
    lStateMachine.InitialState := lStateMachine.FindState('stConsultando');
  
  //Adiciona as transicoes dos estados
    lState := lStateMachine.FindState('stConsultando');
    lTransition := lState.NewOutgoingTransition('RM_INCLUI_OBJETO');
    lTransition.SourceState := lState;
    lTransition.TargetState := lStateMachine.FindState('stEditando');
    lTransition.AddTrigger('RM_INCLUI_OBJETO');
    lTransition.AddEffect('EFFECT_IncluiObjeto');
    lTransition := lState.NewOutgoingTransition('RM_EDITA_OBJETO');
    lTransition.SourceState := lState;
    lTransition.TargetState := lStateMachine.FindState('stEditando');
    lTransition.AddTrigger('RM_EDITA_OBJETO');
    lTransition.AddEffect('EFFECT_MontaContexto');
    lTransition := lState.NewOutgoingTransition('RM_EXCLUI_OBJETO');
    lTransition.SourceState := lState;
    lTransition.TargetState := lStateMachine.FindState('stAguardando');
    lTransition.AddTrigger('RM_EXCLUI_OBJETO');
    lTransition.AddEffect('EFFECT_ExcluiObjeto');
    lTransition := lState.NewOutgoingTransition('RM_OBTEM_CONTEXTO');
    lTransition.SourceState := lState;
    lTransition.TargetState := lState;
    lTransition.AddTrigger('RM_OBTEM_CONTEXTO');
    lTransition.AddEffect('EFFECT_MontaContexto');
    lTransition := lState.NewOutgoingTransition('RM_SALVA_OBJETO');
    lTransition.SourceState := lState;
    lTransition.TargetState := lStateMachine.FindState('stAguardando');
    lTransition.AddTrigger('RM_SALVA_OBJETO');
    lTransition.AddEffect('EFFECT_SalvaObjeto');
  
    lState := lStateMachine.FindState('stEditando');
    lTransition := lState.NewOutgoingTransition('RM_OBTEM_CONTEXTO');
    lTransition.SourceState := lState;
    lTransition.TargetState := lState;
    lTransition.AddTrigger('RM_OBTEM_CONTEXTO');
    lTransition.AddEffect('EFFECT_MontaContexto');
    lTransition := lState.NewOutgoingTransition('RM_SALVA_OBJETO');
    lTransition.GuardCondition := 'GUARD_ValidaObjeto';
    lTransition.SourceState := lState;
    lTransition.TargetState := lStateMachine.FindState('stConsultando');
    lTransition.AddTrigger('RM_SALVA_OBJETO');
    lTransition.AddEffect('EFFECT_SalvaObjeto');
    lTransition := lState.NewOutgoingTransition('RM_EXCLUI_OBJETO');
    lTransition.SourceState := lState;
    lTransition.TargetState := lStateMachine.FindState('stAguardando');
    lTransition.AddTrigger('RM_EXCLUI_OBJETO');
    lTransition.AddEffect('EFFECT_ExcluiObjeto');
    lTransition := lState.NewOutgoingTransition('RM_VALIDA_OBJETO');
    lTransition.GuardCondition := 'GUARD_ValidaObjeto';
    lTransition.SourceState := lState;
    lTransition.TargetState := lState;
    lTransition.AddTrigger('RM_VALIDA_OBJETO');
  
    lState := lStateMachine.FindState('stAguardando');
    lTransition := lState.NewOutgoingTransition('RM_INCLUI_OBJETO');
    lTransition.SourceState := lState;
    lTransition.TargetState := lStateMachine.FindState('stEditando');
    lTransition.AddTrigger('RM_INCLUI_OBJETO');
    lTransition.AddEffect('EFFECT_IncluiObjeto');
  
  
  
    //Gerando StateMachine para o casu de uso 'ucEfetuarEmprestimo'
    lUseCaseTicket := piMetaModel.UseCaseTicketByCode['3220'];
    lStateMachine := lUseCaseTicket.StateMachine;
  
    lStateMachine.Name := 'smServer';
    utState.Create(lStateMachine, 'Initializing');
    lSubMachineState := utSubMachineState.Create(lStateMachine, 'UseCaseSubmachine');
    lSubMachineUseCaseTicket := piMetaModel.UseCaseTicketByCode['3220'];
    lSubMachineState.StateMachine := acUseCaseStateMachine.Create(lSubMachineUseCaseTicket, lSubMachineState);
    utFinalState.Create(lStateMachine, 'smBase_FinalState');
  
  //Define o InitialState do StateMachine
    lStateMachine.InitialState := lStateMachine.FindState('Initializing');
  
  //Adiciona as transicoes dos estados
    lState := lStateMachine.FindState('Initializing');
    lTransition := lState.NewOutgoingTransition('READY');
    lTransition.SourceState := lState;
    lTransition.TargetState := lStateMachine.FindState('UseCaseSubmachine');
    lTransition.AddTrigger('READY');
  
    lState := lStateMachine.FindState('UseCaseSubmachine');
    lTransition := lState.NewOutgoingTransition('ABORT');
    lTransition.SourceState := lState;
    lTransition.TargetState := lStateMachine.FindState('smBase_FinalState');
    lTransition.AddTrigger('UM_ABORT','4');
    lTransition.AddEffect('EFFECT_Abort');
    lTransition := lState.NewOutgoingTransition('TIMEOUTCHECK');
    lTransition.SourceState := lState;
    lTransition.TargetState := lState;
    lTransition.AddTrigger('RM_TIMEOUT_CHECK','16');
    lTransition.AddEffect('EFFECT_TimeOutCheck');
    lTransition := lState.NewOutgoingTransition('GETTRIGGERSFROMCURRENTSTATE');
    lTransition.SourceState := lState;
    lTransition.TargetState := lState;
    lTransition.AddTrigger('RM_GET_TRIGGERS_FROM_CURRENT_STATE');
    lTransition.AddEffect('EFFECT_GetTriggersFromCurrentState');
    lTransition := lState.NewOutgoingTransition('GETXSDBYTRIGGERFROMCURRENTSTATE');
    lTransition.SourceState := lState;
    lTransition.TargetState := lState;
    lTransition.AddTrigger('RM_GET_XSD_BY_TRIGGER_FROM_CURRENT_STATE');
    lTransition.AddEffect('EFFECT_GetXSDByTriggerFromCurrentState');
  
  
  // SUBSTATEMACHINE smucEfetuarEmprestimo ///////////////////////
    lStateMachine := lUseCaseTicket.FindStateMachine('smServer');
    lStateMachine := utSubMachineState(lStateMachine.FindState('UseCaseSubmachine')).StateMachine as acUseCaseStateMachine;
    lStateMachine.Name := 'smucEfetuarEmprestimo';
    utState.Create(lStateMachine, 'PesquisandoUsuario');
    utState.Create(lStateMachine, 'EscolhendoUsuario');
    utState.Create(lStateMachine, 'EditandoEmprestimos');
    utFinalState.Create(lStateMachine, 'FinalState1');
    utState.Create(lStateMachine, 'EscolhendoExemplares');
    utState.Create(lStateMachine, 'Confirmando');
  
  //Define o InitialState do StateMachine
    lStateMachine.InitialState := lStateMachine.FindState('PesquisandoUsuario');
  
  //Adiciona as transicoes dos estados
    lState := lStateMachine.FindState('PesquisandoUsuario');
    lTransition := lState.NewOutgoingTransition('RM_PESQUISAR_USUARIO');
    lTransition.SourceState := lState;
    lTransition.TargetState := lStateMachine.FindState('EscolhendoUsuario');
    lTransition.AddTrigger('RM_PESQUISAR_USUARIO');
    lTransition.AddEffect('Effect_PesquisarUsuario');
    lTransition.XsdIn.XML := GetXSDIn_3220_smucEfetuarEmprestimo_PesquisandoUsuario_RM_PESQUISAR_USUARIO;
    lTransition.XsdOut.XML := GetXSDOut_3220_smucEfetuarEmprestimo_PesquisandoUsuario_RM_PESQUISAR_USUARIO;
  
    lState := lStateMachine.FindState('EscolhendoUsuario');
    lTransition := lState.NewOutgoingTransition('RM_ESCOLHER_USUARIO');
    lTransition.SourceState := lState;
    lTransition.TargetState := lStateMachine.FindState('EditandoEmprestimos');
    lTransition.AddTrigger('RM_ESCOLHER_USUARIO');
    lTransition.AddEffect('Effect_EscolherUsuario');
    lTransition.XsdIn.XML := GetXSDIn_3220_smucEfetuarEmprestimo_EscolhendoUsuario_RM_ESCOLHER_USUARIO;
    lTransition.XsdOut.XML := GetXSDOut_3220_smucEfetuarEmprestimo_EscolhendoUsuario_RM_ESCOLHER_USUARIO;
    lTransition := lState.NewOutgoingTransition('RM_PESQUISAR_USUARIO');
    lTransition.SourceState := lState;
    lTransition.TargetState := lState;
    lTransition.AddTrigger('RM_PESQUISAR_USUARIO');
    lTransition.AddEffect('Effect_PesquisarUsuario');
    lTransition.XsdIn.XML := GetXSDIn_3220_smucEfetuarEmprestimo_EscolhendoUsuario_RM_PESQUISAR_USUARIO;
    lTransition.XsdOut.XML := GetXSDOut_3220_smucEfetuarEmprestimo_EscolhendoUsuario_RM_PESQUISAR_USUARIO;
  
    lState := lStateMachine.FindState('EditandoEmprestimos');
    lTransition := lState.NewOutgoingTransition('RM_PESQUISAR_EXEMPLAR');
    lTransition.SourceState := lState;
    lTransition.TargetState := lStateMachine.FindState('EscolhendoExemplares');
    lTransition.AddTrigger('RM_PESQUISAR_EXEMPLAR');
    lTransition.AddEffect('Effect_PesquisarExemplar');
    lTransition.XsdIn.XML := GetXSDIn_3220_smucEfetuarEmprestimo_EditandoEmprestimos_RM_PESQUISAR_EXEMPLAR;
    lTransition.XsdOut.XML := GetXSDOut_3220_smucEfetuarEmprestimo_EditandoEmprestimos_RM_PESQUISAR_EXEMPLAR;
    lTransition := lState.NewOutgoingTransition('RM_REMOVER_EXEMPLAR');
    lTransition.SourceState := lState;
    lTransition.TargetState := lState;
    lTransition.AddTrigger('RM_REMOVER_EXEMPLAR');
    lTransition.AddEffect('Effect_RemoverExemplar');
    lTransition.XsdIn.XML := GetXSDIn_3220_smucEfetuarEmprestimo_EditandoEmprestimos_RM_REMOVER_EXEMPLAR;
    lTransition.XsdOut.XML := GetXSDOut_3220_smucEfetuarEmprestimo_EditandoEmprestimos_RM_REMOVER_EXEMPLAR;
    lTransition := lState.NewOutgoingTransition('RM_REALIZAR_EMPRESTIMO');
    lTransition.SourceState := lState;
    lTransition.TargetState := lStateMachine.FindState('Confirmando');
    lTransition.AddTrigger('RM_REALIZAR_EMPRESTIMO');
    lTransition.AddEffect('Effect_RealizarEmprestimo');
    lTransition.XsdOut.XML := GetXSDOut_3220_smucEfetuarEmprestimo_EditandoEmprestimos_RM_REALIZAR_EMPRESTIMO;
  
    lState := lStateMachine.FindState('EscolhendoExemplares');
    lTransition := lState.NewOutgoingTransition('RM_PESQUISAR_EXEMPLAR');
    lTransition.SourceState := lState;
    lTransition.TargetState := lState;
    lTransition.AddTrigger('RM_PESQUISAR_EXEMPLAR');
    lTransition.AddEffect('Effect_PesquisarExemplar');
    lTransition.XsdIn.XML := GetXSDIn_3220_smucEfetuarEmprestimo_EscolhendoExemplares_RM_PESQUISAR_EXEMPLAR;
    lTransition.XsdOut.XML := GetXSDOut_3220_smucEfetuarEmprestimo_EscolhendoExemplares_RM_PESQUISAR_EXEMPLAR;
    lTransition := lState.NewOutgoingTransition('RM_CANCELAR_ESCOLHA_EXEMPLAR');
    lTransition.SourceState := lState;
    lTransition.TargetState := lStateMachine.FindState('EditandoEmprestimos');
    lTransition.AddTrigger('RM_CANCELAR_ESCOLHA_EXEMPLAR');
    lTransition.AddEffect('Effect_CancelarEscolhaExemplar');
    lTransition.XsdOut.XML := GetXSDOut_3220_smucEfetuarEmprestimo_EscolhendoExemplares_RM_CANCELAR_ESCOLHA_EXEMPLAR;
    lTransition := lState.NewOutgoingTransition('RM_SELECIONAR_EXEMPLAR');
    lTransition.SourceState := lState;
    lTransition.TargetState := lStateMachine.FindState('EditandoEmprestimos');
    lTransition.AddTrigger('RM_SELECIONAR_EXEMPLAR');
    lTransition.AddEffect('Effect_SelecionarExemplar');
    lTransition.XsdIn.XML := GetXSDIn_3220_smucEfetuarEmprestimo_EscolhendoExemplares_RM_SELECIONAR_EXEMPLAR;
    lTransition.XsdOut.XML := GetXSDOut_3220_smucEfetuarEmprestimo_EscolhendoExemplares_RM_SELECIONAR_EXEMPLAR;
  
    lState := lStateMachine.FindState('Confirmando');
    lTransition := lState.NewOutgoingTransition('RM_CONFIRMAR');
    lTransition.SourceState := lState;
    lTransition.TargetState := lStateMachine.FindState('FinalState1');
    lTransition.AddTrigger('RM_CONFIRMAR');
    lTransition.AddEffect('Effect_Confirmar');
    lTransition := lState.NewOutgoingTransition('RM_CANCELAR_CONFIRMACAO');
    lTransition.SourceState := lState;
    lTransition.TargetState := lStateMachine.FindState('EditandoEmprestimos');
    lTransition.AddTrigger('RM_CANCELAR_CONFIRMACAO');
    lTransition.AddEffect('Effect_CancelarConfirmacao');
    lTransition.XsdOut.XML := GetXSDOut_3220_smucEfetuarEmprestimo_Confirmando_RM_CANCELAR_CONFIRMACAO;
  
  
  
    //Gerando StateMachine para o casu de uso 'ucConsultarEmprestimo'
    lUseCaseTicket := piMetaModel.UseCaseTicketByCode['3222'];
    lStateMachine := lUseCaseTicket.StateMachine;
  
    lStateMachine.Name := 'smServer';
    utState.Create(lStateMachine, 'Initializing');
    lSubMachineState := utSubMachineState.Create(lStateMachine, 'UseCaseSubmachine');
    lSubMachineUseCaseTicket := piMetaModel.UseCaseTicketByCode['3222'];
    lSubMachineState.StateMachine := acUseCaseStateMachine.Create(lSubMachineUseCaseTicket, lSubMachineState);
    utFinalState.Create(lStateMachine, 'smBase_FinalState');
  
  //Define o InitialState do StateMachine
    lStateMachine.InitialState := lStateMachine.FindState('Initializing');
  
  //Adiciona as transicoes dos estados
    lState := lStateMachine.FindState('Initializing');
    lTransition := lState.NewOutgoingTransition('READY');
    lTransition.SourceState := lState;
    lTransition.TargetState := lStateMachine.FindState('UseCaseSubmachine');
    lTransition.AddTrigger('READY');
  
    lState := lStateMachine.FindState('UseCaseSubmachine');
    lTransition := lState.NewOutgoingTransition('ABORT');
    lTransition.SourceState := lState;
    lTransition.TargetState := lStateMachine.FindState('smBase_FinalState');
    lTransition.AddTrigger('UM_ABORT','4');
    lTransition.AddEffect('EFFECT_Abort');
    lTransition := lState.NewOutgoingTransition('TIMEOUTCHECK');
    lTransition.SourceState := lState;
    lTransition.TargetState := lState;
    lTransition.AddTrigger('RM_TIMEOUT_CHECK','16');
    lTransition.AddEffect('EFFECT_TimeOutCheck');
    lTransition := lState.NewOutgoingTransition('GETTRIGGERSFROMCURRENTSTATE');
    lTransition.SourceState := lState;
    lTransition.TargetState := lState;
    lTransition.AddTrigger('RM_GET_TRIGGERS_FROM_CURRENT_STATE');
    lTransition.AddEffect('EFFECT_GetTriggersFromCurrentState');
    lTransition := lState.NewOutgoingTransition('GETXSDBYTRIGGERFROMCURRENTSTATE');
    lTransition.SourceState := lState;
    lTransition.TargetState := lState;
    lTransition.AddTrigger('RM_GET_XSD_BY_TRIGGER_FROM_CURRENT_STATE');
    lTransition.AddEffect('EFFECT_GetXSDByTriggerFromCurrentState');
  
  
  // SUBSTATEMACHINE smucConsultarEmprestimo ///////////////////////
    lStateMachine := lUseCaseTicket.FindStateMachine('smServer');
    lStateMachine := utSubMachineState(lStateMachine.FindState('UseCaseSubmachine')).StateMachine as acUseCaseStateMachine;
    lStateMachine.Name := 'smucConsultarEmprestimo';
    utState.Create(lStateMachine, 'Consultando');
  
  //Define o InitialState do StateMachine
    lStateMachine.InitialState := lStateMachine.FindState('Consultando');
  
  //Adiciona as transicoes dos estados
    lState := lStateMachine.FindState('Consultando');
    lTransition := lState.NewOutgoingTransition('RM_CONSULTAR');
    lTransition.SourceState := lState;
    lTransition.TargetState := lState;
    lTransition.AddTrigger('RM_CONSULTAR');
    lTransition.AddEffect('Effect_Consultar');
    lTransition.XsdIn.XML := GetXSDIn_3222_smucConsultarEmprestimo_Consultando_RM_CONSULTAR;
    lTransition.XsdOut.XML := GetXSDOut_3222_smucConsultarEmprestimo_Consultando_RM_CONSULTAR;
  
  
  
    //Gerando StateMachine para o casu de uso 'ucCadastrarLivro'
    lUseCaseTicket := piMetaModel.UseCaseTicketByCode['3226'];
    lStateMachine := lUseCaseTicket.StateMachine;
  
    lStateMachine.Name := 'smServer';
    utState.Create(lStateMachine, 'Initializing');
    lSubMachineState := utSubMachineState.Create(lStateMachine, 'UseCaseSubmachine');
    lSubMachineUseCaseTicket := piMetaModel.UseCaseTicketByCode['3226'];
    lSubMachineState.StateMachine := acUseCaseStateMachine.Create(lSubMachineUseCaseTicket, lSubMachineState);
    utFinalState.Create(lStateMachine, 'smBase_FinalState');
  
  //Define o InitialState do StateMachine
    lStateMachine.InitialState := lStateMachine.FindState('Initializing');
  
  //Adiciona as transicoes dos estados
    lState := lStateMachine.FindState('Initializing');
    lTransition := lState.NewOutgoingTransition('READY');
    lTransition.SourceState := lState;
    lTransition.TargetState := lStateMachine.FindState('UseCaseSubmachine');
    lTransition.AddTrigger('READY');
  
    lState := lStateMachine.FindState('UseCaseSubmachine');
    lTransition := lState.NewOutgoingTransition('ABORT');
    lTransition.SourceState := lState;
    lTransition.TargetState := lStateMachine.FindState('smBase_FinalState');
    lTransition.AddTrigger('UM_ABORT','4');
    lTransition.AddEffect('EFFECT_Abort');
    lTransition := lState.NewOutgoingTransition('TIMEOUTCHECK');
    lTransition.SourceState := lState;
    lTransition.TargetState := lState;
    lTransition.AddTrigger('RM_TIMEOUT_CHECK','16');
    lTransition.AddEffect('EFFECT_TimeOutCheck');
    lTransition := lState.NewOutgoingTransition('GETTRIGGERSFROMCURRENTSTATE');
    lTransition.SourceState := lState;
    lTransition.TargetState := lState;
    lTransition.AddTrigger('RM_GET_TRIGGERS_FROM_CURRENT_STATE');
    lTransition.AddEffect('EFFECT_GetTriggersFromCurrentState');
    lTransition := lState.NewOutgoingTransition('GETXSDBYTRIGGERFROMCURRENTSTATE');
    lTransition.SourceState := lState;
    lTransition.TargetState := lState;
    lTransition.AddTrigger('RM_GET_XSD_BY_TRIGGER_FROM_CURRENT_STATE');
    lTransition.AddEffect('EFFECT_GetXSDByTriggerFromCurrentState');
  
  
  // SUBSTATEMACHINE smucCadastrarLivro ///////////////////////
    lStateMachine := lUseCaseTicket.FindStateMachine('smServer');
    lStateMachine := utSubMachineState(lStateMachine.FindState('UseCaseSubmachine')).StateMachine as acUseCaseStateMachine;
    lStateMachine.Name := 'smucCadastrarLivro';
    utState.Create(lStateMachine, 'BuscandoLivro');
    utState.Create(lStateMachine, 'CadastrandoLivro');
  
  //Define o InitialState do StateMachine
    lStateMachine.InitialState := lStateMachine.FindState('BuscandoLivro');
  
  //Adiciona as transicoes dos estados
    lState := lStateMachine.FindState('BuscandoLivro');
    lTransition := lState.NewOutgoingTransition('RM_INCLUIR_LIVRO');
    lTransition.SourceState := lState;
    lTransition.TargetState := lStateMachine.FindState('CadastrandoLivro');
    lTransition.AddTrigger('RM_INCLUIR_LIVRO');
    lTransition.AddEffect('Effect_IncluirLivro');
    lTransition.XsdOut.XML := GetXSDOut_3226_smucCadastrarLivro_BuscandoLivro_RM_INCLUIR_LIVRO;
    lTransition := lState.NewOutgoingTransition('RM_EDITAR_LIVRO');
    lTransition.SourceState := lState;
    lTransition.TargetState := lStateMachine.FindState('CadastrandoLivro');
    lTransition.AddTrigger('RM_EDITAR_LIVRO');
    lTransition.AddEffect('Effect_EditarLivro');
    lTransition.XsdIn.XML := GetXSDIn_3226_smucCadastrarLivro_BuscandoLivro_RM_EDITAR_LIVRO;
    lTransition.XsdOut.XML := GetXSDOut_3226_smucCadastrarLivro_BuscandoLivro_RM_EDITAR_LIVRO;
    lTransition := lState.NewOutgoingTransition('RM_BUSCAR_LIVRO');
    lTransition.SourceState := lState;
    lTransition.TargetState := lState;
    lTransition.AddTrigger('RM_BUSCAR_LIVRO');
    lTransition.AddEffect('Effect_BuscarLivro');
    lTransition.XsdIn.XML := GetXSDIn_3226_smucCadastrarLivro_BuscandoLivro_RM_BUSCAR_LIVRO;
    lTransition.XsdOut.XML := GetXSDOut_3226_smucCadastrarLivro_BuscandoLivro_RM_BUSCAR_LIVRO;
    lTransition := lState.NewOutgoingTransition('RM_EXCLUIR_LIVRO');
    lTransition.SourceState := lState;
    lTransition.TargetState := lState;
    lTransition.AddTrigger('RM_EXCLUIR_LIVRO');
    lTransition.AddEffect('Effect_ExcluirLivro');
    lTransition.XsdIn.XML := GetXSDIn_3226_smucCadastrarLivro_BuscandoLivro_RM_EXCLUIR_LIVRO;
    lTransition.XsdOut.XML := GetXSDOut_3226_smucCadastrarLivro_BuscandoLivro_RM_EXCLUIR_LIVRO;
  
    lState := lStateMachine.FindState('CadastrandoLivro');
    lTransition := lState.NewOutgoingTransition('RM_CANCELAR_CADASTRO');
    lTransition.SourceState := lState;
    lTransition.TargetState := lStateMachine.FindState('BuscandoLivro');
    lTransition.AddTrigger('RM_CANCELAR_CADASTRO');
    lTransition.AddEffect('Effect_CancelarCadastro');
    lTransition := lState.NewOutgoingTransition('RM_INCLUIR_EXEMPLAR');
    lTransition.SourceState := lState;
    lTransition.TargetState := lState;
    lTransition.AddTrigger('RM_INCLUIR_EXEMPLAR');
    lTransition.AddEffect('Effect_IncluirExemplar');
    lTransition.XsdIn.XML := GetXSDIn_3226_smucCadastrarLivro_CadastrandoLivro_RM_INCLUIR_EXEMPLAR;
    lTransition.XsdOut.XML := GetXSDOut_3226_smucCadastrarLivro_CadastrandoLivro_RM_INCLUIR_EXEMPLAR;
    lTransition := lState.NewOutgoingTransition('RM_EXCLUIR_EXEMPLAR');
    lTransition.SourceState := lState;
    lTransition.TargetState := lState;
    lTransition.AddTrigger('RM_EXCLUIR_EXEMPLAR');
    lTransition.AddEffect('Effect_ExcluirExemplar');
    lTransition := lState.NewOutgoingTransition('RM_CONCLUIR_CADASTRO');
    lTransition.SourceState := lState;
    lTransition.TargetState := lStateMachine.FindState('BuscandoLivro');
    lTransition.AddTrigger('RM_CONCLUIR_CADASTRO');
    lTransition.AddEffect('Effect_ConcluirCadastro');
    lTransition.XsdIn.XML := GetXSDIn_3226_smucCadastrarLivro_CadastrandoLivro_RM_CONCLUIR_CADASTRO;
    lTransition.XsdOut.XML := GetXSDOut_3226_smucCadastrarLivro_CadastrandoLivro_RM_CONCLUIR_CADASTRO;
  
  
end;

procedure RegisterModelMappings(piMetaModel: acMetaModel);
begin
   RegisterClassTickets1(piMetaModel){1 - 200};
   RegisterClassRelationTickets(piMetaModel);
   RegisterUseCases1(piMetaModel){1 - 100};
end;


end.
